//---------------------------------------------------------------------------


#pragma hdrstop
#include <vcl.h>
#include "OD_funkcije.h"
#include "OD_DM.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

TKorisnik *myTKorisnik=new TKorisnik;
//---------------------------------------------------------------------------
__fastcall TKorisnik::TKorisnik()
{
}

bool SnimiCDS(TDataSetProvider *dsp, TClientDataSet *cds, TDataSource *ds)
{
	//dsp->BeforeUpdateRecord = dspPravaBeforeUpdateRecord(this, cds, cds->Delta, dsp->UpdateMode, false);
	OleVariant MasterVar, OwnerData;
	int ErrCount=0;
	bool btSnimi=false;
	TTransactionDesc TD;

	  cds->CheckBrowseMode();

	  if (cds->ChangeCount > 0)
			MasterVar = cds->Delta;
	  else
			MasterVar.ChangeType(VT_NULL);

 try {

	if (!DM_OD->SC_OD->InTransaction)  {

	  TD.TransactionID = 1;
	  TD.IsolationLevel = 1;//Dbxpress::xilREADCOMMITTED;

	  DM_OD->SC_OD->StartTransaction(TD);

			 if(!MasterVar.IsNull()) {
					 MasterVar = dsp->ApplyUpdates(MasterVar,0,ErrCount);
					 if (ErrCount > 0) {
						throw Exception("Greska u snimanju!! Proverite da li ste definisali obavezna polja!!");
					 }
			 }

			 if (DM_OD->SC_OD->InTransaction) {
						if(ErrCount == 0) {
							DM_OD->SC_OD->Commit(TD);
							btSnimi = false;
						}
						else {
							DM_OD->SC_OD->Rollback(TD);
							btSnimi = true;
						}
			 }
	 }
 }
 catch(Exception &e) {
		if (DM_OD->SC_OD->InTransaction) DM_OD->SC_OD->Rollback(TD);
		ShowMessage("Dokument nije snimljen!! "+e.Message);
		btSnimi = true;
 }

 if(!MasterVar.IsNull()) cds->Reconcile(MasterVar);
 else {
			cds->Reconcile(MasterVar);
 }

 return btSnimi;
}
//---------------------------------------------------------------------------

bool Snimi_2CDS(TDataSetProvider *dspZ, TClientDataSet *cdsZ, TDataSource *dsZ, TDataSetProvider *dspS, TClientDataSet *cdsS, TDataSource *dsS)
{
 //if (DM_OD->SC_OD->InTransaction) DM_OD->SC_OD->Commit(TD); //ShowMessage("Transakcija u toku!");

	bool btSnimi=false;
	OleVariant MasterVar,DetailVar, OwnerData ;
	int ErrCount;
	TTransactionDesc TD;

    cdsZ->CheckBrowseMode();
    cdsS->CheckBrowseMode();

    if (cdsZ->ChangeCount > 0)
        MasterVar = cdsZ->Delta;
    else
        MasterVar.ChangeType(VT_NULL);

	  if (cdsS->ChangeCount > 0)
			DetailVar = cdsS->Delta;
	  else
			DetailVar.ChangeType(VT_NULL);

 try {

	if (!DM_OD->SC_OD->InTransaction)  {

	  TD.TransactionID = 1;
	  TD.IsolationLevel = 1;//Dbxpress::xilREADCOMMITTED;

	  DM_OD->SC_OD->StartTransaction(TD);

			try {
			 if(!MasterVar.IsNull()) {
					 MasterVar = dspZ->ApplyUpdates(MasterVar,0,ErrCount);
					 if (ErrCount > 0) {
						throw Exception("Greska prilikom snimanja zaglavlja!! ");
					 }
			 }
			}
			catch(EDatabaseError &e) {
				if (DM_OD->SC_OD->InTransaction) DM_OD->SC_OD->Rollback(TD);
				ShowMessage("Dokument nije snimljen!! Greska u zaglavlju dokumenta!!"+e.Message);
			}

			try {
			 if(!DetailVar.IsNull()) {
					 DetailVar = dspS->ApplyUpdates(DetailVar,0,ErrCount);
					 if (ErrCount > 0) {
						throw Exception("Greska prilikom snimanja stavki!! ");
					 }
			 }
			}
			catch(EDatabaseError &e) {
				if (DM_OD->SC_OD->InTransaction) DM_OD->SC_OD->Rollback(TD);
				ShowMessage("Dokument nije snimljen!! Greska u stavkama dokumenta!!"+e.Message);
			}
			if (DM_OD->SC_OD->InTransaction) {

						if(ErrCount == 0) {
							DM_OD->SC_OD->Commit(TD);
							btSnimi = false;
						}
						else {
							DM_OD->SC_OD->Rollback(TD);
							btSnimi = true;
						}
			}
	}
 }
 catch(EDatabaseError &e) {
		if (DM_OD->SC_OD->InTransaction) DM_OD->SC_OD->Rollback(TD);
		ShowMessage("Dokument nije snimljen!! "+e.Message);
		btSnimi = true;
 }

 if(!MasterVar.IsNull()) 			cdsZ->Reconcile(MasterVar);
 else if(!DetailVar.IsNull())   cdsS->Reconcile(DetailVar);
 else {
			cdsZ->Reconcile(MasterVar);
			cdsS->Reconcile(DetailVar);
 }

 return btSnimi;
}
//---------------------------------------------------------------------------



/*
	if (DM->SC1->InTransaction) ShowMessage("Transakcija u toku!");



 if(cdsZ->Fields->FindField("datumdpo")) {
  if(DM->cdsSystem->FieldByName("GODINA")->AsInteger != YearOf(cdsZ->FieldByName("datumdpo")->Value)) {
     ShowMessage("Godina je zatvorena !!!");
   //  Abort();
  }
 }

  if (cdsNovcano->FieldByName("sifra_komitenta")->AsInteger <= 0) {
     ShowMessage("A komitent ???");
     Abort();
  }

	OleVariant MasterVar,DetailVar, OwnerData ;
  int ErrCount;

    cdsZ->CheckBrowseMode();
    cdsS->CheckBrowseMode();

    if (cdsZ->ChangeCount > 0)
        MasterVar = cdsZ->Delta;
    else
        MasterVar.ChangeType(VT_NULL);

    if (cdsS->ChangeCount > 0)
        DetailVar = cdsS->Delta;
    else
        DetailVar.ChangeType(VT_NULL);

 try {

  if (!DM->SC1->InTransaction)  {

    TD.TransactionID = 1;
    TD.IsolationLevel = 1;//Dbxpress::xilREADCOMMITTED;

    DM->SC1->StartTransaction(TD);

        try {
         if(!MasterVar.IsNull()) {
               MasterVar = dspZ->ApplyUpdates(MasterVar,0,ErrCount);
					 if (ErrCount > 0) {
						throw Exception("Greska prilikom snimanja zaglavlja!! ");
					 }
         }
        }
        catch(EDatabaseError &e) {
           if (DM->SC1->InTransaction) DM->SC1->Rollback(TD);
           ShowMessage("Dokument nije snimljen!! Greska u zaglavlju dokumenta!!"+e.Message);
        }

        try {
         if(!DetailVar.IsNull()) {
               DetailVar = dspS->ApplyUpdates(DetailVar,0,ErrCount);
					 if (ErrCount > 0) {
						throw Exception("Greska prilikom snimanja stavki!! ");
					 }
			 }
			}
			catch(EDatabaseError &e) {
				if (DM->SC1->InTransaction) DM->SC1->Rollback(TD);
				ShowMessage("Dokument nije snimljen!! Greska u stavkama dokumenta!!"+e.Message);
			}

			if (DM->SC1->InTransaction) {

						if(ErrCount == 0) {
							DM->SC1->Commit(TD);
							btSnimi->Enabled = false;

							sqlBroj->Active = false;
							sqlBroj->ParamByName("idp")->AsInteger = cdsNovcano->FieldByName("idponude")->AsInteger;
							sqlBroj->Active = true;

							cdsNovcano->Edit();
							cdsNovcano->FieldByName("broj_ponude")->AsInteger = sqlBroj->FieldByName("broj_ponude")->AsInteger;
							cdsNovcano->Post();
						}
						else {
							DM->SC1->Rollback(TD);
							btSnimi->Enabled = true;
						}
			}
	 }
 }
 catch(EDatabaseError &e) {
		if (DM->SC1->InTransaction) DM->SC1->Rollback(TD);
		ShowMessage("Dokument nije snimljen!! "+e.Message);
		btSnimi->Enabled = true;
 }
 if(!MasterVar.IsNull()) cdsZ->Reconcile(MasterVar);
 else if(!DetailVar.IsNull())      cdsS->Reconcile(DetailVar);
 else {
			cdsZ->Reconcile(MasterVar);
			cdsS->Reconcile(DetailVar);
 }
*/