//---------------------------------------------------------------------------

#ifndef OD_HearsonH
#define OD_HearsonH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "BUS_osnovna_prazna.h"
#include "cxLookAndFeels.hpp"
#include "cxButtons.hpp"
#include "cxCalendar.hpp"
#include "cxClasses.hpp"
#include "cxContainer.hpp"
#include "cxControls.hpp"
#include "cxCustomData.hpp"
#include "cxData.hpp"
#include "cxDataStorage.hpp"
#include "cxDBData.hpp"
#include "cxDBEdit.hpp"
#include "cxDBLookupComboBox.hpp"
#include "cxDBLookupEdit.hpp"
#include "cxDropDownEdit.hpp"
#include "cxEdit.hpp"
#include "cxFilter.hpp"
#include "cxGraphics.hpp"
#include "cxGrid.hpp"
#include "cxGridCustomTableView.hpp"
#include "cxGridCustomView.hpp"
#include "cxGridDBTableView.hpp"
#include "cxGridLevel.hpp"
#include "cxGridTableView.hpp"
#include "cxLabel.hpp"
#include "cxLookAndFeelPainters.hpp"
#include "cxLookupEdit.hpp"
#include "cxMaskEdit.hpp"
#include "cxPC.hpp"
#include "cxSpinEdit.hpp"
#include "cxSplitter.hpp"
#include "cxStyles.hpp"
#include "cxTextEdit.hpp"
#include "cxTimeEdit.hpp"
#include <ActnList.hpp>
#include <DB.hpp>
#include <DBClient.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <FMTBcd.hpp>
#include <Menus.hpp>
#include <Provider.hpp>
#include <SqlExpr.hpp>
#include "frxClass.hpp"
#include "frxDBSet.hpp"
#include "cxGridChartView.hpp"
#include "cxGridDBChartView.hpp"
#include "cxDateUtils.hpp"
#include "cxNavigator.hpp"
#include "cxPCdxBarPopupMenu.hpp"
#include "dxCore.hpp"
#include "dxSkinBlack.hpp"
#include "dxSkinBlue.hpp"
#include "dxSkinDevExpressDarkStyle.hpp"
#include "dxSkinDevExpressStyle.hpp"
#include "dxSkinFoggy.hpp"
#include "dxSkinOffice2010Black.hpp"
#include "dxSkinOffice2010Blue.hpp"
#include "dxSkinOffice2010Silver.hpp"
#include "dxSkinsCore.hpp"
#include "dxSkinscxPCPainter.hpp"
#include "dxSkinSevenClassic.hpp"
#include "dxSkinVS2010.hpp"
#include <System.Actions.hpp>
#include <Vcl.ComCtrls.hpp>
//---------------------------------------------------------------------------
class TfrmHearson : public TfmOsnovna_prazna
{
__published:	// IDE-managed Components
	TActionList *OsnovneAkcije;
	TAction *PretragaArtikla;
	TAction *PretragaKomitenta;
	TAction *Izlaz;
	TAction *NoviDokument;
	TAction *SnimiDokument;
	TAction *StampaDokumenta;
	TAction *Action1;
	TcxLookAndFeelController *cxLookAndFeel;
	TPopupMenu *PM_izmena;
	TMenuItem *Izmeni1;
	TMenuItem *Obrisi1;
	TMenuItem *Export1;
	TMenuItem *Excel1;
	TMenuItem *Html1;
	TMenuItem *XT1;
	TSaveDialog *SaveDialog1;
	TSQLStoredProc *sp_processing;
	TSQLDataSet *dsetZaglavlje;
	TDataSetProvider *dspZaglavlje;
	TClientDataSet *cdsZaglavlje;
	TDataSource *dsZaglavlje;
	TSQLQuery *sqlObrisi;
	TSQLDataSet *dsetHearsonStavke;
	TDataSetProvider *dspHearsonStavke;
	TClientDataSet *cdsHearsonStavke;
	TDataSource *dsHearsonStavke;
	TSQLQuery *sqlParametri;
	TSQLDataSet *dsetStavke;
	TDataSetProvider *dspStavke;
	TClientDataSet *cdsStavke;
	TDataSource *dsStavke;
	TSQLQuery *qDelete;
	TcxPageControl *cxPC;
	TcxTabSheet *cxTabUnos;
	TPanel *Panel1;
	TPanel *Panel2;
	TcxButton *btNoviDoc;
	TcxButton *btSnimi;
	TcxButton *btStampaj;
	TcxButton *btFunkcije;
	TcxLabel *cxLabel6;
	TcxPageControl *cxPageControl2;
	TcxTabSheet *cxTabPolja;
	TPanel *Panel5;
	TcxLabel *cxLabel1;
	TcxDBDateEdit *cxDatum;
	TcxLabel *cxLabel2;
	TcxLabel *cxLabel4;
	TcxLabel *cxLabel8;
	TcxDBTextEdit *edtPritisakStart;
	TcxLabel *cxLabel11;
	TcxDBTextEdit *edtPritisakStop;
	TcxTabSheet *cxTabPregled;
	TPanel *Panel3;
	TcxDateEdit *cxOdDatuma;
	TcxDateEdit *cxDoDatuma;
	TcxLabel *cxLabel9;
	TcxLabel *cxLabel10;
	TcxButton *cxButton1;
	TcxButton *btnPregled;
	TcxGrid *cxGrid1;
	TcxGridDBTableView *cxPregledZaglavlje;
	TcxGridLevel *cxGrid1Level1;
	TcxSplitter *cxSplitter1;
	TcxGrid *cxGrid2;
	TcxGridDBTableView *cxPregledStavke;
	TcxGridLevel *cxGridLevel1;
	TSQLQuery *qDeleteMerenje;
	TIntegerField *cdsHearsonStavkeID;
	TIntegerField *cdsHearsonStavkeIDZ;
	TIntegerField *cdsHearsonStavkeBROJ_TACNE;
	TFloatField *cdsHearsonStavkeTEZINA_TACNE;
	TFloatField *cdsHearsonStavkeTEZINA_BRUTO;
	TFloatField *cdsHearsonStavkeDUVAN_PRE_SUS;
	TFloatField *cdsHearsonStavkeTACNA_POSLE_SUS;
	TIntegerField *cdsHearsonStavkeBROJ_KUTIJE;
	TStringField *cdsHearsonStavkeGRADE;
	TSQLTimeStampField *cdsHearsonStavkeVREME;
	TIntegerField *cdsHearsonStavkeSIFRA_RADNIKA;
	TIntegerField *cdsHearsonStavkeRADNIK_CHANGE;
	TSQLTimeStampField *cdsHearsonStavkeVREME_CHANGE;
	TFloatField *cdsHearsonStavkeVLAGA_SADRZAJ;
	TFloatField *cdsHearsonStavkeVLAGA_H;
	TFloatField *cdsHearsonStavkeVLAGA_M;
	TFloatField *cdsHearsonStavkeVLAGA_TARGET;
	TFloatField *cdsHearsonStavkeUCL;
	TFloatField *cdsHearsonStavkeLCL;
	TcxDBTextEdit *edtTempStop;
	TcxDBTextEdit *edtTempStart;
	TcxLabel *cxLabel7;
	TcxLabel *cxLabel13;
	TSQLStoredProc *sp_lab_merenja;
	TcxStyleRepository *cxStyle;
	TcxStyle *cxStyleZuta;
	TcxStyle *cxStyleZelena;
	TcxStyle *cxStylePlava;
	TcxStyle *cxStylePink;
	TcxStyle *cxStyleBraon;
	TSQLDataSet *dsetHearson;
	TDataSetProvider *dspHearson;
	TClientDataSet *cdsHearson;
	TDataSource *dsHearson;
	TIntegerField *cdsHearsonID;
	TIntegerField *cdsHearsonSIFRA_RADNIKA;
	TDateField *cdsHearsonDATUM;
	TSQLTimeStampField *cdsHearsonDATUMRADA;
	TIntegerField *cdsHearsonRADNIK_CHANGE;
	TSQLTimeStampField *cdsHearsonVREME_CHANGE;
	TSQLTimeStampField *cdsHearsonMERENJE_START;
	TSQLTimeStampField *cdsHearsonMERENJE_STOP;
	TFloatField *cdsHearsonPRITISAK_START;
	TFloatField *cdsHearsonPRITISAK_STOP;
	TFloatField *cdsHearsonTEMP_START;
	TFloatField *cdsHearsonTEMP_STOP;
	TIntegerField *cdsZaglavljeID;
	TIntegerField *cdsZaglavljeSIFRA_RADNIKA;
	TDateField *cdsZaglavljeDATUM;
	TSQLTimeStampField *cdsZaglavljeDATUMRADA;
	TIntegerField *cdsZaglavljeRADNIK_CHANGE;
	TSQLTimeStampField *cdsZaglavljeVREME_CHANGE;
	TSQLTimeStampField *cdsZaglavljeMERENJE_START;
	TSQLTimeStampField *cdsZaglavljeMERENJE_STOP;
	TFloatField *cdsZaglavljePRITISAK_START;
	TFloatField *cdsZaglavljePRITISAK_STOP;
	TFloatField *cdsZaglavljeTEMP_START;
	TFloatField *cdsZaglavljeTEMP_STOP;
	TIntegerField *cdsStavkeID;
	TIntegerField *cdsStavkeIDZ;
	TIntegerField *cdsStavkeBROJ_TACNE;
	TFloatField *cdsStavkeTEZINA_TACNE;
	TFloatField *cdsStavkeTEZINA_BRUTO;
	TFloatField *cdsStavkeDUVAN_PRE_SUS;
	TFloatField *cdsStavkeTACNA_POSLE_SUS;
	TIntegerField *cdsStavkeBROJ_KUTIJE;
	TStringField *cdsStavkeGRADE;
	TSQLTimeStampField *cdsStavkeVREME;
	TIntegerField *cdsStavkeSIFRA_RADNIKA;
	TIntegerField *cdsStavkeRADNIK_CHANGE;
	TSQLTimeStampField *cdsStavkeVREME_CHANGE;
	TFloatField *cdsStavkeVLAGA_SADRZAJ;
	TFloatField *cdsStavkeVLAGA_H;
	TFloatField *cdsStavkeVLAGA_M;
	TFloatField *cdsStavkeVLAGA_TARGET;
	TFloatField *cdsStavkeUCL;
	TFloatField *cdsStavkeLCL;
	TcxGridDBColumn *cxPregledZaglavljeID;
	TcxGridDBColumn *cxPregledZaglavljeSIFRA_RADNIKA;
	TcxGridDBColumn *cxPregledZaglavljeDATUM;
	TcxGridDBColumn *cxPregledZaglavljeDATUMRADA;
	TcxGridDBColumn *cxPregledZaglavljeRADNIK_CHANGE;
	TcxGridDBColumn *cxPregledZaglavljeVREME_CHANGE;
	TcxGridDBColumn *cxPregledZaglavljeMERENJE_START;
	TcxGridDBColumn *cxPregledZaglavljeMERENJE_STOP;
	TcxGridDBColumn *cxPregledZaglavljePRITISAK_START;
	TcxGridDBColumn *cxPregledZaglavljePRITISAK_STOP;
	TcxGridDBColumn *cxPregledZaglavljeTEMP_START;
	TcxGridDBColumn *cxPregledZaglavljeTEMP_STOP;
	TcxGridDBColumn *cxPregledStavkeID;
	TcxGridDBColumn *cxPregledStavkeIDZ;
	TcxGridDBColumn *cxPregledStavkeBROJ_TACNE;
	TcxGridDBColumn *cxPregledStavkeTEZINA_TACNE;
	TcxGridDBColumn *cxPregledStavkeTEZINA_BRUTO;
	TcxGridDBColumn *cxPregledStavkeDUVAN_PRE_SUS;
	TcxGridDBColumn *cxPregledStavkeTACNA_POSLE_SUS;
	TcxGridDBColumn *cxPregledStavkeBROJ_KUTIJE;
	TcxGridDBColumn *cxPregledStavkeGRADE;
	TcxGridDBColumn *cxPregledStavkeVREME;
	TcxGridDBColumn *cxPregledStavkeSIFRA_RADNIKA;
	TcxGridDBColumn *cxPregledStavkeRADNIK_CHANGE;
	TcxGridDBColumn *cxPregledStavkeVREME_CHANGE;
	TcxGridDBColumn *cxPregledStavkeVLAGA_SADRZAJ;
	TcxGridDBColumn *cxPregledStavkeVLAGA_H;
	TcxGridDBColumn *cxPregledStavkeVLAGA_M;
	TcxGridDBColumn *cxPregledStavkeVLAGA_TARGET;
	TcxGridDBColumn *cxPregledStavkeUCL;
	TcxGridDBColumn *cxPregledStavkeLCL;
	TfrxReport *frxReport1;
	TfrxDBDataset *frxDBStampaHearson;
	TfrxDBDataset *frxDBHearsonStavke;
	TSQLDataSet *sqlStampaHearson;
	TDataSetProvider *dspStampaHearson;
	TClientDataSet *cdsStampaHearson;
	TIntegerField *IntegerField1;
	TIntegerField *IntegerField2;
	TDateField *DateField1;
	TSQLTimeStampField *SQLTimeStampField1;
	TIntegerField *IntegerField3;
	TSQLTimeStampField *SQLTimeStampField2;
	TSQLTimeStampField *SQLTimeStampField3;
	TSQLTimeStampField *SQLTimeStampField4;
	TFloatField *FloatField1;
	TFloatField *FloatField2;
	TFloatField *FloatField3;
	TFloatField *FloatField4;
	TDataSource *dsStampaHearson;
	TDataSource *dsStampaHearsonStavke;
	TClientDataSet *cdsStampaHearsonStavke;
	TIntegerField *IntegerField4;
	TIntegerField *IntegerField5;
	TIntegerField *IntegerField6;
	TFloatField *FloatField5;
	TFloatField *FloatField6;
	TFloatField *FloatField7;
	TFloatField *FloatField8;
	TIntegerField *IntegerField7;
	TStringField *StringField1;
	TSQLTimeStampField *SQLTimeStampField5;
	TIntegerField *IntegerField8;
	TIntegerField *IntegerField9;
	TSQLTimeStampField *SQLTimeStampField6;
	TFloatField *FloatField9;
	TFloatField *FloatField10;
	TFloatField *FloatField11;
	TFloatField *FloatField12;
	TFloatField *FloatField13;
	TFloatField *FloatField14;
	TDataSetProvider *dspStampaHearsonStavke;
	TSQLDataSet *sqlStampaHearsonStavke;
	TcxLabel *cxLabel3;
	TcxDBTextEdit *edtVlagaStart;
	TcxLabel *cxLabel5;
	TcxDBTextEdit *edtVlagaStop;
	TFloatField *cdsHearsonVLAGA_START;
	TFloatField *cdsHearsonVLAGA_STOP;
	TFloatField *cdsZaglavljeVLAGA_START;
	TFloatField *cdsZaglavljeVLAGA_STOP;
	TFloatField *cdsStampaHearsonVLAGA_START;
	TFloatField *cdsStampaHearsonVLAGA_STOP;
	TcxGridDBColumn *cxPregledZaglavljeVLAGA_START;
	TcxGridDBColumn *cxPregledZaglavljeVLAGA_STOP;
	TcxDBDateEdit *deStart;
	TcxDBDateEdit *deStop;
	TSQLQuery *qTacne;
	TStringField *cdsHearsonIDSMENE;
	TFloatField *cdsHearsonPROTOK_V;
	TSQLQuery *qSmene;
	TStringField *qSmeneID;
	TStringField *qSmeneNAZIV;
	TIntegerField *qSmeneSIFRA_RADNIKA;
	TSQLTimeStampField *qSmeneVREME;
	TDataSource *dsSmene;
	TcxLabel *cxLabel14;
	TcxDBTextEdit *cxDBTextEdit1;
	TStringField *cdsHearsonStavkeIDSMENE;
	TcxPageControl *cxPageControl1;
	TcxTabSheet *cxTabSheet;
	TcxGrid *grdStavke;
	TcxGridDBTableView *cxStavke;
	TcxGridDBColumn *cxStavkeID;
	TcxGridDBColumn *cxStavkeIDZ;
	TcxGridDBColumn *cxStavkeBROJ_TACNE;
	TcxGridDBColumn *cxStavkeTEZINA_TACNE;
	TcxGridDBColumn *cxStavkeTEZINA_BRUTO;
	TcxGridDBColumn *cxStavkeDUVAN_PRE_SUS;
	TcxGridDBColumn *cxStavkeTACNA_POSLE_SUS;
	TcxGridDBColumn *cxStavkeBROJ_KUTIJE;
	TcxGridDBColumn *cxStavkeGRADE;
	TcxGridDBColumn *cxStavkeVREME;
	TcxGridDBColumn *cxStavkeSIFRA_RADNIKA;
	TcxGridDBColumn *cxStavkeRADNIK_CHANGE;
	TcxGridDBColumn *cxStavkeVREME_CHANGE;
	TcxGridDBColumn *cxStavkeVLAGA_SADRZAJ;
	TcxGridDBColumn *cxStavkeVLAGA_H;
	TcxGridDBColumn *cxStavkeVLAGA_M;
	TcxGridDBColumn *cxStavkeVLAGA_TARGET;
	TcxGridDBColumn *cxStavkeUCL;
	TcxGridDBColumn *cxStavkeLCL;
	TcxGridDBColumn *cxStavkeIDSMENE;
	TcxGridLevel *grdStavkeLevel1;
	TIntegerField *cdsHearsonStavkeIDBLENDA;
	TcxGridDBColumn *cxStavkeIDBLENDA;
	TStringField *cdsStavkeIDSMENE;
	TIntegerField *cdsStavkeIDBLENDA;
	TStringField *cdsStavkeSMENA;
	TStringField *cdsStavkeOZNAKA_BLENDA;
	TcxGridDBColumn *cxPregledStavkeIDSMENE;
	TcxGridDBColumn *cxPregledStavkeIDBLENDA;
	TcxGridDBColumn *cxPregledStavkeSMENA;
	TcxGridDBColumn *cxPregledStavkeOZNAKA_BLENDA;
	TStringField *cdsHearsonStavkeNAPOMENA;
	TcxGridDBColumn *cxStavkeNAPOMENA;
	TStringField *cdsStavkeNAPOMENA;
	TcxGridDBColumn *cxPregledStavkeNAPOMENA;
	TSQLDataSet *sqlVrstaMerenja;
	TDataSetProvider *dspVrstaMerenja;
	TClientDataSet *cdsVrstaMerenja;
	TDataSource *dsVrstaMerenja;
	TIntegerField *cdsHearsonID_VRSTE_MER;
	TcxDBLookupComboBox *cxDBLookupComboBox1;
	TcxLabel *cxLabel12;
	TFloatField *cdsZaglavljePROTOK_V;
	TIntegerField *cdsZaglavljeID_VRSTE_MER;
	TStringField *cdsZaglavljeMETODA;
	TcxGridDBColumn *cxPregledZaglavljePROTOK_V;
	TcxGridDBColumn *cxPregledZaglavljeID_VRSTE_MER;
	TcxGridDBColumn *cxPregledZaglavljeMETODA;
	TcxStyleRepository *cxStyleRepository1;
	TcxStyle *cxStyle1;
	TcxTabSheet *cxTabSheet1;
	TcxGridDBTableView *cxGrid3DBTableView1;
	TcxGrid *cxGrid3;
	TcxGridLevel *cxGrid3Level1;
	TcxGridDBChartView *cxGrid3DBChartView1;
	TcxGridDBChartSeries *cxGrid3DBChartView1Series1;
	TcxGridDBChartSeries *cxGrid3DBChartView1Series2;
	TcxGridDBChartDataGroup *cxGrid3DBChartView1DataGroup1;
	void __fastcall cdsHearsonNewRecord(TDataSet *DataSet);
	void __fastcall cdsHearsonStavkeNewRecord(TDataSet *DataSet);
	void __fastcall btNoviDocClick(TObject *Sender);
	void __fastcall btSnimiClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall cdsHearsonStavkeAfterPost(TDataSet *DataSet);
	void __fastcall cdsHearsonStavkeAfterDelete(TDataSet *DataSet);
	void __fastcall btnPregledClick(TObject *Sender);
	void __fastcall cdsZaglavljeAfterScroll(TDataSet *DataSet);
	void __fastcall Izmeni1Click(TObject *Sender);
	void __fastcall Obrisi1Click(TObject *Sender);
	void __fastcall btStampajClick(TObject *Sender);
	void __fastcall deStartKeyPress(TObject *Sender, wchar_t &Key);
	void __fastcall cdsHearsonStavkeBeforeScroll(TDataSet *DataSet);
	void __fastcall cdsHearsonStavkeTEZINA_BRUTOChange(TField *Sender);
	void __fastcall cdsHearsonStavkeTACNA_POSLE_SUSChange(TField *Sender);
	void __fastcall cdsHearsonStavkeDUVAN_PRE_SUSChange(TField *Sender);
	void __fastcall cxStavkeEditKeyDown(TcxCustomGridTableView *Sender, TcxCustomGridTableItem *AItem, TcxCustomEdit *AEdit,
			  WORD &Key, TShiftState Shift);
	void __fastcall cdsHearsonID_VRSTE_MERChange(TField *Sender);
private:	// User declarations
	 double tezina_tacne, target, tezina_duvana;
	 AnsiString grade;
public:		// User declarations
	__fastcall TfrmHearson(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmHearson *frmHearson;
//---------------------------------------------------------------------------
#endif
