//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OD_Primese.h"
#include "OD_DM.h"
#include "OD_funkcije.h"
#include "OD_DmPretraga.h"
#include "OD_PretragaPodataka.h"
#include "fmMessageRed.h"
#include "fmMessageYellow.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cxButtons"
#pragma link "cxCalendar"
#pragma link "cxClasses"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxCustomData"
#pragma link "cxData"
#pragma link "cxDataStorage"
#pragma link "cxDBData"
#pragma link "cxDBEdit"
#pragma link "cxDropDownEdit"
#pragma link "cxEdit"
#pragma link "cxFilter"
#pragma link "cxGraphics"
#pragma link "cxGrid"
#pragma link "cxGridCustomTableView"
#pragma link "cxGridCustomView"
#pragma link "cxGridDBTableView"
#pragma link "cxGridLevel"
#pragma link "cxGridTableView"
#pragma link "cxLabel"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxMaskEdit"
#pragma link "cxPC"
#pragma link "cxStyles"
#pragma link "cxTextEdit"
#pragma link "OD_OsnovnaPrazna"
#pragma link "cxDBLookupComboBox"
#pragma link "cxDBLookupEdit"
#pragma link "cxLookupEdit"
#pragma link "cxSplitter"
#pragma link "cxSpinEdit"
#pragma link "cxTimeEdit"
#pragma link "cxDateUtils"
#pragma link "cxNavigator"
#pragma link "cxPCdxBarPopupMenu"
#pragma link "dxCore"
#pragma link "dxSkinBlack"
#pragma link "dxSkinBlue"
#pragma link "dxSkinDevExpressDarkStyle"
#pragma link "dxSkinDevExpressStyle"
#pragma link "dxSkinFoggy"
#pragma link "dxSkinOffice2010Black"
#pragma link "dxSkinOffice2010Blue"
#pragma link "dxSkinOffice2010Silver"
#pragma link "dxSkinsCore"
#pragma link "dxSkinscxPCPainter"
#pragma link "dxSkinSevenClassic"
#pragma link "dxSkinVS2010"
#pragma resource "*.dfm"
TOD_EvidencijaPrimesa *OD_EvidencijaPrimesa;
extern TKorisnik *myTKorisnik;
//---------------------------------------------------------------------------
__fastcall TOD_EvidencijaPrimesa::TOD_EvidencijaPrimesa(TComponent* Owner)
	: TfmOsnovnaPrazna(Owner)
{
	cxOdDatuma->Date = Date();
	cxDoDatuma->Date = Date();

	pravoDelete = DM_OD->cdsProveraSelectPRAVO_DELETE->AsInteger;
	pravoInsert = DM_OD->cdsProveraSelectPRAVO_INSERT->AsInteger;
	pravoUpdate = DM_OD->cdsProveraSelectPRAVO_UPDATE->AsInteger;
}
//---------------------------------------------------------------------------
void __fastcall TOD_EvidencijaPrimesa::btNoviDocClick(TObject *Sender)
{
	if (pravoInsert) {
		try {
			cdsProcessing->Active = false;
			dsetProcessing->ParamByName("id")->AsInteger = -1;
			cdsProcessing->Active = true;

			cdsStavkeMerenja->Active = false;
			dsetStavkeMerenja->ParamByName("idp")->AsInteger = -1;
			cdsStavkeMerenja->Active = true;

			cdsProcessing->Append();

			sqlParametri->Active = false;
			sqlParametri->ParamByName("tip")->AsString = "PRIMESE";
			sqlParametri->Active = true;

			sqlParametri->First();

			while(!sqlParametri->Eof) {

				cdsStavkeMerenja->Append();
				cdsStavkeMerenja->FieldByName("idprocesa")->AsInteger = cdsProcessing->FieldByName("id")->AsInteger;
				cdsStavkeMerenja->FieldByName("parametar1")->AsString = sqlParametri->FieldByName("id")->AsString;
				cdsStavkeMerenja->FieldByName("opis_parametra1")->AsString = sqlParametri->FieldByName("naziv")->AsString;
				cdsStavkeMerenja->Post();

				sqlParametri->Next();
		 }

			btSnimi->Enabled = true;
		}
		catch (Exception &e)
		{
		  ShowMessage("Greska!! "+e.Message);
		}
	}else {
		ShowMessage("Nemate prava da dodate podatke!");
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::cdsStavkeMerenjaNewRecord(TDataSet *DataSet)

{
	sp_lab_merenja->Prepared = true;
	sp_lab_merenja->ExecProc();
	cdsStavkeMerenja->FieldByName("id")->AsInteger = sp_lab_merenja->ParamByName("ID")->Value;
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::cdsProcessingNewRecord(TDataSet *DataSet)
{
	sp_processing->Prepared = true;
	sp_processing->ExecProc();
	cdsProcessing->FieldByName("id")->AsInteger = sp_processing->ParamByName("ID")->Value;
	cdsProcessing->FieldByName("datum")->Value = Date();
	cdsProcessing->FieldByName("vreme")->Value = Time();
	cdsProcessing->FieldByName("idsmene")->AsString = "I";
	cdsProcessing->FieldByName("sifra_radnika")->AsInteger = myTKorisnik->sifra_usera;
	cdsProcessing->FieldByName("vlaga")->AsFloat = 0;
	cdsProcessing->FieldByName("temperatura")->AsFloat = 0;
	cdsProcessing->FieldByName("kolicina")->AsFloat = 0;
	cdsProcessing->FieldByName("sugar")->AsFloat = 0;
	cdsProcessing->FieldByName("nicotin")->AsFloat = 0;
	cdsProcessing->FieldByName("vrsta_transakcije")->AsInteger = 5;    // STRANE PRIMESE  5

	cdsProcessing->FieldByName("idgrade")->AsString = OldIdGrade;
	cdsProcessing->FieldByName("Grade")->AsString = OldGrade;
	cdsProcessing->FieldByName("idlist")->AsString = OldIdList;
	cdsProcessing->FieldByName("status")->AsString = "N";
	//cdsProcessing->FieldByName("id_uzorka")->AsString = OldIdUzorka;
	cdsProcessing->FieldByName("idlaboranta")->AsString = OldIdLaborant;
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::cdsProcessingAfterPost(TDataSet *DataSet)
{
	OldDatum = cdsProcessing->FieldByName("datum")->AsDateTime;

	OldSifraRadnika = cdsProcessing->FieldByName("sifra_radnika")->AsInteger;
	OldIdLaborant = cdsProcessing->FieldByName("idlaboranta")->AsInteger;
	OldRunday = cdsProcessing->FieldByName("runday")->AsInteger;
	OldIdBlend = cdsProcessing->FieldByName("idblend")->AsInteger;
	OldTransakcija = cdsProcessing->FieldByName("vrsta_transakcije")->AsInteger;

	OldGrade = cdsProcessing->FieldByName("grade")->AsString;
	OldIdGrade = cdsProcessing->FieldByName("idgrade")->AsString;
	OldBatch = cdsProcessing->FieldByName("batch_no")->AsString;
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::btSnimiClick(TObject *Sender)
{
	btSnimi->Enabled = Snimi_2CDS(dspProcessing, cdsProcessing, dsProcessing, dspStavkeMerenja, cdsStavkeMerenja, dsStavkeMerenja);
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::cxKlasaKeyPress(TObject *Sender, wchar_t &Key)

{
	AnsiString naziv;

	if(Key == VK_RETURN)
	{
		  naziv = cxKlasa->Text;

		  OD_DM_Pretraga->cdsGrade->Filter = "";
		  OD_DM_Pretraga->cdsGrade->Filtered = false;
		  OD_DM_Pretraga->cdsGrade->Active = false;
		  OD_DM_Pretraga->dsetGrade->ParamByName("opis")->AsString = UpperCase(naziv);
		  OD_DM_Pretraga->cdsGrade->Active = true;

		  if ( OD_DM_Pretraga->cdsGrade->RecordCount > 1)
       {
				TOD_Osnovna_pretrage *OD_Osnovna_pretrage = new TOD_Osnovna_pretrage(OD_DM_Pretraga->dsetGrade, OD_DM_Pretraga->dsGrade, "ID","NAZIV", this);
				OD_Osnovna_pretrage->WindowState = wsNormal;

				if(OD_Osnovna_pretrage->ShowModal() == mrOk) {
					 cdsProcessing->Edit();
					 cdsProcessing->FieldByName("IDGRADE")->AsString   = OD_DM_Pretraga->cdsGrade->FieldByName("ID")->AsString;
					 cdsProcessing->FieldByName("GRADE")->AsString = OD_DM_Pretraga->cdsGrade->FieldByName("NAZIV")->AsString;
					 cdsProcessing->Post();

					 cxSmena->SetFocus();
				}

				delete OD_Osnovna_pretrage;
		  }
		  else if (OD_DM_Pretraga->cdsGrade->RecordCount == 1) {
					cdsProcessing->Edit();
					cdsProcessing->FieldByName("IDGRADE")->AsString   = OD_DM_Pretraga->cdsGrade->FieldByName("ID")->AsString;
					cdsProcessing->FieldByName("GRADE")->AsString = OD_DM_Pretraga->cdsGrade->FieldByName("NAZIV")->AsString;
					cdsProcessing->Post();

					cxSmena->SetFocus();
		  }
		  else ShowMessage("Ne postoji PODATAK koji sadrzi u svom nazivu tekst: "+naziv);
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::cxSmenaKeyPress(TObject *Sender, wchar_t &Key)

{
	AnsiString naziv;

	if(Key == VK_RETURN)
	{
		  naziv = cxSmena->Text;

		  OD_DM_Pretraga->cdsSmene->Filter = "";
		  OD_DM_Pretraga->cdsSmene->Filtered = false;
		  OD_DM_Pretraga->cdsSmene->Active = false;
		  OD_DM_Pretraga->dsetSmene->ParamByName("opis")->AsString = UpperCase(naziv);
		  OD_DM_Pretraga->cdsSmene->Active = true;

		  if ( OD_DM_Pretraga->cdsSmene->RecordCount > 1)
		  {
				TOD_Osnovna_pretrage *OD_Osnovna_pretrage = new TOD_Osnovna_pretrage(OD_DM_Pretraga->dsetSmene, OD_DM_Pretraga->dsSmene, "ID","NAZIV", this);
				OD_Osnovna_pretrage->WindowState = wsNormal;

				if(OD_Osnovna_pretrage->ShowModal() == mrOk) {
					 cdsProcessing->Edit();
					 cdsProcessing->FieldByName("IDSMENE")->AsString   = OD_DM_Pretraga->cdsSmene->FieldByName("ID")->AsString;
					 cdsProcessing->FieldByName("SMENA")->AsString = OD_DM_Pretraga->cdsSmene->FieldByName("NAZIV")->AsString;
					 cdsProcessing->Post();

					 cxM_uzorka->SetFocus();
					 //cxStavkePrimesa->Focus();
					 //cxStavkePrimesaKOLICINA->FocusWithSelection();
				}

				delete OD_Osnovna_pretrage;
		  }
		  else if (OD_DM_Pretraga->cdsSmene->RecordCount == 1) {
					cdsProcessing->Edit();
					cdsProcessing->FieldByName("IDSMENE")->AsString   = OD_DM_Pretraga->cdsSmene->FieldByName("ID")->AsString;
					cdsProcessing->FieldByName("SMENA")->AsString = OD_DM_Pretraga->cdsSmene->FieldByName("NAZIV")->AsString;
					cdsProcessing->Post();

              cxM_uzorka->SetFocus();
					//cxStavkePrimesa->Focus();
					//cxStavkePrimesaKOLICINA->FocusWithSelection();
		  }
		  else ShowMessage("Ne postoji PODATAK koji sadrzi u svom nazivu tekst: "+naziv);
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::btnPregledClick(TObject *Sender)
{
	cdsZaglavlje->Active = false;
	dsetZaglavlje->ParamByName("od_datuma")->Value = cxOdDatuma->Date;
	dsetZaglavlje->ParamByName("do_datuma")->Value = cxDoDatuma->Date;
	dsetZaglavlje->ParamByName("id_transakcije")->AsInteger = 5;
	cdsZaglavlje->Active = true;
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::cdsZaglavljeAfterScroll(TDataSet *DataSet)

{
	cdsStavke->Active = false;
	dsetStavke->ParamByName("idp")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
	cdsStavke->Active = true;
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::cxButton3Click(TObject *Sender)
{
		cdsStavkeMerenja->First();

		while(!cdsStavkeMerenja->IsEmpty()) {
			 cdsStavkeMerenja->Delete();
     }

		sqlParametri->Active = false;
		sqlParametri->ParamByName("tip")->AsString = "PRIMESE";
		sqlParametri->Active = true;

		sqlParametri->First();

		while(!sqlParametri->Eof) {

			cdsStavkeMerenja->Append();
			cdsStavkeMerenja->FieldByName("idprocesa")->AsInteger = cdsProcessing->FieldByName("id")->AsInteger;
			cdsStavkeMerenja->FieldByName("parametar1")->AsString = sqlParametri->FieldByName("id")->AsString;
			cdsStavkeMerenja->FieldByName("opis_parametra1")->AsString = sqlParametri->FieldByName("naziv")->AsString;
			cdsStavkeMerenja->Post();

			sqlParametri->Next();
		}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::cxDatumKeyPress(TObject *Sender, wchar_t &Key)

{
	if(Key == VK_RETURN)	cxVreme->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::cxVremeKeyPress(TObject *Sender, wchar_t &Key)

{
	if(Key == VK_RETURN)	cxKlasa->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::cxTipDuvanaKeyPress(TObject *Sender, wchar_t &Key)

{
	if(Key == VK_RETURN)	cxDatum->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::Izmeni1Click(TObject *Sender)
{
	if (pravoUpdate) {
		cdsProcessing->Active = false;
		dsetProcessing->ParamByName("id")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
		cdsProcessing->Active = true;

		cdsStavkeMerenja->Active = false;
		dsetStavkeMerenja->ParamByName("idp")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
		cdsStavkeMerenja->Active = true;

		cxPC->ActivePage = cxTabUnos;
		btSnimi->Enabled = true;
	}else {
		ShowMessage("Nemate prava da menjate podatke!");
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::Obrisi1Click(TObject *Sender)
{
if (pravoDelete) {
     TTransactionDesc TD;
     int greska;
    
    try {
    
    	TD.TransactionID = 1;
    	TD.IsolationLevel = 0;// xilREADCOMMITTED;  //xilREADCOMMITTED
    
    	if (!DM_OD->SC_OD->InTransaction)  {
    
    	  DM_OD->SC_OD->StartTransaction(TD);
    
       if(MessageBoxA(Handle,"Da li ste sigurni da zelite da nastavite?", "Brisanje ", MB_YESNO) == IDYES)
    		{
    			 qDeleteMerenje->ParamByName("id")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
    			 qDeleteMerenje->ExecSQL();
    
    			 qDelete->ParamByName("id")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
    			 qDelete->ExecSQL();
    
    			 if (greska <= 0) btnPregled->Click();
    	 }
    
    	  if (DM_OD->SC_OD->InTransaction) DM_OD->SC_OD->Commit(TD);
      }
    }
    catch(Exception &e) {
      if (DM_OD->SC_OD->InTransaction) DM_OD->SC_OD->Rollback(TD);
	  ShowMessage("Greska: "+e.Message);
    }    
}                                           else {
		ShowMessage("Nemate prava da brisete podatke!");
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::cxM_uzorkaKeyPress(TObject *Sender, wchar_t &Key)
{
	AnsiString naziv;

	if(Key == VK_RETURN)
	{
		  naziv = cxM_uzorka->Text;

		  OD_DM_Pretraga->cds_MUzorka->Filter = "";
		  OD_DM_Pretraga->cds_MUzorka->Filtered = false;
		  OD_DM_Pretraga->cds_MUzorka->Active = false;
		  OD_DM_Pretraga->dset_MUzorka->ParamByName("opis")->AsString = UpperCase(naziv.SubString(1,10));
		  OD_DM_Pretraga->cds_MUzorka->Active = true;

		  if ( OD_DM_Pretraga->cds_MUzorka->RecordCount > 1)
       {
				TOD_Osnovna_pretrage *OD_Osnovna_pretrage = new TOD_Osnovna_pretrage(OD_DM_Pretraga->dset_MUzorka, OD_DM_Pretraga->ds_MUzorka, "ID","NAZIV", this);
				OD_Osnovna_pretrage->WindowState = wsNormal;

				if(OD_Osnovna_pretrage->ShowModal() == mrOk) {
					 cdsProcessing->Edit();
					 cdsProcessing->FieldByName("ID_UZORKA")->AsString   = OD_DM_Pretraga->cds_MUzorka->FieldByName("ID")->AsString;
					 cdsProcessing->FieldByName("MESTO_UZORKA")->AsString = OD_DM_Pretraga->cds_MUzorka->FieldByName("NAZIV")->AsString;
					 cdsProcessing->Post();

					 cdsStavkeMerenja->First();
					 grdStavkePrimesa->SetFocus();
					 cxStavkePrimesaKOLICINA->FocusWithSelection();
				// if(Sender != cxStavkePrimesa) cxVlaga->SetFocus();
				}

				delete OD_Osnovna_pretrage;
		  }
		  else if (OD_DM_Pretraga->cds_MUzorka->RecordCount == 1) {
					cdsProcessing->Edit();
					cdsProcessing->FieldByName("ID_UZORKA")->AsString   = OD_DM_Pretraga->cds_MUzorka->FieldByName("ID")->AsString;
					cdsProcessing->FieldByName("MESTO_UZORKA")->AsString = OD_DM_Pretraga->cds_MUzorka->FieldByName("NAZIV")->AsString;
					cdsProcessing->Post();

					cdsStavkeMerenja->First();
					grdStavkePrimesa->SetFocus();
					cxStavkePrimesaKOLICINA->FocusWithSelection();
				  //	if(Sender != cxStavke) cxVlaga->SetFocus();
		  }
       else ShowMessage("Ne postoji PODATAK koji sadrzi u svom nazivu tekst: "+naziv);
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::dspProcessingBeforeUpdateRecord(TObject *Sender,
          TDataSet *SourceDS, TCustomClientDataSet *DeltaDS, TUpdateKind UpdateKind,
          bool &Applied)
{

	if (UpdateKind == ukInsert) {
		if (!pravoInsert) {
			Applied = true;
			ShowMessage("Nemate pravo da dodate nove podatke!");
			if(cdsProcessing->Active == true) {
				if(cdsProcessing->ChangeCount == 0)
					cdsProcessing->Refresh();
				else {
					cdsProcessing->Active = false;
					cdsProcessing->Active = true;
                }
            }
		}

	}else if (UpdateKind == ukModify) {
		if (!pravoUpdate) {
			Applied = true;
			ShowMessage("Nemate pravo da menjate postojece podatke!");
			if(cdsProcessing->Active == true) {
				if(cdsProcessing->ChangeCount == 0)
					cdsProcessing->Refresh();
				else {
					cdsProcessing->Active = false;
					cdsProcessing->Active = true;
                }
			}
		}

	}else if (UpdateKind == ukDelete) {
		if (!pravoDelete) {
			Applied = true;
			ShowMessage("Nemate pravo da brisete postojece podatke!");
			if(cdsProcessing->Active == true) {
				if(cdsProcessing->ChangeCount == 0)
					cdsProcessing->Refresh();
				else {
					cdsProcessing->Active = false;
					cdsProcessing->Active = true;
                }
            }
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::dspStavkeMerenjaBeforeUpdateRecord(TObject *Sender,
          TDataSet *SourceDS, TCustomClientDataSet *DeltaDS, TUpdateKind UpdateKind,
          bool &Applied)
{

	if (UpdateKind == ukInsert) {
		if (!pravoInsert) {
			Applied = true;
			ShowMessage("Nemate pravo da dodate nove podatke!");
			if(cdsStavkeMerenja->Active == true) {
				if(cdsStavkeMerenja->ChangeCount == 0)
					cdsStavkeMerenja->Refresh();
				else {
					cdsStavkeMerenja->Active = false;
					cdsStavkeMerenja->Active = true;
                }
            }
		}

	}else if (UpdateKind == ukModify) {
		if (!pravoUpdate) {
			Applied = true;
			ShowMessage("Nemate pravo da menjate postojece podatke!");
			if(cdsStavkeMerenja->Active == true) {
				if(cdsStavkeMerenja->ChangeCount == 0)
					cdsStavkeMerenja->Refresh();
				else {
					cdsStavkeMerenja->Active = false;
					cdsStavkeMerenja->Active = true;
                }
			}
		}

	}else if (UpdateKind == ukDelete) {
		if (!pravoDelete) {
			Applied = true;
			ShowMessage("Nemate pravo da brisete postojece podatke!");
			if(cdsStavkeMerenja->Active == true) {
				if(cdsStavkeMerenja->ChangeCount == 0)
					cdsStavkeMerenja->Refresh();
				else {
					cdsStavkeMerenja->Active = false;
					cdsStavkeMerenja->Active = true;
                }
            }
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::FormCreate(TObject *Sender)
{
//	fmOsnovnaPrazna->podesiPrava("OD_EvidencijaPrimesa");
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaPrimesa::cdsProcessingBARKODChange(TField *Sender)
{
	 try {
			cdsBala->Active = false;
			dsetBala->ParamByName("barkod")->AsString = cxBarkod->Text;
			cdsBala->Active = true;

			if(cdsBala->FieldByName("ima_bale")->AsInteger == 0) {
				 ShowMyMessageRed->Show("Ne postoji bala sa barkodom: "+cxBarkod->Text, 0x00CCF8F9);
				 cxBarkod->Text = "";
				 cxBarkod->SetFocus();
				 return;
			}
	 }
	 catch(Exception &e) {
      ShowMessage("Greska!! "+e.Message );
   }
}
//---------------------------------------------------------------------------

