// ---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OD_RecepturaBlenda.h"
#include "OD_DM.h"
#include "OD_funkcije.h"
#include "od_raspored_stolova.h"
#include "OD_DmPretraga.h"
#include "OD_PretragaPodataka.h"
// ---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cxButtons"
#pragma link "cxCalendar"
#pragma link "cxClasses"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxCustomData"
#pragma link "cxData"
#pragma link "cxDataStorage"
#pragma link "cxDBData"
#pragma link "cxDBEdit"
#pragma link "cxDropDownEdit"
#pragma link "cxEdit"
#pragma link "cxFilter"
#pragma link "cxGraphics"
#pragma link "cxGrid"
#pragma link "cxGridCustomTableView"
#pragma link "cxGridCustomView"
#pragma link "cxGridDBTableView"
#pragma link "cxGridLevel"
#pragma link "cxGridTableView"
#pragma link "cxLabel"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxMaskEdit"
#pragma link "cxPC"
#pragma link "cxStyles"
#pragma link "cxTextEdit"
#pragma link "OD_OsnovnaPrazna"
#pragma link "frxClass"
#pragma link "frxDBSet"
#pragma link "dxBar"
#pragma link "cxCheckBox"
#pragma link "cxGridCustomPopupMenu"
#pragma link "cxGridPopupMenu"
#pragma link "cxDBLookupComboBox"
#pragma link "cxMemo"
#pragma link "cxDBLookupEdit"
#pragma link "cxLookupEdit"
#pragma link "frxCross"
#pragma link "frxExportPDF"
#pragma link "frxExportXLS"
#pragma link "cxDateUtils"
#pragma link "cxNavigator"
#pragma link "cxPCdxBarPopupMenu"
#pragma link "dxCore"
#pragma link "dxSkinBlack"
#pragma link "dxSkinBlue"
#pragma link "dxSkinDevExpressDarkStyle"
#pragma link "dxSkinDevExpressStyle"
#pragma link "dxSkinFoggy"
#pragma link "dxSkinOffice2010Black"
#pragma link "dxSkinOffice2010Blue"
#pragma link "dxSkinOffice2010Silver"
#pragma link "dxSkinsCore"
#pragma link "dxSkinscxPCPainter"
#pragma link "dxSkinSevenClassic"
#pragma link "dxSkinVS2010"
#pragma resource "*.dfm"
TOD_DefinisanjeReceptureBlenda* OD_DefinisanjeReceptureBlenda;
extern AnsiString DIR_STAMPE;
extern TKorisnik* myTKorisnik;

// ---------------------------------------------------------------------------
__fastcall TOD_DefinisanjeReceptureBlenda::TOD_DefinisanjeReceptureBlenda(TComponent* Owner)
	:TfmOsnovnaPrazna(Owner)
{
	pravoDelete = DM_OD->cdsProveraSelectPRAVO_DELETE->AsInteger;
	pravoInsert = DM_OD->cdsProveraSelectPRAVO_INSERT->AsInteger;
	pravoUpdate = DM_OD->cdsProveraSelectPRAVO_UPDATE->AsInteger;

	if (!cdsGrupeKomitenata->Active)
		cdsGrupeKomitenata->Active = true;
}

// ---------------------------------------------------------------------------
void __fastcall TOD_DefinisanjeReceptureBlenda::btSnimiClick(TObject* Sender)
{
	bool uspehBlend, uspehBlendStavke, uspehStolovi = false;

	uspehBlend       = SnimiCDS(dspBlend, cdsBlend, dsBlend);
	uspehBlendStavke = SnimiCDS(dspBlendStavke, cdsBlendStavke, dsBlendStavke);
	uspehStolovi     = SnimiCDS(dspStolovi, cdsStolovi, dsStolovi);

	if (uspehBlend == false && uspehBlendStavke == false && uspehStolovi == false)
	{
		btSnimi->Enabled = false;
		btNoviDoc->SetFocus();
	}
	else
	{
		ShowMessage("Neuspeno snimanje!!!");
	}
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::btNoviDocClick(TObject* Sender)
{
	if (pravoInsert)
	{
		rb = 0;

		cdsBlend->Active = false;
		dsetBlend->ParamByName("idb")->AsInteger = -1;
		cdsBlend->Active = true;

		cdsBlend->Append();

		cdsBlendStavke->Active = false;
		dsetBlendStavke->ParamByName("idb")->AsInteger = cdsBlend->FieldByName("ID")->AsInteger;
		cdsBlendStavke->Active = true;

		cdsStolovi->Active = false;
		dsetStolovi->ParamByName("idBlenda")->AsInteger = cdsBlend->FieldByName("ID")->AsInteger;
		cdsStolovi->Active = true;

		btSnimi->Enabled = true;

		cxGridStavke->NewItemRow->Visible  = true;
		cxGridStolovi->NewItemRow->Visible = true;

		txtOpisBlenda->SetFocus();
	}
	else
	{
		ShowMessage("Nemate prava da dodate podatke!");
	}
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cdsBlendNewRecord(TDataSet* DataSet)

{
	spBlend->Prepared = true;
	spBlend->ExecProc();

	cdsBlend->FieldByName("id")->AsInteger = spBlend->ParamByName("ID")->AsInteger;
	cdsBlend->FieldByName("VAZI_OD")->Value = Now();
	cdsBlend->FieldByName("DATUM")->Value = Date();
	cdsBlend->FieldByName("sifra_radnika")->AsInteger = myTKorisnik->sifra_usera;
	cdsBlend->FieldByName("BERBA")->AsInteger = YearOf(Date());
	cdsBlend->FieldByName("BROJ_BL_KOOPERANTA")->AsInteger = 0;
	cdsBlend->FieldByName("UKUPNO_BALA")->AsInteger = 0;
	cdsBlend->FieldByName("BROJ_KOOPER_GRUPE")->AsInteger = 0;
	cdsBlend->FieldByName("BROJ_BALA_GRUPE")->AsInteger = 0;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cdsBlendStavkeNewRecord(TDataSet* DataSet)

{
	spBlendStavke->Prepared = true;
	spBlendStavke->ExecProc();

	cdsBlendStavke->FieldByName("ID")->AsInteger = spBlendStavke->ParamByName("ID")->AsInteger;
	cdsBlendStavke->FieldByName("IDBLENDA")->AsInteger = cdsBlend->FieldByName("id")->AsInteger;
	cdsBlendStavke->FieldByName("BROJ_BALA")->AsCurrency = 0;
	cdsBlendStavke->FieldByName("TEZINA_KG")->AsCurrency = 0;
	cdsBlendStavke->FieldByName("VREME")->Value = Now();
	cdsBlendStavke->FieldByName("RB")->AsInteger = cdsBlendStavke->RecordCount + 1;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::FormActivate(TObject* Sender)
{
	cdsBlend->Active = true;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cxGridLevel1GetGridView(TcxGridLevel* Sender,
	TcxCustomGridRecord* AMasterRecord, TcxCustomGridView*& AGridView)

{
	// cdsBlend->Active = true;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cxButton1Click(TObject* Sender)
{
	cdsZaglavlje->Active = false;
	dsetZaglavlje->ParamByName("od_datum")->Value = cxDateOd->Date;
	dsetZaglavlje->ParamByName("do_datum")->Value = cxDateDo->Date;
	cdsZaglavlje->Active = true;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cdsZaglavljeAfterScroll(TDataSet* DataSet)

{
	if (!cdsZaglavlje->ConstraintsDisabled())
	{
		cdsStavke->Active = false;
		dsetStavke->ParamByName("idb")->AsInteger = cdsZaglavlje->FieldByName("ID")->AsInteger;
		cdsStavke->Active = true;
	}
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::btnPregledClick(TObject* Sender)
{
	cdsZaglavlje->Active = false;
	dsetZaglavlje->ParamByName("od_datum")->Value = cxDateOd->Date;
	dsetZaglavlje->ParamByName("do_datum")->Value = cxDateDo->Date;
	cdsZaglavlje->Active = true;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::btStampajClick(TObject* Sender)
{

	AnsiString nazivfajla;
	nazivfajla = DIR_STAMPE + "\\StampaLeaf\\Blend.fr3";
	frxReport1->LoadFromFile(nazivfajla);
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cxGridDBTableView1DblClick(TObject* Sender)

{
	cdsStavke->Active = false;
	dsetStavke->ParamByName("idb")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
	cdsStavke->Active = true;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cxButton2Click(TObject* Sender)
{
	int ID;

	if (cxPageControl1->ActivePage == cxTabSheet2)
		ID = cdsZaglavlje->FieldByName("ID")->AsInteger;
	else
		ID = cdsBlend->FieldByName("ID")->AsInteger;

	cdsStampa->Active = false;
	dsetStampa->ParamByName("idb")->AsInteger = ID;
	cdsStampa->Active = true;

	cdsStampa1->Active = false;
	dsetStampa1->ParamByName("idb")->AsInteger = ID;
	cdsStampa1->Active = true;

	cdsStatistika->Active = false;
	cdsStatistika->Params->ParamByName("idb")->AsInteger = ID;
	cdsStatistika->Active = true;

	cdsStampaSto->Active = false;
	dsetStampaSto->ParamByName("idblenda")->AsInteger = ID;
	cdsStampaSto->Active = true;

	AnsiString nazivfajla = DIR_STAMPE + "\\StampaLeaf\\Blend.fr3";

	if (frxReport1->LoadFromFile(nazivfajla))
	{
		frxReport1->ShowReport(true);
	}
	else
		ShowMessage("Ne postoji fajl!! " + nazivfajla);

}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::FormCreate(TObject* Sender)
{
	if (!DM_OD->cdsIntKlasa->Active)
		DM_OD->cdsIntKlasa->Active = true;

	cxDateOd->Date = StartOfTheMonth(Now());
	cxDateDo->Date = EndOfTheMonth(Now());

	cdsOznakaStola->Active      = true;
	DM_OD->cdsTipDuvana->Active = true;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::Izmeni2Click(TObject* Sender)
{
	if (pravoUpdate)
	{
		cdsBlend->Active = false;
		dsetBlend->ParamByName("idb")->AsInteger = cdsZaglavlje->FieldByName("ID")->AsInteger;
		cdsBlend->Active = true;

		cdsBlendStavke->Active = false;
		dsetBlendStavke->ParamByName("idb")->AsInteger = cdsZaglavlje->FieldByName("ID")->AsInteger;
		cdsBlendStavke->Active = true;
		cdsBlendStavke->Edit();

		cdsStolovi->Active = false;
		dsetStolovi->ParamByName("idblenda")->AsInteger = cdsZaglavlje->FieldByName("ID")->AsInteger;
		cdsStolovi->Active = true;

		cxPageControl1->ActivePage = cxTabSheet1;
		btSnimi->Enabled           = true;

		if (cdsBlend->IsEmpty())
			cxGridStavke->NewItemRow->Visible = true;
		else
			cxGridStavke->NewItemRow->Visible = false;

		if (!cdsStolovi->IsEmpty())
			cxGridStolovi->NewItemRow->Visible = false;
		else
			cxGridStolovi->NewItemRow->Visible = true;
	}
	else
	{
		ShowMessage("Nemate prava da menjate podatke!");
	}
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cdsBlendStavkeGRADEChange(TField* Sender)

{

	sqlProveraKlase->Active = false;
	sqlProveraKlase->ParamByName("oznaka")->AsString = cdsBlendStavke->FieldByName("GRADE")->AsString;
	sqlProveraKlase->Active = true;

	if (sqlProveraKlase->FieldByName("ima_klasa")->AsInteger == 0)
	{
		ShowMessage("Ne postoji KLASA koja sadrzi u svom nazivu tekst: " + sqlProveraKlase->ParamByName("oznaka")->AsString);
	}

	sqlUkupnoKG->Active = false;
	sqlUkupnoKG->Params->ParamByName("OZNAKA")->AsString = cdsBlendStavke->FieldByName("GRADE")->AsString;
	sqlUkupnoKG->Active = true;

	cdsBlendStavke->Edit();
	cdsBlendStavke->FieldByName("TEZINA_UK")->AsFloat = sqlUkupnoKG->FieldByName("UKUPNA_TEZINA")->AsFloat;
	cdsBlendStavke->Post();
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cdsStoloviNewRecord(TDataSet* DataSet)

{
	spStolovi->Prepared = true;
	spStolovi->ExecProc();

	cdsStolovi->FieldByName("ID")->AsInteger = spStolovi->ParamByName("ID")->AsInteger;
	cdsStolovi->FieldByName("IDBLENDA")->AsInteger = cdsBlend->FieldByName("id")->AsInteger;
	cdsStolovi->FieldByName("Datum")->Value = Now();
	cdsStolovi->FieldByName("BROJ_BALA")->AsInteger = 0;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::txtOpisBlendaKeyPress(TObject* Sender,
	wchar_t& Key)
{
	AnsiString naziv;

	if (Key == VK_RETURN)
	{
		naziv = txtOpisBlenda->Text;

		OD_DM_Pretraga->cdsOznakaBlenda->Filter   = "";
		OD_DM_Pretraga->cdsOznakaBlenda->Filtered = false;
		OD_DM_Pretraga->cdsOznakaBlenda->Active   = false;
		OD_DM_Pretraga->dsetOznakaBlenda->ParamByName("oznaka")->AsString = UpperCase(naziv);
		OD_DM_Pretraga->cdsOznakaBlenda->Active = true;

		if (OD_DM_Pretraga->cdsOznakaBlenda->RecordCount > 1)
		{
			TOD_Osnovna_pretrage* OD_Osnovna_pretrage = new TOD_Osnovna_pretrage(OD_DM_Pretraga->dsetOznakaBlenda, OD_DM_Pretraga->dsOznakaBlenda, "OZNAKA_BLENDA", "OPIS", this);
			OD_Osnovna_pretrage->WindowState          = wsNormal;

			if (OD_Osnovna_pretrage->ShowModal() == mrOk)
			{
				cdsBlend->Edit();
				cdsBlend->FieldByName("OPIS")->AsString = OD_DM_Pretraga->cdsOznakaBlenda->FieldByName("OZNAKA_BLENDA")->AsString;
				cdsBlend->FieldByName("IDBLENDA")->AsInteger = OD_DM_Pretraga->cdsOznakaBlenda->FieldByName("ID")->AsInteger;
				// cdsBlend->FieldByName("PROV_POREKLA")->AsInteger = OD_DM_Pretraga->cdsOznakaBlenda->FieldByName("PROV_POREKLA")->AsInteger;
			}

			delete OD_Osnovna_pretrage;
		}
		else if (OD_DM_Pretraga->cdsOznakaBlenda->RecordCount == 1)
		{
			cdsBlend->Edit();
			cdsBlend->FieldByName("OPIS")->AsString = OD_DM_Pretraga->cdsOznakaBlenda->FieldByName("OZNAKA_BLENDA")->AsString;
			cdsBlend->FieldByName("IDBLENDA")->AsInteger = OD_DM_Pretraga->cdsOznakaBlenda->FieldByName("ID")->AsInteger;
			// cdsBlend->FieldByName("PROV_POREKLA")->AsInteger = OD_DM_Pretraga->cdsOznakaBlenda->FieldByName("PROV_POREKLA")->AsInteger;
		}
		else
			ShowMessage("Ne postoji PODATAK koji sadrzi u svom nazivu tekst: " + naziv);
	}

	// if (Key == VK_RETURN)
	// txtBrojBatch->SetFocus();
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::txtBrojBatchKeyPress(TObject* Sender,
	wchar_t& Key)
{
	if (Key == VK_RETURN)
		txtOrderNo->SetFocus();
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::txtOrderNoKeyPress(TObject* Sender,
	wchar_t& Key)
{
	if (Key == VK_RETURN)
		cxDatum->SetFocus();
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cxDatumKeyPress(TObject* Sender, wchar_t& Key)

{
	if (Key == VK_RETURN)
		txtBerba->SetFocus();
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::txtBerbaKeyPress(TObject* Sender,
	wchar_t& Key)
{
	if (Key == VK_RETURN)
		txtBrojBala->SetFocus();
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::txtBrojBalaKeyPress(TObject* Sender,
	wchar_t& Key)
{
	if (Key == VK_RETURN)
	{
		cxBrojBlKooperanta->SetFocus();
	}
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::Stampapointklasi1Click(TObject* Sender)
{
	int ID;

	if (cxPageControl1->ActivePage == cxTabSheet2)
		ID = cdsZaglavlje->FieldByName("ID")->AsInteger;
	else
		ID = cdsBlend->FieldByName("ID")->AsInteger;

	cdsStampa->Active = false;
	dsetStampa->ParamByName("idb")->AsInteger = ID;
	cdsStampa->Active = true;

	cdsStampa1->Active = false;
	dsetStampa1->ParamByName("idb")->AsInteger = ID;
	cdsStampa1->Active = true;

	cdsStampaSto->Active = false;
	dsetStampaSto->ParamByName("idblenda")->AsInteger = ID;
	cdsStampaSto->Active = true;

	AnsiString nazivfajla = DIR_STAMPE + "\\StampaLeaf\\IntKlasaSto.fr3";

	if (frxReport1->LoadFromFile(nazivfajla))
	{
		frxReport1->ShowReport(true);
	}
	else
		ShowMessage("Ne postoji fajl!! " + nazivfajla);
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cdsBlendStavkeAfterDelete(TDataSet* DataSet)
{
	if (cdsBlend->IsEmpty())
		cxGridStavke->NewItemRow->Visible = true;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cdsBlendStavkeAfterPost(TDataSet* DataSet)
{
	if (!cdsBlend->IsEmpty())
		cxGridStavke->NewItemRow->Visible = false;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cdsStoloviAfterDelete(TDataSet* DataSet)
{
	if (cdsStolovi->IsEmpty())
		cxGridStolovi->NewItemRow->Visible = true;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cdsStoloviAfterPost(TDataSet* DataSet)
{
	if (!cdsStolovi->IsEmpty())
		cxGridStolovi->NewItemRow->Visible = false;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cxAktivanKeyPress(TObject* Sender, wchar_t& Key)
{
	if (Key == VK_RETURN)
		cxNapomene->SetFocus();
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cxNapomeneKeyPress(TObject* Sender, wchar_t& Key)
{
	if (Key == VK_RETURN)
	{
		cdsBlendStavke->Append();
		cxGrid1->SetFocus();
		cxGridStavkeGRADE->FocusWithSelection();
	}
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cxGridStavkeDataControllerSummaryAfterSummary(TcxDataSummary* ASender)
{
	// try {
	if ((cdsBlendStavke->Active == true) && (!cdsBlendStavke->IsEmpty()))
	{
		TcxDataSummary* broj_bala = cxGridStavke->DataController->Summary;

		if (VarIsNull(broj_bala->FooterSummaryValues[0]))
			return;

		if ((int)broj_bala->FooterSummaryValues[0] > cdsBlend->FieldByName("UKUPNO_BALA")->AsInteger)
		{
			ShowMessage("Veci broj bala!");
			cdsBlendStavke->Delete();
			cxGrid1->SetFocus();
			cxGridStavkeGRADE->FocusWithSelection();
		}
	}
	/*
	 }
	 catch(Exception &e) {
	 //-------------
	 }
	 */
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cxBrojBlKooperantaKeyPress(TObject* Sender, wchar_t& Key)
{
	if (Key == VK_RETURN)
		cxAktivan->SetFocus();
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::dspBlendBeforeUpdateRecord(TObject* Sender,
	TDataSet* SourceDS, TCustomClientDataSet* DeltaDS, TUpdateKind UpdateKind,
	bool& Applied)
{ // cdsBlend

	if (UpdateKind == ukInsert)
	{
		if (!pravoInsert)
		{
			Applied = true;
			ShowMessage("Nemate pravo da dodate nove podatke!");
			if (cdsBlend->Active == true)
			{
				if (cdsBlend->ChangeCount == 0)
					cdsBlend->Refresh();
				else
				{
					cdsBlend->Active = false;
					cdsBlend->Active = true;
				}
			}
		}

	}
	else if (UpdateKind == ukModify)
	{
		if (!pravoUpdate)
		{
			Applied = true;
			ShowMessage("Nemate pravo da menjate postojece podatke!");
			if (cdsBlend->Active == true)
			{
				if (cdsBlend->ChangeCount == 0)
					cdsBlend->Refresh();
				else
				{
					cdsBlend->Active = false;
					cdsBlend->Active = true;
				}
			}
		}

	}
	else if (UpdateKind == ukDelete)
	{
		if (!pravoDelete)
		{
			Applied = true;
			ShowMessage("Nemate pravo da brisete postojece podatke!");
			if (cdsBlend->Active == true)
			{
				if (cdsBlend->ChangeCount == 0)
					cdsBlend->Refresh();
				else
				{
					cdsBlend->Active = false;
					cdsBlend->Active = true;
				}
			}
		}
	}

}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::dspBlendStavkeBeforeUpdateRecord(TObject* Sender,
	TDataSet* SourceDS, TCustomClientDataSet* DeltaDS, TUpdateKind UpdateKind,
	bool& Applied)
{

	if (UpdateKind == ukInsert)
	{
		if (!pravoInsert)
		{
			Applied = true;
			ShowMessage("Nemate pravo da dodate nove podatke!");
			if (cdsBlendStavke->Active == true)
			{
				if (cdsBlendStavke->ChangeCount == 0)
					cdsBlendStavke->Refresh();
				else
				{
					cdsBlendStavke->Active = false;
					cdsBlendStavke->Active = true;
				}
			}
		}

	}
	else if (UpdateKind == ukModify)
	{
		if (!pravoUpdate)
		{
			Applied = true;
			ShowMessage("Nemate pravo da menjate postojece podatke!");
			if (cdsBlendStavke->Active == true)
			{
				if (cdsBlendStavke->ChangeCount == 0)
					cdsBlendStavke->Refresh();
				else
				{
					cdsBlendStavke->Active = false;
					cdsBlendStavke->Active = true;
				}
			}
		}

	}
	else if (UpdateKind == ukDelete)
	{
		if (!pravoDelete)
		{
			Applied = true;
			ShowMessage("Nemate pravo da brisete postojece podatke!");
			if (cdsBlendStavke->Active == true)
			{
				if (cdsBlendStavke->ChangeCount == 0)
					cdsBlendStavke->Refresh();
				else
				{
					cdsBlendStavke->Active = false;
					cdsBlendStavke->Active = true;
				}
			}
		}
	}
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::dspStoloviBeforeUpdateRecord(TObject* Sender,
	TDataSet* SourceDS, TCustomClientDataSet* DeltaDS, TUpdateKind UpdateKind,
	bool& Applied)
{

	if (UpdateKind == ukInsert)
	{
		if (!pravoInsert)
		{
			Applied = true;
			ShowMessage("Nemate pravo da dodate nove podatke!");
			if (cdsStolovi->Active == true)
			{
				if (cdsStolovi->ChangeCount == 0)
					cdsStolovi->Refresh();
				else
				{
					cdsStolovi->Active = false;
					cdsStolovi->Active = true;
				}
			}
		}

	}
	else if (UpdateKind == ukModify)
	{
		if (!pravoUpdate)
		{
			Applied = true;
			ShowMessage("Nemate pravo da menjate postojece podatke!");
			if (cdsStolovi->Active == true)
			{
				if (cdsStolovi->ChangeCount == 0)
					cdsStolovi->Refresh();
				else
				{
					cdsStolovi->Active = false;
					cdsStolovi->Active = true;
				}
			}
		}

	}
	else if (UpdateKind == ukDelete)
	{
		if (!pravoDelete)
		{
			Applied = true;
			ShowMessage("Nemate pravo da brisete postojece podatke!");
			if (cdsStolovi->Active == true)
			{
				if (cdsStolovi->ChangeCount == 0)
					cdsStolovi->Refresh();
				else
				{
					cdsStolovi->Active = false;
					cdsStolovi->Active = true;
				}
			}
		}
	}
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::Obrisi1Click(TObject* Sender)
{
	if (pravoDelete)
	{
		TTransactionDesc TD;
		int greska;

		sqlProveraRecepture->Active = false;
		sqlProveraRecepture->ParamByName("id")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
		sqlProveraRecepture->Active = true;

		if (sqlProveraRecepture->FieldByName("broj")->AsInteger > 0)
		{
			ShowMessage("Ne mozete brisati recepturu!! \r\rReceptura je koristena u batchu broj: " + sqlProveraRecepture->FieldByName("broj_batcha")->AsString + "\r\rod datuma: " + sqlProveraRecepture->FieldByName("datum_od")->AsString);
			return;
		}

		try
		{

			TD.TransactionID  = 1;
			TD.IsolationLevel = 0; // xilREADCOMMITTED;  //xilREADCOMMITTED

			if (!DM_OD->SC_OD->InTransaction)
			{

				DM_OD->SC_OD->StartTransaction(TD);

				if (MessageBoxA(Handle, "Da li ste sigurni da zelite da nastavite?", "Brisanje ", MB_YESNO) == IDYES)
				{
					qDeleteStolovi->ParamByName("idb")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
					qDeleteStolovi->ExecSQL();

					qDeleteStavke->ParamByName("idb")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
					qDeleteStavke->ExecSQL();

					qDelete->ParamByName("idb")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
					qDelete->ExecSQL();

					if (greska <= 0)
						btnPregled->Click();
				}

				if (DM_OD->SC_OD->InTransaction)
					DM_OD->SC_OD->Commit(TD);
			}
		}
		catch (Exception& e)
		{
			if (DM_OD->SC_OD->InTransaction)
				DM_OD->SC_OD->Rollback(TD);
			ShowMessage("Greska: " + e.Message);
		}
	}
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::btRasporedClick(TObject* Sender)
{

	Tod_raspored_stol* od_raspored_stol = new Tod_raspored_stol(this, cdsBlend->FieldByName("ID")->AsInteger);
	od_raspored_stol->ShowModal();

	cdsStolovi->Active = false;
	cdsStolovi->Params->ParamByName("IDBLENDA")->AsInteger = cdsBlend->FieldByName("ID")->AsInteger;
	cdsStolovi->Active = true;

	// int BrojStola                 = 1, BrojBalaNaStolu = 0, OstaloBala = 0, BrojBala = 0;
	// int DefaultBrojBalaPoStolu    = 0;
	// Extended BrojStolova          = 10;
	// Extended FloatBrojBalaNaStolu = 0;
	// Extended UkupanBrojBala       = cdsBlend->FieldByName("UKUPNO_BALA")->AsFloat;
	//
	// cdsStolovi->Active = false;
	// dsetStolovi->ParamByName("idBlenda")->AsInteger = cdsBlend->FieldByName("ID")->AsInteger;
	// cdsStolovi->Active = true;
	//
	// if (cdsStolovi->RecordCount > 0)
	// {
	// if (MessageDlg("Bale duvana su vec rasporedjene po stolovima ! \n\nDa li ipak zelite da nastavite?", mtWarning, TMsgDlgButtons() << mbYes << mbNo, 0) == mrNo)
	// return;
	// }
	// try
	// {
	//
	// cdsRasporedStolova->Active = false;
	// sqlRasporedStolova->ParamByName("idb")->AsInteger = cdsBlend->FieldByName("id")->AsInteger;
	// cdsRasporedStolova->Active = true;
	//
	// FloatBrojBalaNaStolu = UkupanBrojBala / BrojStolova;
	//
	// if (cdsRasporedStolova->RecordCount != 0)
	// DefaultBrojBalaPoStolu = (int)Ceil(FloatBrojBalaNaStolu);
	//
	// cdsRasporedStolova->First();
	// cdsOznakaStola->First();
	//
	// while (!cdsOznakaStola->Eof)
	// {
	// BrojBalaNaStolu = 0;
	// BrojBala        = 0;
	//
	// while (!cdsRasporedStolova->Eof)
	// {
	// if (OstaloBala > 0) // 4
	// {
	// BrojBalaNaStolu = BrojBalaNaStolu + OstaloBala; // 0+0
	//
	// if (OstaloBala <= DefaultBrojBalaPoStolu) // 0<6.6
	// {
	// BrojBala   = OstaloBala;
	// OstaloBala = 0;
	// }
	// else
	// {
	// BrojBala   = DefaultBrojBalaPoStolu;
	// OstaloBala = OstaloBala - DefaultBrojBalaPoStolu;
	// }
	// }
	// else
	// {
	// BrojBalaNaStolu = BrojBalaNaStolu + cdsRasporedStolova->FieldByName("broj_bala")->AsInteger;
	// BrojBala        = cdsRasporedStolova->FieldByName("broj_bala")->AsInteger;
	//
	// if (BrojBalaNaStolu > DefaultBrojBalaPoStolu)
	// {
	// BrojBala   = DefaultBrojBalaPoStolu - BrojBalaNaStolu + cdsRasporedStolova->FieldByName("broj_bala")->AsInteger;
	// OstaloBala = cdsRasporedStolova->FieldByName("broj_bala")->AsInteger - BrojBala;
	// }
	// }
	// if (BrojBala > 0)
	// {
	// cdsStolovi->Append();
	// cdsStolovi->FieldByName("id_stola")->AsString = cdsOznakaStola->FieldByName("id")->AsString;
	// cdsStolovi->FieldByName("int_klasa")->AsString = cdsRasporedStolova->FieldByName("grade")->AsString;
	// cdsStolovi->FieldByName("broj_bala")->AsInteger = BrojBala;
	// cdsStolovi->Post();
	// }
	//
	// if (BrojBalaNaStolu > DefaultBrojBalaPoStolu)
	// {
	// break;
	// }
	//
	// cdsRasporedStolova->Next();
	// }
	// BrojStolova = BrojStolova - 1;
	//
	// UkupanBrojBala = UkupanBrojBala - DefaultBrojBalaPoStolu;
	//
	// FloatBrojBalaNaStolu   = UkupanBrojBala / BrojStolova;
	// DefaultBrojBalaPoStolu = (int)Ceil(FloatBrojBalaNaStolu);
	//
	// cdsOznakaStola->Next();
	// }
	// btSnimi->Enabled = true;
	// }
	// catch (Exception& e)
	// {
	// // ShowMessage("Greska!! "+e.Message);
	// }
}

// ---------------------------------------------------------------------------
/*
 if(OstaloBala > 0)                                         //0
 {
 BrojBalaNaStolu = BrojBalaNaStolu+OstaloBala;           //0+0

 if(OstaloBala <= DefaultBrojBalaPoStolu)                //0<6.6
 {
 BrojBala=OstaloBala;
 OstaloBala=0;
 }
 else {
 BrojBala=DefaultBrojBalaPoStolu;
 OstaloBala=OstaloBala-DefaultBrojBalaPoStolu;
 }
 }
 else 	{
 BrojBalaNaStolu = BrojBalaNaStolu+cdsRasporedStolova->FieldByName("broj_bala")->AsInteger;
 BrojBala=cdsRasporedStolova->FieldByName("broj_bala")->AsInteger;

 if(BrojBalaNaStolu > DefaultBrojBalaPoStolu)
 {
 BrojBala=DefaultBrojBalaPoStolu-BrojBalaNaStolu+cdsRasporedStolova->FieldByName("broj_bala")->AsInteger;
 OstaloBala = cdsRasporedStolova->FieldByName("broj_bala")->AsInteger-BrojBala;

 }
 }
 */
// ---------------------------------------------------------------------------
void __fastcall TOD_DefinisanjeReceptureBlenda::cxLookupComboBox1PropertiesChange(TObject* Sender)
{
	DM_OD->cdsIntKlasa->Active = false;
	DM_OD->dsetIntKlasa->ParamByName("idsorte")->AsInteger = cxSorta->EditValue;
	DM_OD->cdsIntKlasa->Active = true;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cxOznakeBlendaClick(TObject* Sender)
{
	wchar_t Taster = VK_RETURN;

	txtOpisBlendaKeyPress(this, Taster);
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cdsBlendIDGRUPEChange(TField* Sender)
{
	// if(cdsBlend->FieldByName("idgrupe")->AsInteger > 0) {
	// pnGrupa->Visible = true;
	// }
	// else pnGrupa->Visible = false;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cdsBlendPROV_POREKLAChange(TField* Sender)
{
	if (cdsBlend->FieldByName("PROV_POREKLA")->AsInteger != 1)
	{
		ShowMessage("Ukoliko ste iskljucili proveru porekla duvana, onda ne smete unositi Poreklo.\rTakodje, internu klasu unesite samo jednom!!");
	}
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cdsBlendStavkeTEZINA_KGChange(TField* Sender)

{
	if (cdsBlend->FieldByName("UKUPNO_KG")->AsCurrency != 0)
		cdsBlendStavke->FieldByName("PROCENAT")->AsCurrency = 100.0000 * cdsBlendStavke->FieldByName("TEZINA_KG")->AsCurrency / cdsBlend->FieldByName("UKUPNO_KG")->AsCurrency;
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cxGridStavkeEditKeyDown(TcxCustomGridTableView* Sender,
	TcxCustomGridTableItem* AItem, TcxCustomEdit* AEdit,
	WORD& Key, TShiftState Shift)
{
	if (Key == VK_RETURN)
	{
		AnsiString tekst = VarToStr(AEdit->EditingValue);

		if ((tekst != "" && AItem == cxGridStavkeTEZINA_KG))
		{
			if (cdsBlendStavkeGRADE->AsString != "")
			{
				cdsBlendStavke->Post();
			}
			else
			{
				ShowMessage("Odaberite prvo internu klasu pre unosenja tezine");
				return;
			}

		}
	}
}
// ---------------------------------------------------------------------------

void __fastcall TOD_DefinisanjeReceptureBlenda::cxIzracunajKGClick(TObject* Sender)

{
	float ukupnokg = 0;

	cdsBlendStavke->First();
	while (!cdsBlendStavke->Eof)
	{

		ukupnokg += cdsBlendStavke->FieldByName("TEZINA_UK")->AsFloat;

		cdsBlendStavke->Next();

	}
	cdsBlendStavke->First();
	while (!cdsBlendStavke->Eof)
	{

		float proc = RoundTo(cdsBlendStavke->FieldByName("TEZINA_UK")->AsFloat / ukupnokg, -2);

		cdsBlendStavke->Edit();
		cdsBlendStavke->FieldByName("TEZINA_KG")->AsFloat = RoundTo(cdsBlend->FieldByName("UKUPNO_KG")->AsFloat * proc, -2);
		cdsBlendStavke->Post();
		cdsBlendStavke->Next();

	}

}

// ---------------------------------------------------------------------------
void __fastcall TOD_DefinisanjeReceptureBlenda::cxPreracunajKGClick(TObject* Sender)

{
	float ukupnokg = 0;

	cdsStavke->First();
	while (!cdsStavke->Eof)
	{

		sqlUkupnoKG->Active = false;
		sqlUkupnoKG->Params->ParamByName("OZNAKA")->AsString = cdsStavke->FieldByName("GRADE")->AsString;
		sqlUkupnoKG->Active = true;

		cdsStavke->Edit();
		cdsStavke->FieldByName("TEZINA_UK")->AsFloat = sqlUkupnoKG->FieldByName("UKUPNA_TEZINA")->AsFloat;
		cdsStavke->Post();

		ukupnokg += cdsStavke->FieldByName("TEZINA_UK")->AsFloat;

		cdsStavke->Next();

	}
	cdsStavke->First();
	while (!cdsStavke->Eof)
	{

		float proc = RoundTo(cdsStavke->FieldByName("TEZINA_UK")->AsFloat / ukupnokg, -2);

		cdsStavke->Edit();
		cdsStavke->FieldByName("TEZINA_KG")->AsFloat = RoundTo(cdsZaglavlje->FieldByName("UKUPNO_KG")->AsFloat * proc, -2);
		cdsStavke->FieldByName("PROCENAT")->AsCurrency = 100.0000 * cdsStavke->FieldByName("TEZINA_KG")->AsCurrency / cdsZaglavlje->FieldByName("UKUPNO_KG")->AsCurrency;
		cdsStavke->Post();
		cdsStavke->Next();

	}
	int uspehBlendStavke = SnimiCDS(dspStavke, cdsStavke, dsStavke);
}
// ---------------------------------------------------------------------------
