//---------------------------------------------------------------------------

#ifndef OD_RecepturaBlendaH
#define OD_RecepturaBlendaH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "cxButtons.hpp"
#include "cxCalendar.hpp"
#include "cxClasses.hpp"
#include "cxContainer.hpp"
#include "cxControls.hpp"
#include "cxCustomData.hpp"
#include "cxData.hpp"
#include "cxDataStorage.hpp"
#include "cxDBData.hpp"
#include "cxDBEdit.hpp"
#include "cxDropDownEdit.hpp"
#include "cxEdit.hpp"
#include "cxFilter.hpp"
#include "cxGraphics.hpp"
#include "cxGrid.hpp"
#include "cxGridCustomTableView.hpp"
#include "cxGridCustomView.hpp"
#include "cxGridDBTableView.hpp"
#include "cxGridLevel.hpp"
#include "cxGridTableView.hpp"
#include "cxLabel.hpp"
#include "cxLookAndFeelPainters.hpp"
#include "cxLookAndFeels.hpp"
#include "cxMaskEdit.hpp"
#include "cxPC.hpp"
#include "cxStyles.hpp"
#include "cxTextEdit.hpp"
#include "OD_OsnovnaPrazna.h"
#include <ActnList.hpp>
#include <DB.hpp>
#include <DBClient.hpp>
#include <ExtCtrls.hpp>
#include <FMTBcd.hpp>
#include <Menus.hpp>
#include <Provider.hpp>
#include <SqlExpr.hpp>
#include <Dialogs.hpp>
#include "frxClass.hpp"
#include "frxDBSet.hpp"
#include "dxBar.hpp"
#include "cxCheckBox.hpp"
#include "cxGridCustomPopupMenu.hpp"
#include "cxGridPopupMenu.hpp"
#include "cxDBLookupComboBox.hpp"
#include "cxMemo.hpp"
#include <DBGrids.hpp>
#include <Grids.hpp>
#include "cxDBLookupEdit.hpp"
#include "cxLookupEdit.hpp"
#include "frxCross.hpp"
#include "frxExportPDF.hpp"
#include "frxExportXLS.hpp"
#include "cxDateUtils.hpp"
#include "cxNavigator.hpp"
#include "cxPCdxBarPopupMenu.hpp"
#include "dxCore.hpp"
#include "dxSkinBlack.hpp"
#include "dxSkinBlue.hpp"
#include "dxSkinDevExpressDarkStyle.hpp"
#include "dxSkinDevExpressStyle.hpp"
#include "dxSkinFoggy.hpp"
#include "dxSkinOffice2010Black.hpp"
#include "dxSkinOffice2010Blue.hpp"
#include "dxSkinOffice2010Silver.hpp"
#include "dxSkinsCore.hpp"
#include "dxSkinscxPCPainter.hpp"
#include "dxSkinSevenClassic.hpp"
#include "dxSkinVS2010.hpp"
#include <System.Actions.hpp>
#include <Vcl.ComCtrls.hpp>
//---------------------------------------------------------------------------
class TOD_DefinisanjeReceptureBlenda : public TfmOsnovnaPrazna
{
__published:	// IDE-managed Components
	TcxPageControl *cxPageControl1;
	TcxTabSheet *cxTabSheet1;
	TcxTabSheet *cxTabSheet2;
	TPanel *Panel1;
	TPanel *Panel2;
	TPanel *Panel3;
	TcxButton *btNoviDoc;
	TcxButton *btSnimi;
	TcxButton *btStampaj;
	TcxButton *btFunkcije;
	TcxDBDateEdit *cxDatum;
	TcxLabel *cxLabel2;
	TcxLabel *cxLabel11;
	TcxLabel *cxLabel12;
	TcxLabel *cxLabel3;
	TcxDBTextEdit *txtOpisBlenda;
	TcxLabel *cxLabel4;
	TSQLDataSet *dsetBlend;
	TDataSetProvider *dspBlend;
	TClientDataSet *cdsBlend;
	TDataSource *dsBlend;
	TSQLDataSet *dsetBlendStavke;
	TDataSetProvider *dspBlendStavke;
	TClientDataSet *cdsBlendStavke;
	TDataSource *dsBlendStavke;
	TIntegerField *cdsBlendID;
	TStringField *cdsBlendOPIS;
	TStringField *cdsBlendBATCH_NO;
	TStringField *cdsBlendORDER_NO;
	TIntegerField *cdsBlendBERBA;
	TDateField *cdsBlendVAZI_OD;
	TIntegerField *cdsBlendBROJ_BLENDA;
	TDateField *cdsBlendDATUM;
	TStringField *cdsBlendSMENA;
	TSmallintField *cdsBlendAKTIVAN;
	TStringField *cdsBlendNAPOMENA;
	TIntegerField *cdsBlendSIFRA_RADNIKA;
	TIntegerField *cdsBlendStavkeID;
	TIntegerField *cdsBlendStavkeIDBLENDA;
	TStringField *cdsBlendStavkeGRADE;
	TFloatField *cdsBlendStavkeBROJ_BALA;
	TIntegerField *cdsBlendStavkeRB;
	TFloatField *cdsBlendStavkePROCENAT;
	TSQLTimeStampField *cdsBlendStavkeVREME;
	TSQLDataSet *dsetZaglavlje;
	TDataSetProvider *dspZaglavlje;
	TClientDataSet *cdsZaglavlje;
	TDataSource *dsZaglavlje;
	TIntegerField *cdsZaglavljeID;
	TStringField *cdsZaglavljeOPIS;
	TStringField *cdsZaglavljeBATCH_NO;
	TStringField *cdsZaglavljeORDER_NO;
	TIntegerField *cdsZaglavljeBERBA;
	TDateField *cdsZaglavljeVAZI_OD;
	TIntegerField *cdsZaglavljeBROJ_BLENDA;
	TDateField *cdsZaglavljeDATUM;
	TStringField *cdsZaglavljeSMENA;
	TSmallintField *cdsZaglavljeAKTIVAN;
	TStringField *cdsZaglavljeNAPOMENA;
	TIntegerField *cdsZaglavljeSIFRA_RADNIKA;
	TStringField *cdsZaglavljeRADNIK;
	TSQLDataSet *dsetStavke;
	TDataSetProvider *dspStavke;
	TClientDataSet *cdsStavke;
	TDataSource *dsStavke;
	TIntegerField *cdsStavkeID;
	TIntegerField *cdsStavkeIDBLENDA;
	TStringField *cdsStavkeGRADE;
	TFloatField *cdsStavkeBROJ_BALA;
	TIntegerField *cdsStavkeRB;
	TFloatField *cdsStavkePROCENAT;
	TSQLTimeStampField *cdsStavkeVREME;
	TPanel *Panel4;
	TcxGrid *cxGrid3;
	TcxGridDBTableView *cxGridDBTableView1;
	TcxGridLevel *cxGridLevel1;
	TcxDateEdit *cxDateOd;
	TcxDateEdit *cxDateDo;
	TcxLabel *cxLabel8;
	TSQLStoredProc *spBlend;
	TcxLabel *cxLabel9;
	TcxGridDBColumn *cxGridDBTableView1ID;
	TcxGridDBColumn *cxGridDBTableView1OPIS;
	TcxGridDBColumn *cxGridDBTableView1IDNO;
	TcxGridDBColumn *cxGridDBTableView1BATCH_NO;
	TcxGridDBColumn *cxGridDBTableView1ORDER_NO;
	TcxGridDBColumn *cxGridDBTableView1BERBA;
	TcxGridDBColumn *cxGridDBTableView1VAZI_OD;
	TcxGridDBColumn *cxGridDBTableView1BROJ_BLENDA;
	TcxGridDBColumn *cxGridDBTableView1DATUM;
	TcxGridDBColumn *cxGridDBTableView1SMENA;
	TcxGridDBColumn *cxGridDBTableView1AKTIVAN;
	TcxGridDBColumn *cxGridDBTableView1NAPOMENA;
	TcxGridDBColumn *cxGridDBTableView1SIFRA_RADNIKA;
	TSQLStoredProc *spBlendStavke;
	TfrxDBDataset *frxDBBlend;
	TcxButton *cxButton2;
	TcxButton *btnPregled;
	TfrxReport *frxReport1;
	TSQLDataSet *dsetStampa;
	TDataSetProvider *dspStampa;
	TClientDataSet *cdsStampa;
	TDataSource *dsStampa;
	TClientDataSet *cdsStampa1;
	TDataSource *dsStampa1;
	TDataSetProvider *dspStampa1;
	TSQLDataSet *dsetStampa1;
	TfrxDBDataset *frxDBStavke;
	TIntegerField *cdsStampa1ID;
	TIntegerField *cdsStampa1IDBLENDA;
	TStringField *cdsStampa1GRADE;
	TFloatField *cdsStampa1BROJ_BALA;
	TIntegerField *cdsStampa1RB;
	TFloatField *cdsStampa1PROCENAT;
	TSQLTimeStampField *cdsStampa1VREME;
	TcxGrid *cxGrid2;
	TcxGridDBTableView *cxGrid2DBTableView1;
	TcxGridDBColumn *cxGrid2DBTableView1ID;
	TcxGridDBColumn *cxGrid2DBTableView1IDBLENDA;
	TcxGridDBColumn *cxGrid2DBTableView1GRADE;
	TcxGridDBColumn *cxGrid2DBTableView1BROJ_BALA;
	TcxGridDBColumn *cxGrid2DBTableView1RB;
	TcxGridDBColumn *cxGrid2DBTableView1PROCENAT;
	TcxGridDBColumn *cxGrid2DBTableView1VREME;
	TcxGridLevel *cxGrid2Level1;
	TFloatField *cdsBlendUKUPNO_BALA;
	TcxDBTextEdit *txtBrojBala;
	TcxLabel *cxLabel10;
	TSQLQuery *sqlProveraKlase;
	TcxPageControl *cxPageControl2;
	TcxTabSheet *cxTabSheet3;
	TcxGrid *cxGrid1;
	TcxGridDBTableView *cxGridStavke;
	TcxGridDBColumn *cxGridStavkeID;
	TcxGridDBColumn *cxGridStavkeIDBLENDA;
	TcxGridDBColumn *cxGridStavkeRB;
	TcxGridDBColumn *cxGridStavkeGRADE;
	TcxGridDBColumn *cxGridStavkeBROJ_BALA;
	TcxGridDBColumn *cxGridStavkePROCENAT;
	TcxGridLevel *cxGrid1Level1;
	TcxGridPopupMenu *cxGridPopupMenu1;
	TSQLDataSet *dsetStolovi;
	TDataSetProvider *dspStolovi;
	TClientDataSet *cdsStolovi;
	TDataSource *dsStolovi;
	TActionList *ActionList1;
	TcxDBTextEdit *txtBrojBatch;
	TcxDBTextEdit *txtOrderNo;
	TcxDBTextEdit *txtBerba;
	TSQLStoredProc *spStolovi;
	TIntegerField *cdsStoloviID;
	TStringField *cdsStoloviINT_KLASA;
	TIntegerField *cdsStoloviIDBLENDA;
	TSQLTimeStampField *cdsStoloviDATUM;
	TStringField *cdsStoloviID_STOLA;
	TDataSource *dsOznakaStola;
	TClientDataSet *cdsOznakaStola;
	TDataSetProvider *dspOznakaStola;
	TSQLDataSet *dsetOznakaStola;
	TStringField *cdsOznakaStolaID;
	TStringField *cdsOznakaStolaOPIS;
	TIntegerField *cdsStoloviBROJ_BALA;
	TfrxDBDataset *frxDBStolovi;
	TcxDBCheckBox *cxAktivan;
	TSQLDataSet *dsetStampaSto;
	TDataSetProvider *dspStampaSto;
	TClientDataSet *cdsStampaSto;
	TIntegerField *IntegerField1;
	TStringField *StringField1;
	TIntegerField *IntegerField2;
	TSQLTimeStampField *SQLTimeStampField1;
	TStringField *StringField2;
	TIntegerField *IntegerField3;
	TDataSource *dsStampaSto;
	TcxLabel *cxLabel1;
	TPopupMenu *PMS;
	TMenuItem *Stamparecepture1;
	TMenuItem *Stampapointklasi1;
	TIntegerField *cdsStampaID;
	TStringField *cdsStampaOPIS;
	TStringField *cdsStampaBATCH_NO;
	TStringField *cdsStampaORDER_NO;
	TIntegerField *cdsStampaBERBA;
	TDateField *cdsStampaVAZI_OD;
	TIntegerField *cdsStampaBROJ_BLENDA;
	TDateField *cdsStampaDATUM;
	TStringField *cdsStampaSMENA;
	TSmallintField *cdsStampaAKTIVAN;
	TStringField *cdsStampaNAPOMENA;
	TIntegerField *cdsStampaSIFRA_RADNIKA;
	TFloatField *cdsStampaUKUPNO_BALA;
	TStringField *cdsStampaRADNIK;
	TIntegerField *cdsStavkeIDPOREKLA;
	TIntegerField *cdsBlendStavkeIDPOREKLA;
	TcxGridDBColumn *cxGridStavkeIDPOREKLA;
	TcxGridDBColumn *cxGrid2DBTableView1IDPOREKLA;
	TStringField *cdsStampa1POREKLO;
	TcxDBMemo *cxNapomene;
	TIntegerField *cdsBlendIDBLENDA;
	TcxGrid *cxGrid5;
	TcxGridDBTableView *cxGridStolovi;
	TcxGridDBColumn *cxGridStoloviID;
	TcxGridDBColumn *cxGridStoloviID_STOLA;
	TcxGridDBColumn *cxGridStoloviINT_KLASA;
	TcxGridDBColumn *cxGridStoloviIDBLENDA;
	TcxGridDBColumn *cxGridStoloviDATUM;
	TcxGridDBColumn *cxGridStoloviBROJ_BALA;
	TcxGridLevel *cxGrid5Level1;
	TcxLabel *cxLabel5;
	TcxDBTextEdit *cxBrojBlKooperanta;
	TIntegerField *cdsBlendBROJ_BL_KOOPERANTA;
	TcxLabel *cxLabel6;
	TcxDBTextEdit *cxDBTextEdit1;
	TcxStyleRepository *cxStyle;
	TcxStyle *cxStyleZuta;
	TcxStyle *cxStyleZelena;
	TcxStyle *cxStylePlava;
	TcxStyle *cxStylePink;
	TcxStyle *cxStyleBraon;
	TSQLQuery *qDeleteStavke;
	TSQLQuery *qDeleteStolovi;
	TcxButton *btRaspored;
	TDataSource *dsRasporedStolova;
	TClientDataSet *cdsRasporedStolova;
	TDataSetProvider *dspRasporedStolova;
	TSQLDataSet *sqlRasporedStolova;
	TStringField *cdsRasporedStolovaGRADE;
	TStringField *cdsRasporedStolovaKLASA;
	TStringField *cdsRasporedStolovaLIST;
	TFloatField *cdsRasporedStolovaBROJ_BALA;
	TStringField *cdsOznakaStolaSTRANA;
	TStringField *cdsOznakaStolaBROJ;
	TcxLabel *cxLabel7;
	TcxLookupComboBox *cxSorta;
	TFloatField *cdsBlendStavkeTEZINA_KG;
	TFloatField *cdsBlendBROJ_BALA_GRUPE;
	TIntegerField *cdsBlendIDGRUPE;
	TSQLDataSet *sqlGrupeKomitenata;
	TDataSetProvider *dspGrupeKomitenata;
	TClientDataSet *cdsGrupeKomitenata;
	TDataSource *dsGrupeKomitenata;
	TcxLabel *cxLabel13;
	TFloatField *cdsBlendBROJ_KOOPER_GRUPE;
	TcxGridDBColumn *cxGridStavkeVREME;
	TcxGridDBColumn *cxGridStavkeTEZINA_KG;
	TFloatField *cdsStavkeTEZINA_KG;
	TFloatField *cdsZaglavljeUKUPNO_BALA;
	TIntegerField *cdsZaglavljeIDBLENDA;
	TIntegerField *cdsZaglavljeBROJ_BL_KOOPERANTA;
	TFloatField *cdsZaglavljeBROJ_BALA_GRUPE;
	TIntegerField *cdsZaglavljeIDGRUPE;
	TFloatField *cdsZaglavljeBROJ_KOOPER_GRUPE;
	TcxGridDBColumn *cxGridDBTableView1RADNIK;
	TcxGridDBColumn *cxGridDBTableView1UKUPNO_BALA;
	TcxGridDBColumn *cxGridDBTableView1IDBLENDA;
	TcxGridDBColumn *cxGridDBTableView1BROJ_BL_KOOPERANTA;
	TcxGridDBColumn *cxGridDBTableView1BROJ_BALA_GRUPE;
	TcxGridDBColumn *cxGridDBTableView1IDGRUPE;
	TcxGridDBColumn *cxGridDBTableView1BROJ_KOOPER_GRUPE;
	TcxDBCheckBox *cxDBCheckBox1;
	TcxButton *cxOznakeBlenda;
	TSmallintField *cdsBlendPROV_POREKLA;
	TPanel *pnGrupa;
	TcxLabel *cxLabel14;
	TcxDBTextEdit *cxDBTextEdit2;
	TcxDBTextEdit *cxDBTextEdit3;
	TcxLabel *cxLabel15;
	TfrxCrossObject *frxCrossObject1;
	TStringField *cdsStampaStoSTRANA;
	TfrxPDFExport *frxPDFExport1;
	TfrxXLSExport *frxXLSExport1;
	TStringField *cdsBlendGRUPA_FQI;
	TcxDBTextEdit *cxDBTextEdit4;
	TStringField *cdsZaglavljeGRUPA_FQI;
	TcxGridDBColumn *cxGridDBTableView1GRUPA_FQI;
	TcxLabel *cxLabel16;
	TcxLabel *cxLabel17;
	TcxDBTextEdit *cxDBTextEdit5;
	TcxDBTextEdit *cxDBTextEdit6;
	TFMTBCDField *cdsBlendFQI_MIN;
	TFloatField *cdsBlendFQI_MAX;
	TFMTBCDField *cdsZaglavljeFQI_MIN;
	TFloatField *cdsZaglavljeFQI_MAX;
	TcxGridDBColumn *cxGridDBTableView1FQI_MIN;
	TcxGridDBColumn *cxGridDBTableView1FQI_MAX;
	TSQLQuery *sqlProveraRecepture;
	TFloatField *cdsBlendUKUPNO_KG;
	TcxButton *cxIzracunajKG;
	TcxGridDBColumn *cxGridStavkeTEZINA_UK;
	TSQLQuery *sqlUkupnoKG;
	TFloatField *cdsBlendStavkeTEZINA_UK;
	TcxButton *cxPreracunajKG;
	TFloatField *cdsZaglavljeUKUPNO_KG;
	TcxGridDBColumn *cxGrid2DBTableView1TEZINA_KG;
	TFloatField *cdsStavkeTEZINA_UK;
	TStringField *cdsRasporedStolovaINT_KLASA;
	TIntegerField *cdsRasporedStolovaPROC_MG_KG;
	TFloatField *cdsRasporedStolovaUKUPNO;
	TFloatField *cdsRasporedStolovaKG;
	TFMTBCDField *cdsStoloviKG;
	TFMTBCDField *cdsStampaStoKG;
	TFloatField *cdsStampaUKUPNO_KG;
	TFloatField *cdsStampa1TEZINA_KG;
	TFloatField *cdsStampa1TEZINA_UK;
	TIntegerField *cdsStampaStoBROJ;
	TSQLDataSet *sqlStatistika;
	TDataSetProvider *dspStatistika;
	TClientDataSet *cdsStatistika;
	TStringField *cdsStatistikaINT_KLASA;
	TFloatField *cdsStatistikaUKUPNO;
	TStringField *cdsStatistikaGRADE;
	TFloatField *cdsStatistikaKG;
	TStringField *cdsStatistikaKLASA;
	TStringField *cdsStatistikaLIST;
	TFMTBCDField *cdsStatistikaPROC_MG_KG;
	TDataSource *dsStatistika;
	TfrxDBDataset *ftxStatistika;
	TIntegerField *cdsStatistikaUKUPNO_BLEND;
	TFloatField *cdsStatistikaPROC_UK;
	void __fastcall btSnimiClick(TObject *Sender);
	void __fastcall btNoviDocClick(TObject *Sender);
	void __fastcall cdsBlendNewRecord(TDataSet *DataSet);
	void __fastcall cdsBlendStavkeNewRecord(TDataSet *DataSet);
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall cxGridLevel1GetGridView(TcxGridLevel *Sender, TcxCustomGridRecord *AMasterRecord,
          TcxCustomGridView *&AGridView);
	void __fastcall cxButton1Click(TObject *Sender);
	void __fastcall cdsZaglavljeAfterScroll(TDataSet *DataSet);
	void __fastcall btnPregledClick(TObject *Sender);
	void __fastcall btStampajClick(TObject *Sender);
	void __fastcall cxGridDBTableView1DblClick(TObject *Sender);
	void __fastcall cxButton2Click(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall Izmeni2Click(TObject *Sender);
	//void __fastcall cxDBTextEdit1KeyPress(TObject *Sender, wchar_t &Key);
	//void __fastcall cxKlasaKeyPress(TObject *Sender, wchar_t &Key);
	//void __fastcall cxBrojBatchKeyPress(TObject *Sender, wchar_t &Key);
	//void __fastcall cxBrojKutijeKeyPress(TObject *Sender, wchar_t &Key);
	//void __fastcall cxDatumKeyPress(TObject *Sender, wchar_t &Key);
	//void __fastcall cxDBTextEdit3KeyPress(TObject *Sender, wchar_t &Key);
	//void __fastcall cxDBDateEdit1KeyPress(TObject *Sender, wchar_t &Key);
	void __fastcall cdsBlendStavkeGRADEChange(TField *Sender);
	void __fastcall cdsStoloviNewRecord(TDataSet *DataSet);
	void __fastcall txtOpisBlendaKeyPress(TObject *Sender, wchar_t &Key);
	void __fastcall txtBrojBatchKeyPress(TObject *Sender, wchar_t &Key);
	void __fastcall txtOrderNoKeyPress(TObject *Sender, wchar_t &Key);
	void __fastcall cxDatumKeyPress(TObject *Sender, wchar_t &Key);
	void __fastcall txtBerbaKeyPress(TObject *Sender, wchar_t &Key);
	void __fastcall txtBrojBalaKeyPress(TObject *Sender, wchar_t &Key);
	void __fastcall Stampapointklasi1Click(TObject *Sender);
	void __fastcall cdsBlendStavkeAfterDelete(TDataSet *DataSet);
	void __fastcall cdsBlendStavkeAfterPost(TDataSet *DataSet);
	void __fastcall cdsStoloviAfterDelete(TDataSet *DataSet);
	void __fastcall cdsStoloviAfterPost(TDataSet *DataSet);
	void __fastcall cxAktivanKeyPress(TObject *Sender, wchar_t &Key);
	void __fastcall cxNapomeneKeyPress(TObject *Sender, wchar_t &Key);
	void __fastcall cxGridStavkeDataControllerSummaryAfterSummary(TcxDataSummary *ASender);
	void __fastcall cxBrojBlKooperantaKeyPress(TObject *Sender, wchar_t &Key);
	void __fastcall dspBlendBeforeUpdateRecord(TObject *Sender, TDataSet *SourceDS,
          TCustomClientDataSet *DeltaDS, TUpdateKind UpdateKind, bool &Applied);
	void __fastcall dspBlendStavkeBeforeUpdateRecord(TObject *Sender, TDataSet *SourceDS,
          TCustomClientDataSet *DeltaDS, TUpdateKind UpdateKind, bool &Applied);
	void __fastcall dspStoloviBeforeUpdateRecord(TObject *Sender, TDataSet *SourceDS,
          TCustomClientDataSet *DeltaDS, TUpdateKind UpdateKind, bool &Applied);
	void __fastcall Obrisi1Click(TObject *Sender);
	void __fastcall btRasporedClick(TObject *Sender);
	void __fastcall cxLookupComboBox1PropertiesChange(TObject *Sender);
	void __fastcall cxOznakeBlendaClick(TObject *Sender);
	void __fastcall cdsBlendIDGRUPEChange(TField *Sender);
	void __fastcall cdsBlendPROV_POREKLAChange(TField *Sender);
	void __fastcall cdsBlendStavkeTEZINA_KGChange(TField *Sender);
	void __fastcall cxGridStavkeEditKeyDown(TcxCustomGridTableView *Sender, TcxCustomGridTableItem *AItem,
          TcxCustomEdit *AEdit, WORD &Key, TShiftState Shift);
	void __fastcall cxIzracunajKGClick(TObject *Sender);
	void __fastcall cxPreracunajKGClick(TObject *Sender);






private:	// User declarations
	int rb;
public:		// User declarations
	__fastcall TOD_DefinisanjeReceptureBlenda(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TOD_DefinisanjeReceptureBlenda *OD_DefinisanjeReceptureBlenda;
//---------------------------------------------------------------------------
#endif
