//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OD_SadrzajNikotinaSecera.h"
#include "OD_DM.h"
#include "OD_DmPretraga.h"
#include "OD_PretragaPodataka.h"
#include "OD_funkcije.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cxButtons"
#pragma link "cxCalendar"
#pragma link "cxClasses"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxCustomData"
#pragma link "cxData"
#pragma link "cxDataStorage"
#pragma link "cxDBData"
#pragma link "cxDBEdit"
#pragma link "cxDropDownEdit"
#pragma link "cxEdit"
#pragma link "cxFilter"
#pragma link "cxGraphics"
#pragma link "cxGrid"
#pragma link "cxGridCustomTableView"
#pragma link "cxGridCustomView"
#pragma link "cxGridDBTableView"
#pragma link "cxGridLevel"
#pragma link "cxGridTableView"
#pragma link "cxLabel"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxMaskEdit"
#pragma link "cxPC"
#pragma link "cxStyles"
#pragma link "cxTextEdit"
#pragma link "OD_OsnovnaPrazna"
#pragma link "cxSpinEdit"
#pragma link "cxTimeEdit"
#pragma link "cxDateUtils"
#pragma link "cxNavigator"
#pragma link "cxPCdxBarPopupMenu"
#pragma link "dxCore"
#pragma link "dxSkinBlack"
#pragma link "dxSkinBlue"
#pragma link "dxSkinDevExpressDarkStyle"
#pragma link "dxSkinDevExpressStyle"
#pragma link "dxSkinFoggy"
#pragma link "dxSkinOffice2010Black"
#pragma link "dxSkinOffice2010Blue"
#pragma link "dxSkinOffice2010Silver"
#pragma link "dxSkinsCore"
#pragma link "dxSkinscxPCPainter"
#pragma link "dxSkinSevenClassic"
#pragma link "dxSkinVS2010"
#pragma resource "*.dfm"
TOD_NikotinSecer *OD_NikotinSecer;
extern TKorisnik *myTKorisnik;
//---------------------------------------------------------------------------
__fastcall TOD_NikotinSecer::TOD_NikotinSecer(TComponent* Owner)
	: TfmOsnovnaPrazna(Owner)
{
	cxOdDatuma->Date = Date();
	cxDoDatuma->Date = Date();

	pravoDelete = DM_OD->cdsProveraSelectPRAVO_DELETE->AsInteger;
	pravoInsert = DM_OD->cdsProveraSelectPRAVO_INSERT->AsInteger;
	pravoUpdate = DM_OD->cdsProveraSelectPRAVO_UPDATE->AsInteger;
}
//---------------------------------------------------------------------------
void __fastcall TOD_NikotinSecer::btNoviDocClick(TObject *Sender)
{
	if (pravoInsert) {
		try {
			cdsProcessing->Active = false;
			dsetProcessing->ParamByName("id")->AsInteger = -1;
			cdsProcessing->Active = true;

			cdsProcessing->Append();
			btSnimi->Enabled = true;

			if(cxPageControl2->ActivePage == cxTabPolja) cxKlasa->SetFocus();

		}
		catch (Exception &e)
		{
		  ShowMessage("Greska!! "+e.Message);
		}
	}else {
		ShowMessage("Nemate prava da dodate podatke!");
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::cdsProcessingNewRecord(TDataSet *DataSet)
{
	sp_processing->Prepared = true;
	sp_processing->ExecProc();
	cdsProcessing->FieldByName("id")->AsInteger = sp_processing->ParamByName("ID")->Value;
	cdsProcessing->FieldByName("datum")->Value = Date();
	cdsProcessing->FieldByName("vreme")->Value = Time();
	cdsProcessing->FieldByName("idsmene")->AsString = "I";
	cdsProcessing->FieldByName("sifra_radnika")->AsInteger = myTKorisnik->sifra_usera;
	cdsProcessing->FieldByName("vlaga")->AsFloat = 0;
	cdsProcessing->FieldByName("temperatura")->AsFloat = 0;
	cdsProcessing->FieldByName("kolicina")->AsFloat = 0;
	cdsProcessing->FieldByName("sugar")->AsFloat = 0;
	cdsProcessing->FieldByName("nicotin")->AsFloat = 0;
	cdsProcessing->FieldByName("vrsta_transakcije")->AsInteger = 3;

	cdsProcessing->FieldByName("idgrade")->AsString = OldIdGrade;
	cdsProcessing->FieldByName("Grade")->AsString = OldGrade;
	cdsProcessing->FieldByName("idlist")->AsString = OldIdList;
	cdsProcessing->FieldByName("status")->AsString = "N";
	cdsProcessing->FieldByName("id_uzorka")->AsString = OldIdUzorka;
//	cdsProcessing->FieldByName("mesto_uzorka")->AsString = OldMesto_Uzorka;
	cdsProcessing->FieldByName("idlaboranta")->AsString = OldIdLaborant;

}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::cdsProcessingAfterPost(TDataSet *DataSet)
{
	cxStavke->NewItemRow->Visible = false;

	OldDatum = cdsProcessing->FieldByName("datum")->AsDateTime;

	OldSifraRadnika = cdsProcessing->FieldByName("sifra_radnika")->AsInteger;
	OldIdLaborant = cdsProcessing->FieldByName("idlaboranta")->AsInteger;
	OldRunday = cdsProcessing->FieldByName("runday")->AsInteger;
	OldIdBlend = cdsProcessing->FieldByName("idblend")->AsInteger;
	OldTransakcija = cdsProcessing->FieldByName("vrsta_transakcije")->AsInteger;

	OldGrade = cdsProcessing->FieldByName("grade")->AsString;
//	OldIdList = cdsProcessing->FieldByName("idlist")->AsString;
	OldIdGrade = cdsProcessing->FieldByName("idgrade")->AsString;
	OldBatch = cdsProcessing->FieldByName("batch_no")->AsString;
//	OldIdUzorka = cdsProcessing->FieldByName("id_uzorka")->AsString;
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::cdsProcessingAfterDelete(TDataSet *DataSet)
{
	if(cdsProcessing->IsEmpty()) cxStavke->NewItemRow->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::btSnimiClick(TObject *Sender)
{
	btSnimi->Enabled = SnimiCDS(dspProcessing, cdsProcessing, dsProcessing);
	if(!btSnimi->Enabled) btNoviDoc->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::cxStavkeEditKeyDown(TcxCustomGridTableView *Sender,
          TcxCustomGridTableItem *AItem, TcxCustomEdit *AEdit,
          WORD &Key, TShiftState Shift)
{
 wchar_t taster = (wchar_t) Key;

 if(Key == VK_RETURN) {
	if(AItem == cxStavkeGRADE) {
		 cxKlasa->Text = VarToStr(AEdit->EditingValue);
		 cxKlasaKeyPress(cxStavke, taster);
	}
 }
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::cxKlasaKeyPress(TObject *Sender, wchar_t &Key)
{
	AnsiString naziv;

	if(Key == VK_RETURN)
	{
		  naziv = cxKlasa->Text;

		  OD_DM_Pretraga->cdsGrade->Filter = "";
		  OD_DM_Pretraga->cdsGrade->Filtered = false;
		  OD_DM_Pretraga->cdsGrade->Active = false;
		  OD_DM_Pretraga->dsetGrade->ParamByName("opis")->AsString = UpperCase(naziv);
		  OD_DM_Pretraga->cdsGrade->Active = true;

		  if ( OD_DM_Pretraga->cdsGrade->RecordCount > 1)
       {
				TOD_Osnovna_pretrage *OD_Osnovna_pretrage = new TOD_Osnovna_pretrage(OD_DM_Pretraga->dsetGrade, OD_DM_Pretraga->dsGrade, "ID","NAZIV", this);
				OD_Osnovna_pretrage->WindowState = wsNormal;

				if(OD_Osnovna_pretrage->ShowModal() == mrOk) {
					 cdsProcessing->Edit();
					 cdsProcessing->FieldByName("IDGRADE")->AsString   = OD_DM_Pretraga->cdsGrade->FieldByName("ID")->AsString;
					 cdsProcessing->FieldByName("GRADE")->AsString = OD_DM_Pretraga->cdsGrade->FieldByName("NAZIV")->AsString;
					 cdsProcessing->Post();

					 if(Sender != cxStavke) cxBrojBatch->SetFocus();
				}

				delete OD_Osnovna_pretrage;
		  }
		  else if (OD_DM_Pretraga->cdsGrade->RecordCount == 1) {
					cdsProcessing->Edit();
					cdsProcessing->FieldByName("IDGRADE")->AsString   = OD_DM_Pretraga->cdsGrade->FieldByName("ID")->AsString;
					cdsProcessing->FieldByName("GRADE")->AsString = OD_DM_Pretraga->cdsGrade->FieldByName("NAZIV")->AsString;
					cdsProcessing->Post();

					if(Sender != cxStavke) cxBrojBatch->SetFocus();
		  }
		  else ShowMessage("Ne postoji PODATAK koji sadrzi u svom nazivu tekst: "+naziv);
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::cxDatumKeyPress(TObject *Sender, wchar_t &Key)
{
	if(Key == VK_RETURN)	cxVreme->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::cxVremeKeyPress(TObject *Sender, wchar_t &Key)
{
	if(Key == VK_RETURN)	cxKlasa->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::cxBrojBatchKeyPress(TObject *Sender, wchar_t &Key)

{
	if(Key == VK_RETURN)	cxBrojKutije->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::cxBrojKutijeKeyPress(TObject *Sender, wchar_t &Key)

{
	if(Key == VK_RETURN)	cxNikotin->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::cxNikotinKeyPress(TObject *Sender, wchar_t &Key)

{
	if(Key == VK_RETURN)	cxSecer->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::cxSecerKeyPress(TObject *Sender, wchar_t &Key)
{
	if(Key == VK_RETURN)	btSnimi->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::btnPregledClick(TObject *Sender)
{
	cdsZaglavlje->Active = false;
	dsetZaglavlje->ParamByName("od_datuma")->Value = cxOdDatuma->Date;
	dsetZaglavlje->ParamByName("do_datuma")->Value = cxDoDatuma->Date;
	dsetZaglavlje->ParamByName("id_transakcije")->AsInteger = 3;
	cdsZaglavlje->Active = true;
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::cdsProcessingAfterInsert(TDataSet *DataSet)
{
	btSnimi->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::cdsProcessingAfterEdit(TDataSet *DataSet)
{
	btSnimi->Enabled = true;
}
//---------------------------------------------------------------------------


void __fastcall TOD_NikotinSecer::btSnimiKeyPress(TObject *Sender, wchar_t &Key)
{
 if(btSnimi->Enabled) {
	if(Key == VK_RETURN)	{
			btSnimi->Enabled = SnimiCDS(dspProcessing, cdsProcessing, dsProcessing);
			btNoviDoc->SetFocus();
	}
 }
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::Izmeni1Click(TObject *Sender)
{
	if(pravoUpdate){
		cdsProcessing->Active = false;
		dsetProcessing->ParamByName("id")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
		cdsProcessing->Active = true;

		cxPC->ActivePage = cxTabUnos;
		btSnimi->Enabled = true;
	}else {
		ShowMessage("Nemate prava da menjate podatke!");
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::Obrisi1Click(TObject *Sender)
{
  if (pravoDelete) {
     TTransactionDesc TD;
      int greska;
     
     try {
     
     	TD.TransactionID = 1;
     	TD.IsolationLevel = 0;// xilREADCOMMITTED;  //xilREADCOMMITTED
     
       if (!DM_OD->SC_OD->InTransaction)  {
     
     	DM_OD->SC_OD->StartTransaction(TD);
     
        if(MessageBoxA(Handle,"Da li ste sigurni da zelite da nastavite?", "Brisanje ", MB_YESNO) == IDYES)
     	 {
     			 qDelete->ParamByName("id")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
     		 qDelete->ExecSQL();
     
     			 if (greska <= 0) btnPregled->Click();
     	 }
     
     	if (DM_OD->SC_OD->InTransaction) DM_OD->SC_OD->Commit(TD);
       }
     }
     catch(Exception &e) {
       if (DM_OD->SC_OD->InTransaction) DM_OD->SC_OD->Rollback(TD);
	   ShowMessage("Greska: "+e.Message);
     }    
 }else {
 	ShowMessage("Nemate prava da brisete podatke!");
 }
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::dspProcessingBeforeUpdateRecord(TObject *Sender,
          TDataSet *SourceDS, TCustomClientDataSet *DeltaDS, TUpdateKind UpdateKind,
          bool &Applied)
{
if (UpdateKind == ukInsert) {
		if (!pravoInsert) {
			Applied = true;
			ShowMessage("Nemate pravo da dodate nove podatke!");
			if(cdsProcessing->Active == true) {
				if(cdsProcessing->ChangeCount == 0)
					cdsProcessing->Refresh();
				else {
					cdsProcessing->Active = false;
					cdsProcessing->Active = true;
                }
            }
		}

	}else if (UpdateKind == ukModify) {
		if (!pravoUpdate) {
			Applied = true;
			ShowMessage("Nemate pravo da menjate postojece podatke!");
			if(cdsProcessing->Active == true) {
				if(cdsProcessing->ChangeCount == 0)
					cdsProcessing->Refresh();
				else {
					cdsProcessing->Active = false;
					cdsProcessing->Active = true;
                }
			}
		}

	}else if (UpdateKind == ukDelete) {
		if (!pravoDelete) {
			Applied = true;
			ShowMessage("Nemate pravo da brisete postojece podatke!");
			if(cdsProcessing->Active == true) {
				if(cdsProcessing->ChangeCount == 0)
					cdsProcessing->Refresh();
				else {
					cdsProcessing->Active = false;
					cdsProcessing->Active = true;
                }
            }
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_NikotinSecer::FormCreate(TObject *Sender)
{
//	fmOsnovnaPrazna->podesiPrava("OD_SadrzajNikotinaSecera");
}
//---------------------------------------------------------------------------

