//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OD_VlagaPrasina.h"
#include "OD_DM.h"
#include "OD_funkcije.h"
#include "OD_DmPretraga.h"
#include "OD_PretragaPodataka.h"
#include "OD_glavna.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cxControls"
#pragma link "cxGraphics"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxPC"
#pragma link "OD_OsnovnaPrazna"
#pragma link "cxButtons"
#pragma link "cxCalendar"
#pragma link "cxContainer"
#pragma link "cxDBEdit"
#pragma link "cxDropDownEdit"
#pragma link "cxEdit"
#pragma link "cxLabel"
#pragma link "cxMaskEdit"
#pragma link "cxTextEdit"
#pragma link "cxClasses"
#pragma link "cxCustomData"
#pragma link "cxData"
#pragma link "cxDataStorage"
#pragma link "cxDBData"
#pragma link "cxFilter"
#pragma link "cxGrid"
#pragma link "cxGridCustomTableView"
#pragma link "cxGridCustomView"
#pragma link "cxGridDBTableView"
#pragma link "cxGridLevel"
#pragma link "cxGridTableView"
#pragma link "cxStyles"
#pragma link "frxClass"
#pragma link "frxDBSet"
#pragma link "cxSpinEdit"
#pragma link "cxTimeEdit"
#pragma resource "*.dfm"
TOD_EvidencijaVlagePrasine *OD_EvidencijaVlagePrasine;
extern AnsiString DIR_STAMPE;
extern TKorisnik *myTKorisnik;
//---------------------------------------------------------------------------
__fastcall TOD_EvidencijaVlagePrasine::TOD_EvidencijaVlagePrasine(TComponent* Owner)
	: TfmOsnovnaPrazna(Owner)
{
	cxOdDatuma->Date = Date();
	cxDoDatuma->Date = Date();

	OldDatum = Date();

	OldSifraRadnika = 10;
	OldIdLaborant = 10;
	OldLaborant = "";
	OldRunday = 1;
	OldIdBlend = 0;
	OldIdTransakcija = 1;

	OldIdsmene = "I";
	OldIdList =  "";
	OldIdGrade = "";
	OldBatch =   "";
	OldIdUzorka = "";
	OldMesto_Uzorka = "";
	OldSmena =        "";
	OldTransakcija =  1;
	OldGrade =        "";
	OldList =         "";

	pravoDelete = DM_OD->cdsProveraSelectPRAVO_DELETE->AsInteger;
	pravoInsert = DM_OD->cdsProveraSelectPRAVO_INSERT->AsInteger;
	pravoUpdate = DM_OD->cdsProveraSelectPRAVO_UPDATE->AsInteger;

}
//---------------------------------------------------------------------------
void __fastcall TOD_EvidencijaVlagePrasine::cdsProcessingNewRecord(TDataSet *DataSet)

{
	sp_processing->Prepared = true;
	sp_processing->ExecProc();
	cdsProcessing->FieldByName("id")->AsInteger = sp_processing->ParamByName("ID")->Value;
	cdsProcessing->FieldByName("datum")->Value = OldDatum;
	cdsProcessing->FieldByName("vreme")->Value = Time();
	cdsProcessing->FieldByName("idsmene")->AsString = OldIdsmene;
	cdsProcessing->FieldByName("idblend")->AsInteger = OldIdBlend;
	cdsProcessing->FieldByName("sifra_radnika")->AsInteger = myTKorisnik->sifra_usera;
	cdsProcessing->FieldByName("vlaga")->AsFloat = 0;
	cdsProcessing->FieldByName("temperatura")->AsFloat = 0;
	cdsProcessing->FieldByName("kolicina")->AsFloat = 0;
	cdsProcessing->FieldByName("vrsta_transakcije")->AsInteger = 1;
	cdsProcessing->FieldByName("runday")->AsInteger = OldRunday;

	cdsProcessing->FieldByName("idgrade")->AsString = OldIdGrade;
	cdsProcessing->FieldByName("idlist")->AsString = OldIdList;
	cdsProcessing->FieldByName("id_uzorka")->AsString = OldIdUzorka;

	cdsProcessing->FieldByName("Transakcija")->AsString = OldTransakcija;
	cdsProcessing->FieldByName("Grade")->AsString = OldGrade;
	cdsProcessing->FieldByName("List")->AsString = OldList;
	cdsProcessing->FieldByName("mesto_uzorka")->AsString = OldMesto_Uzorka;
	cdsProcessing->FieldByName("Smena")->AsString = OldSmena;
	cdsProcessing->FieldByName("status")->AsString = "N";
	/*
	cdsProcessing->FieldByName("idlaboranta")->AsString = OldIdLaborant;
	cdsProcessing->FieldByName("laborant")->AsString = OldLaborant;
	*/
}
//---------------------------------------------------------------------------


void __fastcall TOD_EvidencijaVlagePrasine::btSnimiClick(TObject *Sender)
{
	btSnimi->Enabled = SnimiCDS(dspProcessing, cdsProcessing, dsProcessing);
	if(!btSnimi->Enabled) btNoviDoc->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::btNoviDocClick(TObject *Sender)
{
	if (pravoInsert) {
		try {
			cdsProcessing->Active = false;
			dsetProcessing->ParamByName("id")->AsInteger = -1;
			cdsProcessing->Active = true;

			cdsProcessing->Append();
			btSnimi->Enabled = true;

			cxDatum->SetFocus();
		}
		catch (Exception &e)
		{
		  ShowMessage("Greska!! "+e.Message);
		}
	}else {
		ShowMessage("Nemate prava da dodate podatke!");
	}
}
//---------------------------------------------------------------------------




void __fastcall TOD_EvidencijaVlagePrasine::cdsProcessingAfterDelete(TDataSet *DataSet)
{
	if(cdsProcessing->IsEmpty()) cxStavke->NewItemRow->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::cxSmenaKeyPress(TObject *Sender, wchar_t &Key)

{
	AnsiString naziv;

	if(Key == VK_RETURN)
	{
		  naziv = cxSmena->Text;

		  OD_DM_Pretraga->cdsSmene->Filter = "";
		  OD_DM_Pretraga->cdsSmene->Filtered = false;
		  OD_DM_Pretraga->cdsSmene->Active = false;
		  OD_DM_Pretraga->dsetSmene->ParamByName("opis")->AsString = UpperCase(naziv);
		  OD_DM_Pretraga->cdsSmene->Active = true;

		  if ( OD_DM_Pretraga->cdsSmene->RecordCount > 1)
       {
				TOD_Osnovna_pretrage *OD_Osnovna_pretrage = new TOD_Osnovna_pretrage(OD_DM_Pretraga->dsetSmene, OD_DM_Pretraga->dsSmene, "ID","NAZIV", this);
				OD_Osnovna_pretrage->WindowState = wsNormal;

				if(OD_Osnovna_pretrage->ShowModal() == mrOk) {
					 cdsProcessing->Edit();
					 cdsProcessing->FieldByName("IDSMENE")->AsString   = OD_DM_Pretraga->cdsSmene->FieldByName("ID")->AsString;
					 cdsProcessing->FieldByName("SMENA")->AsString = OD_DM_Pretraga->cdsSmene->FieldByName("NAZIV")->AsString;
					 cdsProcessing->Post();

					 if(Sender != cxStavke) cxM_uzorka->SetFocus();
				}

				delete OD_Osnovna_pretrage;
		  }
		  else if (OD_DM_Pretraga->cdsSmene->RecordCount == 1) {
					cdsProcessing->Edit();
					cdsProcessing->FieldByName("IDSMENE")->AsString   = OD_DM_Pretraga->cdsSmene->FieldByName("ID")->AsString;
					cdsProcessing->FieldByName("SMENA")->AsString = OD_DM_Pretraga->cdsSmene->FieldByName("NAZIV")->AsString;
					cdsProcessing->Post();

					if(Sender != cxStavke) cxM_uzorka->SetFocus();
       }
       else ShowMessage("Ne postoji PODATAK koji sadrzi u svom nazivu tekst: "+naziv);
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::cxM_uzorkaKeyPress(TObject *Sender, wchar_t &Key)

{
	AnsiString naziv;

	if(Key == VK_RETURN)
	{
		  naziv = cxM_uzorka->Text;

		  OD_DM_Pretraga->cds_MUzorka->Filter = "";
		  OD_DM_Pretraga->cds_MUzorka->Filtered = false;
		  OD_DM_Pretraga->cds_MUzorka->Active = false;
		  OD_DM_Pretraga->dset_MUzorka->ParamByName("opis")->AsString = UpperCase(naziv.SubString(1,10));
		  OD_DM_Pretraga->cds_MUzorka->Active = true;

		  if ( OD_DM_Pretraga->cds_MUzorka->RecordCount > 1)
       {
				TOD_Osnovna_pretrage *OD_Osnovna_pretrage = new TOD_Osnovna_pretrage(OD_DM_Pretraga->dset_MUzorka, OD_DM_Pretraga->ds_MUzorka, "ID","NAZIV", this);
				OD_Osnovna_pretrage->WindowState = wsNormal;

				if(OD_Osnovna_pretrage->ShowModal() == mrOk) {
					 cdsProcessing->Edit();
					 cdsProcessing->FieldByName("ID_UZORKA")->AsString   = OD_DM_Pretraga->cds_MUzorka->FieldByName("ID")->AsString;
					 cdsProcessing->FieldByName("MESTO_UZORKA")->AsString = OD_DM_Pretraga->cds_MUzorka->FieldByName("NAZIV")->AsString;
					 cdsProcessing->Post();

					 if(Sender != cxStavke) cxVlaga->SetFocus();
				}

				delete OD_Osnovna_pretrage;
		  }
		  else if (OD_DM_Pretraga->cds_MUzorka->RecordCount == 1) {
					cdsProcessing->Edit();
					cdsProcessing->FieldByName("ID_UZORKA")->AsString   = OD_DM_Pretraga->cds_MUzorka->FieldByName("ID")->AsString;
					cdsProcessing->FieldByName("MESTO_UZORKA")->AsString = OD_DM_Pretraga->cds_MUzorka->FieldByName("NAZIV")->AsString;
					cdsProcessing->Post();

					if(Sender != cxStavke) cxVlaga->SetFocus();
		  }
       else ShowMessage("Ne postoji PODATAK koji sadrzi u svom nazivu tekst: "+naziv);
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::cxKlasaKeyPress(TObject *Sender, wchar_t &Key)

{
	AnsiString naziv;

	if(Key == VK_RETURN)
	{
		  naziv = cxKlasa->Text;

		  OD_DM_Pretraga->cdsGrade->Filter = "";
		  OD_DM_Pretraga->cdsGrade->Filtered = false;
		  OD_DM_Pretraga->cdsGrade->Active = false;
		  OD_DM_Pretraga->dsetGrade->ParamByName("opis")->AsString = UpperCase(naziv);
		  OD_DM_Pretraga->cdsGrade->Active = true;

		  if ( OD_DM_Pretraga->cdsGrade->RecordCount > 1)
       {
				TOD_Osnovna_pretrage *OD_Osnovna_pretrage = new TOD_Osnovna_pretrage(OD_DM_Pretraga->dsetGrade, OD_DM_Pretraga->dsGrade, "ID","NAZIV", this);
				OD_Osnovna_pretrage->WindowState = wsNormal;

				if(OD_Osnovna_pretrage->ShowModal() == mrOk) {
					 cdsProcessing->Edit();
					 cdsProcessing->FieldByName("IDGRADE")->AsString   = OD_DM_Pretraga->cdsGrade->FieldByName("ID")->AsString;
					 cdsProcessing->FieldByName("GRADE")->AsString = OD_DM_Pretraga->cdsGrade->FieldByName("NAZIV")->AsString;
					 cdsProcessing->Post();

					 if(Sender != cxStavke) cxRun->SetFocus();
				}

				delete OD_Osnovna_pretrage;
		  }
		  else if (OD_DM_Pretraga->cdsGrade->RecordCount == 1) {
					cdsProcessing->Edit();
					cdsProcessing->FieldByName("IDGRADE")->AsString   = OD_DM_Pretraga->cdsGrade->FieldByName("ID")->AsString;
					cdsProcessing->FieldByName("GRADE")->AsString = OD_DM_Pretraga->cdsGrade->FieldByName("NAZIV")->AsString;
					cdsProcessing->Post();

					if(Sender != cxStavke) cxRun->SetFocus();
       }
       else ShowMessage("Ne postoji PODATAK koji sadrzi u svom nazivu tekst: "+naziv);
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::cxListKeyPress(TObject *Sender, wchar_t &Key)

{
	AnsiString naziv;

	if(Key == VK_RETURN)
	{
		  naziv = cxList->Text;

		  OD_DM_Pretraga->cdsList->Filter = "";
		  OD_DM_Pretraga->cdsList->Filtered = false;
		  OD_DM_Pretraga->cdsList->Active = false;
		  OD_DM_Pretraga->dsetList->ParamByName("opis")->AsString = UpperCase(naziv);
		  OD_DM_Pretraga->cdsList->Active = true;

		  if ( OD_DM_Pretraga->cdsList->RecordCount > 1)
       {
				TOD_Osnovna_pretrage *OD_Osnovna_pretrage = new TOD_Osnovna_pretrage(OD_DM_Pretraga->dsetList, OD_DM_Pretraga->dsList, "ID","NAZIV", this);
				OD_Osnovna_pretrage->WindowState = wsNormal;

				if(OD_Osnovna_pretrage->ShowModal() == mrOk) {
					 cdsProcessing->Edit();
					 cdsProcessing->FieldByName("IDLIST")->AsString   = OD_DM_Pretraga->cdsList->FieldByName("ID")->AsString;
					 cdsProcessing->FieldByName("LIST")->AsString = OD_DM_Pretraga->cdsList->FieldByName("NAZIV")->AsString;
					 cdsProcessing->Post();

					 if(Sender != cxStavke) cxM_uzorka->SetFocus();
				}

				delete OD_Osnovna_pretrage;
		  }
		  else if (OD_DM_Pretraga->cdsList->RecordCount == 1) {
					cdsProcessing->Edit();
					cdsProcessing->FieldByName("IDLIST")->AsString   = OD_DM_Pretraga->cdsList->FieldByName("ID")->AsString;
					cdsProcessing->FieldByName("LIST")->AsString = OD_DM_Pretraga->cdsList->FieldByName("NAZIV")->AsString;
					cdsProcessing->Post();

					if(Sender != cxStavke) cxM_uzorka->SetFocus();
       }
       else ShowMessage("Ne postoji PODATAK koji sadrzi u svom nazivu tekst: "+naziv);
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::cxStavkeEditKeyDown(TcxCustomGridTableView *Sender,
			  TcxCustomGridTableItem *AItem, TcxCustomEdit *AEdit,
			  WORD &Key, TShiftState Shift)
{
 wchar_t taster = (wchar_t) Key;

 if(Key == VK_RETURN) {
	if(AItem == cxStavkeSMENA) {
		 cxSmena->Text = VarToStr(AEdit->EditingValue);
		 cxSmenaKeyPress(cxStavke, taster);
	}
	else if(AItem == cxStavkeMESTO_UZORKA) {
		 cxM_uzorka->Text = VarToStr(AEdit->EditingValue);
		 cxM_uzorkaKeyPress(cxStavke, taster);
	}
	else if(AItem == cxStavkeGRADE) {
		 cxKlasa->Text = VarToStr(AEdit->EditingValue);
		 cxKlasaKeyPress(cxStavke, taster);
	}
	else if(AItem == cxStavkeLIST) {
		 cxList->Text = VarToStr(AEdit->EditingValue);
		 cxListKeyPress(cxStavke, taster);
	}
 }
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::cdsProcessingAfterPost(TDataSet *DataSet)

{
	cxStavke->NewItemRow->Visible = false;

	OldDatum = cdsProcessing->FieldByName("datum")->AsDateTime;

	OldSifraRadnika = cdsProcessing->FieldByName("sifra_radnika")->AsInteger;
	//OldIdLaborant = cdsProcessing->FieldByName("idlaborant")->AsInteger;
	OldRunday = cdsProcessing->FieldByName("runday")->AsInteger;
	OldIdBlend = cdsProcessing->FieldByName("idblend")->AsInteger;
	OldTransakcija = cdsProcessing->FieldByName("vrsta_transakcije")->AsInteger;

	OldIdsmene = cdsProcessing->FieldByName("idsmene")->AsString;
	OldIdList = cdsProcessing->FieldByName("idlist")->AsString;
	OldIdGrade = cdsProcessing->FieldByName("idgrade")->AsString;
	OldBatch = cdsProcessing->FieldByName("batch_no")->AsString;
	OldIdUzorka = cdsProcessing->FieldByName("id_uzorka")->AsString;

	OldTransakcija = cdsProcessing->FieldByName("Transakcija")->AsString;
	OldGrade = cdsProcessing->FieldByName("Grade")->AsString;
	OldList = cdsProcessing->FieldByName("List")->AsString;
	OldMesto_Uzorka = cdsProcessing->FieldByName("mesto_uzorka")->AsString;
	OldSmena = cdsProcessing->FieldByName("Smena")->AsString;

}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::btnPregledClick(TObject *Sender)
{
	cdsZaglavlje->Active = false;
	dsetZaglavlje->ParamByName("od_datuma")->Value = cxOdDatuma->Date;
	dsetZaglavlje->ParamByName("do_datuma")->Value = cxDoDatuma->Date;
	dsetZaglavlje->ParamByName("id_transakcije")->AsInteger = 1;
	cdsZaglavlje->Active = true;
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::Obrisi1Click(TObject *Sender)
{
	if (pravoDelete) {
		 try {
			sqlObrisi->ParamByName("status")->AsString = "D";
			sqlObrisi->ParamByName("idp")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
			sqlObrisi->ExecSQL();
		 }
		 catch (Exception &e)
		 {
			  ShowMessage("Greska!! "+e.Message);
		 }
	}else {
		ShowMessage("Nemate prava da brisete podatke!");
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::cxButton1Click(TObject *Sender)
{
	if(frxR->LoadFromFile(DIR_STAMPE+"\\StampaLeaf\\od_vlaga_prasine.fr3")) {
				frxR->ShowReport();
	}
	else ShowMessage("Ne postoji fajl: od_vlaga_prasine.fr3");
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::cxDatumKeyPress(TObject *Sender, wchar_t &Key)

{
	if(Key == VK_RETURN)	cxVreme->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::cxVremeKeyPress(TObject *Sender, wchar_t &Key)

{
if(Key == VK_RETURN)	cxKlasa->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::cxRunKeyPress(TObject *Sender, wchar_t &Key)

{
if(Key == VK_RETURN)	cxSmena->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::cxVlagaKeyPress(TObject *Sender, wchar_t &Key)

{
if(Key == VK_RETURN)	btSnimi->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::cdsProcessingAfterEdit(TDataSet *DataSet)

{
btSnimi->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::cdsProcessingAfterInsert(TDataSet *DataSet)

{
btSnimi->Enabled = true;
}
//---------------------------------------------------------------------------



void __fastcall TOD_EvidencijaVlagePrasine::btSnimiKeyPress(TObject *Sender, wchar_t &Key)

{
 if(btSnimi->Enabled) {
	if(Key == VK_RETURN)	{
			btSnimi->Enabled = SnimiCDS(dspProcessing, cdsProcessing, dsProcessing);
			btNoviDoc->SetFocus();
	}
 }
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::Izmeni1Click(TObject *Sender)
{
	if (pravoUpdate) {
		cdsProcessing->Active = false;
		dsetProcessing->ParamByName("id")->AsInteger = cdsZaglavlje->FieldByName("id")->AsInteger;
		cdsProcessing->Active = true;

		cxPC->ActivePage = cxTabUnos;
		btSnimi->Enabled = true;
	}else {
		ShowMessage("Nemate prava da menjate podatke!");
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::dspProcessingBeforeUpdateRecord(TObject *Sender,
          TDataSet *SourceDS, TCustomClientDataSet *DeltaDS, TUpdateKind UpdateKind,
          bool &Applied)
{

	if (UpdateKind == ukInsert) {
		if (!pravoInsert) {
			Applied = true;
			ShowMessage("Nemate pravo da dodate nove podatke!");
			if(cdsProcessing->Active == true) {
				if(cdsProcessing->ChangeCount == 0)
					cdsProcessing->Refresh();
				else {
					cdsProcessing->Active = false;
					cdsProcessing->Active = true;
                }
            }
		}

	}else if (UpdateKind == ukModify) {
		if (!pravoUpdate) {
			Applied = true;
			ShowMessage("Nemate pravo da menjate postojece podatke!");
			if(cdsProcessing->Active == true) {
				if(cdsProcessing->ChangeCount == 0)
					cdsProcessing->Refresh();
				else {
					cdsProcessing->Active = false;
					cdsProcessing->Active = true;
                }
			}
		}

	}else if (UpdateKind == ukDelete) {
		if (!pravoDelete) {
			Applied = true;
			ShowMessage("Nemate pravo da brisete postojece podatke!");
			if(cdsProcessing->Active == true) {
				if(cdsProcessing->ChangeCount == 0)
					cdsProcessing->Refresh();
				else {
					cdsProcessing->Active = false;
					cdsProcessing->Active = true;
                }
            }
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TOD_EvidencijaVlagePrasine::FormCreate(TObject *Sender)
{
//	fmOsnovnaPrazna->podesiPrava("OD_VlagaPrasina");
}
//---------------------------------------------------------------------------

