// ---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OD_ObradaDuvanaPressa2.h"
#include "OD_DM.h"
#include "fmMessageRed.h"
#include "OD_funkcije.h"
#include "OD_PraznjenjeSilosa.h"
// ---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "BUS_osnovna_prazna"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxDBEdit"
#pragma link "cxDBLookupComboBox"
#pragma link "cxDBLookupEdit"
#pragma link "cxDropDownEdit"
#pragma link "cxEdit"
#pragma link "cxGraphics"
#pragma link "cxLabel"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxLookupEdit"
#pragma link "cxMaskEdit"
#pragma link "cxTextEdit"
#pragma link "cxGroupBox"
#pragma link "cxCalendar"
#pragma link "cxPC"
#pragma link "cxButtons"
#pragma link "cxClasses"
#pragma link "cxCustomData"
#pragma link "cxData"
#pragma link "cxDataStorage"
#pragma link "cxDBData"
#pragma link "cxFilter"
#pragma link "cxGrid"
#pragma link "cxGridCustomTableView"
#pragma link "cxGridCustomView"
#pragma link "cxGridDBTableView"
#pragma link "cxGridLevel"
#pragma link "cxGridTableView"
#pragma link "cxStyles"
#pragma link "frxClass"
#pragma link "frxDBSet"
#pragma link "frxBarcode"
#pragma link "cxCheckBox"
#pragma link "cxSplitter"
#pragma link "cxDateUtils"
#pragma link "cxNavigator"
#pragma link "cxPCdxBarPopupMenu"
#pragma link "dxCore"
#pragma link "dxSkinBlack"
#pragma link "dxSkinBlue"
#pragma link "dxSkinDevExpressDarkStyle"
#pragma link "dxSkinDevExpressStyle"
#pragma link "dxSkinFoggy"
#pragma link "dxSkinOffice2010Black"
#pragma link "dxSkinOffice2010Blue"
#pragma link "dxSkinOffice2010Silver"
#pragma link "dxSkinsCore"
#pragma link "dxSkinscxPCPainter"
#pragma link "dxSkinSevenClassic"
#pragma link "dxSkinVS2010"
#pragma resource "*.dfm"
TODObradaPressa2* ODObradaPressa2;
extern AnsiString DIR_STAMPE;
extern int MAGACIN_BUFFER;
extern int DOC_PROIZVODNJE;
extern TKorisnik* myTKorisnik;

// extern "C" __declspec(dllimport) double MerenjeTezineVaga(int a, AnsiString Vaga, TSQLConnection *SC);
// ---------------------------------------------------------------------------
__fastcall TODObradaPressa2::TODObradaPressa2(TComponent* Owner)
	:TfmOsnovna_prazna(Owner)
{
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::FormClose(TObject* Sender, TCloseAction& Action)

{
	Action = caFree;
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::Action1Execute(TObject* Sender)
{
	btNoviDoc->Click();
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::Action2Execute(TObject* Sender)
{
	btStampaj->Click();
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::cdsObradaGPNewRecord(TDataSet* DataSet)
{
	try
	{
		spObradaGP->Prepared = true;
		spObradaGP->ExecProc();
		cdsObradaGP->FieldByName("id")->AsInteger = spObradaGP->ParamByName("ID")->Value;
		cdsObradaGP->FieldByName("DATUM")->AsDateTime = Now();
		cdsObradaGP->FieldByName("DATUM_OBRADE")->AsDateTime = Now() - DM_OD->cdsSystemOD->FieldByName("start_radni_dan")->AsDateTime;
		cdsObradaGP->FieldByName("DATUM_ETIKETE")->AsDateTime = cdsObradaGP->FieldByName("DATUM_OBRADE")->AsDateTime;
		cdsObradaGP->FieldByName("DEALER")->AsString = cdsEtiketa->FieldByName("DEALER")->AsString;
		cdsObradaGP->FieldByName("crop")->AsInteger = cdsEtiketa->FieldByName("BERBA")->AsInteger;
		cdsObradaGP->FieldByName("ORIGIN")->AsString = cdsEtiketa->FieldByName("ORIGIN")->AsString;
		cdsObradaGP->FieldByName("sap_batch")->AsString = StrToIntDef(cdsList->FieldByName("sap_batch")->AsString, 0);
		cdsObradaGP->FieldByName("deleted")->AsInteger = 0;
		cdsObradaGP->FieldByName("zaprimljena")->AsInteger = 0;
		cdsObradaGP->FieldByName("blokiraj")->AsInteger = 1;
		cdsObradaGP->FieldByName("sifra_radnika")->AsInteger = myTKorisnik->sifra_usera;

		// sqlBrojBarkoda->Active = false;
		// sqlBrojBarkoda->ParamByName("crop")->AsInteger = cdsObradaGP->FieldByName("crop")->AsInteger;
		// sqlBrojBarkoda->Active = true;
		//
		// cdsObradaGP->FieldByName("BARKOD")->AsInteger  = sqlBrojBarkoda->FieldByName("BrojKutije")->AsInteger+1;
	}
	catch (Exception& e)
	{
		ShowMyMessageRed->Show("Greska!! " + e.Message, 0x00FFDDFF);
	}
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::cdsObradaGPNETOChange(TField* Sender)
{
	cdsObradaGP->FieldByName("BRUTO")->AsCurrency = cdsObradaGP->FieldByName("NETO")->AsCurrency + cdsObradaGP->FieldByName("TARA")->AsCurrency;
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::btNoviDocClick(TObject* Sender)
{
	if (pravoInsert)
	{
		try
		{
			cdsObradaGP->Active = false;
			dsetObradaGP->ParamByName("id")->AsInteger = -1;
			cdsObradaGP->Active = true;

			cdsObradaGP->Append();
			cdsObradaGP->Post();

			// NovoZaglavljePrijemnice();

			btSnimi->Enabled = true;

			// if(cxPocetakMerenja->Tag == 1) TimerNoviGP->Enabled = true;

			IzmenaPodataka      = false;
			cxStampaGP->Enabled = !IzmenaPodataka;
			btStampaj->Enabled  = !IzmenaPodataka;
		  //	btSnimi->Visible    = IzmenaPodataka;
		}
		catch (Exception& e)
		{
			ShowMyMessageRed->Show("Greska!! " + e.Message, 0x00FFDDFF);
			btSnimi->Enabled = false;
		}
	}
	else
	{
		ShowMessage("Nemate prava da dodate podatke!");
	}
}

// ---------------------------------------------------------------------------
void TODObradaPressa2::NovoZaglavljePrijemnice()
{
	int id = -1;

	sqlOtvorenaPrijemnicaNaDan->Active = false;
	sqlOtvorenaPrijemnicaNaDan->ParamByName("mg")->AsInteger = 11; // Cooling
	sqlOtvorenaPrijemnicaNaDan->ParamByName("doc")->AsInteger = 6002;
	sqlOtvorenaPrijemnicaNaDan->ParamByName("datum")->Value = cdsObradaGP->FieldByName("DATUM")->AsDateTime;
	sqlOtvorenaPrijemnicaNaDan->Active = true;

	if (sqlOtvorenaPrijemnicaNaDan->FieldByName("broj_prijemnica")->AsInteger > 0)
		id = sqlOtvorenaPrijemnicaNaDan->FieldByName("id")->AsInteger;
	else
		id = -1;

	try
	{
		if (id == -1)
		{
			cdsMG_ZG->Active = false;
			dsetMG_ZG->ParamByName("id")->AsInteger = -1;
			cdsMG_ZG->Active = true;

			cdsMG_ZG->Append();
			cdsMG_ZG->Post();

			cdsMG_STAV->Active = false;
			dsetMG_STAV->ParamByName("idz")->AsInteger = cdsMG_ZG->FieldByName("id")->AsInteger;
			cdsMG_STAV->Active = true;
		}
		else
		{
			cdsMG_ZG->Active = false;
			dsetMG_ZG->ParamByName("id")->AsInteger = id;
			cdsMG_ZG->Active = true;

			cdsMG_STAV->Active = false;
			dsetMG_STAV->ParamByName("idz")->AsInteger = cdsMG_ZG->FieldByName("id")->AsInteger;
			cdsMG_STAV->Active = true;
		}
		cdsBalaMG->Active = false;
		cdsBalaMG->Active = true;
	}
	catch (Exception& e)
	{
		ShowMessage("Nemogu da otvorim novi zapis!! " + e.Message);
	}
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::FormCreate(TObject* Sender)
{
	cxSplitter1->CloseSplitter();
	cdsList->Active    = true;
	cdsEtiketa->Active = true;

	cxOdDatuma->Date     = Date();
	cxDoDatuma->Date     = Now();
	cxDatumPrijema->Date = Date();

	cdsDokumenti->Active = false;
	sdsDokumenti->ParamByName("tip1")->AsInteger = 0;
	sdsDokumenti->ParamByName("tip2")->AsInteger = 9;
	cdsDokumenti->Active = true;

	cdsMagacin->Active = false;
	dsetMagacin->ParamByName("robno")->AsInteger = 1;
	cdsMagacin->Active = true;
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::cdsObradaGPSAP_BATCHChange(TField* Sender)
{
	cdsObradaGP->FieldByName("GRADE")->AsString = cdsList->FieldByName("OZNAKA")->AsString;
	cdsObradaGP->FieldByName("MOPI")->AsString = cdsList->FieldByName("MO_PI")->AsString;
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::cdsObradaGPGRADEChange(TField* Sender)
{
	sqlCaseNo->Active = false;
	sqlCaseNo->ParamByName("grade")->AsString = cdsObradaGP->FieldByName("grade")->AsString;
	sqlCaseNo->ParamByName("crop")->AsInteger = cdsObradaGP->FieldByName("crop")->AsInteger;
	sqlCaseNo->ParamByName("dealer")->AsString = cdsEtiketa->FieldByName("DEALER")->AsString;
	sqlCaseNo->Active = true;

	sqlCaseUK->Active = false;
	sqlCaseUK->ParamByName("grade")->AsString = cdsObradaGP->FieldByName("grade")->AsString;
	sqlCaseUK->ParamByName("crop")->AsInteger = cdsObradaGP->FieldByName("crop")->AsInteger;
	sqlCaseUK->ParamByName("dealer")->AsString = cdsEtiketa->FieldByName("DEALER")->AsString;
	sqlCaseUK->Active = true;

	cdsObradaGP->FieldByName("case_no")->AsInteger = sqlCaseNo->FieldByName("BrojKutijeGrade")->AsInteger + 1;
	cdsObradaGP->FieldByName("case_uk")->AsInteger = sqlCaseUK->FieldByName("BROJKUTIJAUK")->AsInteger + 1;

	sqlIntBatch->Active = false;
	sqlIntBatch->ParamByName("status_batcha")->AsInteger = cdsList->FieldByName("BATCH")->AsInteger;
	sqlIntBatch->ParamByName("mg")->AsInteger = MAGACIN_BUFFER;
	sqlIntBatch->ParamByName("doc")->AsInteger = DOC_PROIZVODNJE;
	sqlIntBatch->Active = true;

	// if(sqlIntBatch->FieldByName("broj_batcha")->AsInteger == 0) {
	// ShowMyMessageRed->Show("Proverite sa SUPERVIZOROM da li postoje batch-evi u stanju U SILOSU ili NA PAKOVANJU!!", 0x00CCF8F9);
	// }

	cdsObradaGP->FieldByName("BATCH_NO")->AsInteger = sqlIntBatch->FieldByName("broj_batcha")->AsInteger;
	cdsObradaGP->FieldByName("ID_BLENDA")->AsInteger = sqlIntBatch->FieldByName("idblend")->AsInteger;
	cdsObradaGP->FieldByName("IDZG")->AsInteger = sqlIntBatch->FieldByName("IDZG")->AsInteger;
	cdsObradaGP->FieldByName("IDOZBLENDA")->AsInteger = cdsList->FieldByName("DOZNAKA")->AsInteger;
	cdsObradaGP->FieldByName("NETO")->AsCurrency = cdsList->FieldByName("neto_amb")->AsCurrency;
	cdsObradaGP->FieldByName("TARA")->AsCurrency = cdsList->FieldByName("tara_amb")->AsCurrency;
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::btSnimiClick(TObject* Sender)
{ /*
	 try {
	 cdsObradaGP->Edit();
	 cdsObradaGP->FieldByName("DATUM")->AsDateTime=Now();
	 cdsObradaGP->Post();
	 }
	 catch(Exception &e) {
	 ShowMyMessageRed->Show("Vreme stampanja nije uspesno upisano!! \r\rEtiketa nije snimljena!!", 0x00FFDDFF);
	 return;
	 } */
	cdsObradaGP->Edit();
	// cdsObradaGP->FieldByName("tezina")->AsFloat = StrToFloat(cxTezina->Text);
	cdsObradaGP->FieldByName("BARKOD")->AsInteger = BarkodInt();
	cdsObradaGP->FieldByName("DATUM_ETIKETE")->AsDateTime = Now();
	cdsObradaGP->FieldByName("DATUM_OBRADE")->AsDateTime = Now();
	cdsObradaGP->Post();

	btSnimi->Enabled = SnimiCDS(dspObradaGP, cdsObradaGP, dsObradaGP);

	if (Sender==btSnimi)
	btNoviDoc->Click();
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::cxPregledClick(TObject* Sender)
{
	cdsPregledBala->Active = false;
	dsetPregledBala->ParamByName("od_datuma")->Value = cxOdDatuma->Date;
	dsetPregledBala->ParamByName("do_datuma")->Value = cxDoDatuma->Date;
	cdsPregledBala->Active = true;
}

// ---------------------------------------------------------------------------
bool TODObradaPressa2::ProveraTezine()
{
	double Neto = 0;
	double tara = 0;

	try
	{
		Neto = StrToFloat(cxNeto->Text);
		tara = StrToFloat(cxTare->Text);
	}
	catch (Exception& e)
	{
		ShowMyMessageRed->Show("Neto ili tara nisu broj!!", 0x00CCF8F9);
		return false;
	}

	if (tara == 0)
	{
		ShowMyMessageRed->Show("Tara je 0 !!", 0x00CCF8F9);
		return false;
	}
	if (Neto == 0)
	{
		ShowMyMessageRed->Show("Neto je 0!!", 0x00CCF8F9);
		return false;
	}

	return true;
}

// ---------------------------------------------------------------------------
int TODObradaPressa2::BarkodInt()
{
	sqlBrojBarkoda->Active = false;
	sqlBrojBarkoda->ParamByName("crop")->AsInteger = cdsObradaGP->FieldByName("crop")->AsInteger;
	sqlBrojBarkoda->Active = true;

	// cdsObradaGP->FieldByName("BARKOD")->AsInteger  =
	return sqlBrojBarkoda->FieldByName("BrojKutije")->AsInteger + 1;
}

// ----------------------------------------------------------------------------
void __fastcall TODObradaPressa2::btStampajClick(TObject* Sender)
{
	if (Sender == btStampaj2)
	{ // stampa etikete iz pregleda kutija
		if (myTKorisnik->dozvola_stampe == 1)
		{
			cdsObradaStampa->Active = false;
			dsetObradaStampa->ParamByName("id")->AsInteger = cdsPregledBala->FieldByName("id")->AsInteger;
			cdsObradaStampa->Active = true;
		}
		else
		{
			ShowMyMessageRed->Show("Nemate prava stampanja etikete!!", 0x00CCF8F9);
			return;
		}
	}

	// else {                     //stampa nove etikete

	// Merenje();
	//
	// if(!ProveraTezine()) return;
	//
	// if(cdsObradaGP->Active)
	// {
	// try {
	// cdsObradaGP->Edit();
	// cdsObradaGP->FieldByName("tezina")->AsFloat 	= StrToFloat(cxTezina->Text);
	// cdsObradaGP->FieldByName("BARKOD")->AsInteger  = BarkodInt();
	// cdsObradaGP->Post();
	// }
	// catch (Exception &e) {
	// ShowMessage("Greska! Tezina bale nije ispravna!!");
	// return;
	// }
	// }

	btSnimi->Click();

	// DodajNoviRedStavke(cdsObradaGP->FieldByName("int_barkod")->AsString);  //iskljucio nesa zbog novih zahteva JT-a za 2013/2014 godinu

	cdsObradaStampa->Active = false;
	dsetObradaStampa->ParamByName("id")->AsInteger = cdsObradaGP->FieldByName("id")->AsInteger;
	cdsObradaStampa->Active = true;

	if (!cdsObradaStampa->IsEmpty())
	{
		if (frxReport1->LoadFromFile(DIR_STAMPE + "\\StampaLeaf\\EtiketaGP.fr3"))
		{

			frxReport1->PrintOptions->ShowDialog = false;
			frxReport1->PrintOptions->Copies     = StrToIntDef(edtKopija->Text, 1);

			TfrxMemoView* datum_etikete;
			datum_etikete       = (TfrxMemoView*) frxReport1->FindObject("datum_etikete");
			datum_etikete->Text = FormatDateTime("yyyy", cdsObradaStampa->FieldByName("datum_etikete")->Value) + "/" + FormatDateTime("mm", cdsObradaStampa->FieldByName("datum_etikete")->Value) + "/" + FormatDateTime("dd", cdsObradaStampa->FieldByName("datum_etikete")->Value);

			if (cdsObradaStampa->FieldByName("STAMPA_BARKODA")->AsInteger != 1)
			{
				TfrxMemoView* barkod1;
				barkod1 = (TfrxMemoView*) frxReport1->FindObject("BarCode1");
				TfrxMemoView* barkod2;
				barkod2 = (TfrxMemoView*) frxReport1->FindObject("BarCode2");

				barkod1->Visible = false;
				barkod2->Visible = false;
			}

			if (frxReport1->PrepareReport())
				frxReport1->ShowReport(); // Print();
		}
	}

	else
		ShowMyMessageRed->Show("Nema podataka za stampu etikete ", 0x00CCF8F9);

	if (Sender != btStampaj2)
	{
		if (IzmenaPodataka == false)
		{
			btNoviDoc->Click();
		}
		// cxTezina->Text = "0";
	}

	btStampaj->Enabled = !IzmenaPodataka;
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::cxGrossKeyPress(TObject* Sender, wchar_t& Key)
{
	if (Key == VK_RETURN)
	{
		if (Sender == cxCaseNo)
			cxDate->SetFocus();
		else if (Sender == cxDate)
			cxGross->SetFocus();
		else if (Sender == cxGross)
			cxTare->SetFocus();
		else if (Sender == cxTare)
			cxNeto->SetFocus();
		else if (Sender == cxNeto)
			btStampaj->SetFocus();
	}
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::Izmenietiketu1Click(TObject* Sender)
{
	if (pravoUpdate)
	{
		cdsObradaGP->Active = false;
		dsetObradaGP->ParamByName("id")->AsInteger = cdsPregledBala->FieldByName("id")->AsInteger;
		cdsObradaGP->Active = true;

		cxPC1->ActivePage = cxTabSheet1;
		btSnimi->Enabled  = true;
		IzmenaPodataka    = true;

		btSnimi->Visible = IzmenaPodataka;
		// pnlBlokada->Visible = IzmenaPodataka;
	}
	else
	{
		ShowMessage("Nemate prava da menjate podatke!");
	}
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::Obrisi1Click(TObject* Sender)
{
	if (pravoDelete)
	{
		if (cdsPregledBala->Active)
		{

			if (!cdsPregledBala->IsEmpty())
			{

				if (MessageBoxA(Handle, "Da li ste sigurni da zelite da OBRISETE balu?", "Obrada ", MB_YESNO) == IDYES)
				{
					cdsPregledBala->Edit();
					cdsPregledBala->FieldByName("deleted")->AsInteger = 1;
					cdsPregledBala->Post();

					if (SnimiCDS(dspPregledBala, cdsPregledBala, dsPregledBala))
					{
						ShowMyMessageRed->Show("Greska!! Bala NIJE obrisana!!", 0x00FFDDFF);
					}

					cxPregled->Click();
				}
			}
			else
				ShowMyMessageRed->Show("Nema podataka u trazenom periodu!!", 0x00CCF8F9);
		}
		else
		{
			ShowMyMessageRed->Show("Kliknite na dugme pregled da pregledate podatke!!", 0x00CCF8F9);
		}
	}
	else
	{
		ShowMessage("Nemate prava da brisete podatke!");
	}
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::Exportuexcel1Click(TObject* Sender)
{
	SaveDialog1->Title = "Izvoz podataka u excel";
	if (SaveDialog1->Execute())
	{
		ExportGridToExcel(SaveDialog1->FileName, cxGrid1, False, True, True, "xls");
	}
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::cxStampaGPClick(TObject* Sender)
{

	if (Sender == cxStampaGP2)
	{ // stampa iz pregleda kutija
		if (myTKorisnik->dozvola_stampe)
		{
			cdsObradaStampa->Active = false;
			dsetObradaStampa->ParamByName("id")->AsInteger = cdsPregledBala->FieldByName("id")->AsInteger;
			cdsObradaStampa->Active = true;
		}
		else
		{
			ShowMyMessageRed->Show("Nemate prava stampanja etikete!!", 0x00CCF8F9);
			return;
		}
	}
	else
	{ // stampa iz proizvodnje

		// Merenje();

		if (!ProveraTezine())
			return;

		if (cdsObradaGP->Active)
		{
			try
			{
				cdsObradaGP->Edit();
				// cdsObradaGP->FieldByName("tezina")->AsFloat = StrToFloat(cxTezina->Text);
				cdsObradaGP->FieldByName("BARKOD")->AsInteger = BarkodInt();
				cdsObradaGP->FieldByName("DATUM_ETIKETE")->AsDateTime = Now();
				cdsObradaGP->FieldByName("DATUM_OBRADE")->AsDateTime = Now();
				cdsObradaGP->Post();
			}
			catch (Exception& e)
			{
				ShowMessage("Greska! Tezina bale nije ispravna!!");
				return;
			}
		}

		sqlProvera->Active = false;
		sqlProvera->ParamByName("grade")->AsString = cdsObradaGP->FieldByName("grade")->AsString;
		sqlProvera->ParamByName("crop")->AsInteger = cdsObradaGP->FieldByName("crop")->AsInteger;
		sqlProvera->ParamByName("case")->AsInteger = cdsObradaGP->FieldByName("CASE_NO")->AsInteger;
		sqlProvera->Active = true;

		if (sqlProvera->FieldByName("CASE_NO")->AsInteger > 0)
		{

			ShowMyMessageRed->Show("Greska! Kutija sa brojem " + IntToStr(cdsObradaGP->FieldByName("CASE_NO")->AsInteger) + " je vec snimljena !! Sledeca kutija je " + IntToStr(sqlCaseNo->FieldByName("BrojKutijeGrade")->AsInteger + 1), 0x00CCF8F9);
			return;
		}


        btSnimiClick(this);
		// DodajNoviRedStavke(cdsObradaGP->FieldByName("int_barkod")->AsString);  //iskljucio nesa zbog novih zahteva JT-a za 2013/2014 godinu

		cdsObradaStampa->Active = false;
		dsetObradaStampa->ParamByName("id")->AsInteger = cdsObradaGP->FieldByName("id")->AsInteger;
		cdsObradaStampa->Active = true;
	}

	if (!cdsObradaStampa->IsEmpty())
	{
		if (frxReport1->LoadFromFile(DIR_STAMPE + "\\StampaLeaf\\EtiketaIntNalepnice.fr3"))
		{

			frxReport1->PrintOptions->ShowDialog = false;
			if (frxReport1->PrepareReport())
				frxReport1->ShowReport();
		}
	}
	else
		ShowMyMessageRed->Show("Nema podataka za stampu interne etikete ", 0x00CCF8F9);

	if (IzmenaPodataka == false)
	{

		btNoviDoc->Click();
		cxStampaGP->Enabled = !IzmenaPodataka;
		// cxTezina->Text      = "0";
	}
}

// ---------------------------------------------------------------------------
void TODObradaPressa2::DodajNoviRedStavke(AnsiString barkod)
{
	cdsPostojiBalaGP->Active = false;
	sqlPostojiBalaGP->ParamByName("intbarkod")->AsString = barkod;
	cdsPostojiBalaGP->Active = true;
	// Proveriti da li se bala vec nalazi u mg

	if (cdsPostojiBalaGP->RecordCount > 0)
	{

		cdsPostojiBala->Active = false;
		dsetPostojiBala->ParamByName("barkod")->AsString = barkod;
		cdsPostojiBala->Active = true;

		if (cdsPostojiBala->RecordCount == 0)
		{
			cdsBalaMG->Append();
			cdsBalaMG->FieldByName("brbarkoda")->AsInteger = cdsPostojiBalaGP->FieldByName("barkod")->AsInteger;
			cdsBalaMG->FieldByName("barkod")->AsString = cdsPostojiBalaGP->FieldByName("int_barkod")->AsString;
			cdsBalaMG->FieldByName("kutijaid")->AsInteger = cdsPostojiBalaGP->FieldByName("id")->AsInteger;
			cdsBalaMG->FieldByName("tip_proizvoda")->AsInteger = 1; // gotov proizvod
			cdsBalaMG->FieldByName("sifra_mg")->AsInteger = cdsMG_ZG->FieldByName("sifra_magacina")->AsInteger;
			cdsBalaMG->Post();
		}

		cdsPrijemnica->Active = false;
		dsetPrijemnica->ParamByName("barkod")->AsString = barkod;
		cdsPrijemnica->Active = true;

		if (cdsPrijemnica->RecordCount > 0)
		{
			MessageBeep(80);
			ShowMessage("Bala sa unetim bar kodom je vec primljena u magacin!\r" + cdsPrijemnica->FieldByName("magacin")->AsString +
				" dana: " + cdsPrijemnica->FieldByName("datumdpo")->AsString +
				" sa prijemnicom broj: " + cdsPrijemnica->FieldByName("broj")->AsString);
			return;
		}

		cdsMG_STAV->Append();
		cdsMG_STAV->FieldByName("magacin_stav")->AsInteger = 11; // magacin cooling
		cdsMG_STAV->FieldByName("sifra_mg")->AsInteger = cdsMG_ZG->FieldByName("sifra_magacina")->AsInteger;
		cdsMG_STAV->FieldByName("kod")->AsString = cdsPostojiBalaGP->FieldByName("grade")->AsString;
		cdsMG_STAV->FieldByName("broj_serije")->AsString = cdsPostojiBalaGP->FieldByName("int_barkod")->AsString;
		cdsMG_STAV->FieldByName("barkod")->AsString = cdsPostojiBalaGP->FieldByName("int_barkod")->AsString;
		cdsMG_STAV->FieldByName("idbalamg")->AsInteger = cdsBalaMG->FieldByName("id")->AsInteger;
		cdsMG_STAV->FieldByName("LOKACIJA_U")->AsInteger = 0;
		cdsMG_STAV->FieldByName("ulaz_kol")->AsCurrency = 1;
		cdsMG_STAV->FieldByName("ulaz_kol_alt")->AsCurrency = cdsPostojiBalaGP->FieldByName("neto")->AsCurrency;
		cdsMG_STAV->FieldByName("izlaz_kol")->AsCurrency = 0;
		cdsMG_STAV->FieldByName("izlaz_kol_alt")->AsCurrency = 0;
		cdsMG_STAV->FieldByName("vreme")->Value = Now();
		cdsMG_STAV->Post();

	}
	else
	{
		MessageBeep(80);
		ShowMessage("Kutija sa unetim bar kodom ne postoji!");
	}
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::cdsObradaGPCASE_NOChange(TField* Sender)
{ /*
	 AnsiString barkod;
	 barkod = cdsObradaGP->FieldByName("IDOZBLENDA")->AsString;
	 barkod += Strutils::DupeString('0', (4-cdsObradaGP->FieldByName("case_no")->AsString.Length()))+cdsObradaGP->FieldByName("case_no")->AsString;
	 barkod += cdsObradaGP->FieldByName("crop")->AsString.SubString(3,2);
	 barkod += FormatDateTime("mmdd",cdsObradaGP->FieldByName("DATUM_ETIKETE")->AsDateTime);

	 barkod = cdsObradaGP->FieldByName("CROP")->AsString.SubString(3,2)+"K";
	 barkod += Strutils::DupeString('0', (5-cdsObradaGP->FieldByName("barkod")->AsString.Length()))+cdsObradaGP->FieldByName("barkod")->AsString;

	 cdsObradaGP->FieldByName("INT_BARKOD")->AsString = barkod; */
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::dspObradaGPBeforeUpdateRecord(TObject* Sender, TDataSet* SourceDS, TCustomClientDataSet* DeltaDS,
	TUpdateKind UpdateKind, bool& Applied)
{
	switch (UpdateKind)
	{
		case ukInsert:
		if (pravoInsert)
			// DeltaDS->FieldByName("DATUM_ETIKETE")->NewValue=Now();
				DeltaDS->FieldByName("DATUM")->NewValue = Now();
		break;
		case ukModify:
		if (pravoUpdate)
		{
			DeltaDS->FieldByName("DATE_CHANGE")->NewValue = Now();
			DeltaDS->FieldByName("RADNIKA_CHANGE")->NewValue = myTKorisnik->sifra_usera;
		}
		default:
		break;

	}
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::dspPregledBalaBeforeUpdateRecord(TObject* Sender,
	TDataSet* SourceDS, TCustomClientDataSet* DeltaDS, TUpdateKind UpdateKind,
	bool& Applied)
{

	if (UpdateKind == ukInsert)
	{
		if (!pravoInsert)
		{
			Applied = true;
			ShowMessage("Nemate pravo da dodate nove podatke!");
			if (DeltaDS->Active == true)
			{
				if (DeltaDS->ChangeCount == 0)
					DeltaDS->Refresh();
				else
				{
					DeltaDS->Active = false;
					DeltaDS->Active = true;
				}
			}
		}

	}
	else if (UpdateKind == ukModify)
	{
		if (!pravoUpdate)
		{
			Applied = true;
			ShowMessage("Nemate pravo da menjate postojece podatke!");
			if (DeltaDS->Active == true)
			{
				if (DeltaDS->ChangeCount == 0)
					DeltaDS->Refresh();
				else
				{
					DeltaDS->Active = false;
					DeltaDS->Active = true;
				}
			}
		}

	}
	else if (UpdateKind == ukDelete)
	{
		if (!pravoDelete)
		{
			Applied = true;
			ShowMessage("Nemate pravo da brisete postojece podatke!");
			if (DeltaDS->Active == true)
			{
				if (DeltaDS->ChangeCount == 0)
					DeltaDS->Refresh();
				else
				{
					DeltaDS->Active = false;
					DeltaDS->Active = true;
				}
			}
		}
	}
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::cdsMG_STAVNewRecord(TDataSet* DataSet)
{
	try
	{
		DM_OD->SP_ID_STAV->Prepared = true;
		DM_OD->SP_ID_STAV->ExecProc();

		cdsMG_STAV->FieldByName("id")->AsInteger = DM_OD->SP_ID_STAV->ParamByName("ID")->AsInteger;
		cdsMG_STAV->FieldByName("idzg")->AsInteger = cdsMG_ZG->FieldByName("id")->AsInteger;

	}
	catch (Exception& e)
	{
		ShowMessage("Nemogu da otvorim novi zapis!! " + e.Message);
	}
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::cdsMG_STAVAfterPost(TDataSet* DataSet)
{
	if (SnimiCDS(dspMG_STAV, cdsMG_STAV, dsMG_STAV) > 0)
	{
		ShowMessage("Greska prilikom SNIMANJA zaglavlja prijemnice!!");
		return;
	}
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::cdsMG_ZGNewRecord(TDataSet* DataSet)
{
	try
	{
		DM_OD->SP_ID_ZG->Prepared = true;
		DM_OD->SP_ID_ZG->ExecProc();

		cdsMG_ZG->FieldByName("id")->Value = DM_OD->SP_ID_ZG->ParamByName("ID")->AsInteger;
		cdsMG_ZG->FieldByName("datumdpo")->Value = Date();
		cdsMG_ZG->FieldByName("datumvalute")->Value = Date();
		cdsMG_ZG->FieldByName("datum_rada")->Value = Date();
		cdsMG_ZG->FieldByName("sifra_radnika")->AsInteger = myTKorisnik->sifra_usera;
		cdsMG_ZG->FieldByName("sifra_magacina")->AsInteger = 11;    // myTKorisnik->default_mg;
		cdsMG_ZG->FieldByName("sifra_dokumenta")->AsInteger = 6002; // sifra_dokumenta=2200 prijemnica robe
		cdsMG_ZG->FieldByName("sifra_komitenta")->AsInteger = 0;
		// cdsMG_ZG->FieldByName("sifra_komitenta2")->AsInteger = 0;
	}
	catch (Exception& e)
	{
		ShowMessage("Nemogu da otvorim novi zapis!! " + e.Message);
	}
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::cdsMG_ZGAfterPost(TDataSet* DataSet)
{
	if (SnimiCDS(dspMG_ZG, cdsMG_ZG, dsMG_ZG) > 0)
	{
		ShowMessage("Greska prilikom SNIMANJA zaglavlja prijemnice!!");
		return;
	}
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::cdsBalaMGNewRecord(TDataSet* DataSet)
{
	try
	{
		spBalaMG->Prepared = true;
		spBalaMG->ExecProc();

		cdsBalaMG->FieldByName("id")->AsInteger = spBalaMG->ParamByName("ID")->AsInteger;
		cdsBalaMG->FieldByName("datum_prijema")->Value = Now();
		cdsBalaMG->FieldByName("obrisano")->AsInteger = 0;

	}
	catch (Exception& e)
	{
		ShowMessage("Nemogu da otvorim novi zapis!! " + e.Message);
	}
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::cdsBalaMGAfterPost(TDataSet* DataSet)
{
	if (SnimiCDS(dspBalaMG, cdsBalaMG, dsBalaMG) > 0)
	{
		ShowMessage("Greska prilikom SNIMANJA karakteristika bale!!");
		return;
	}
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::Stampajetiketezacelulistu1Click(TObject* Sender)
{
	if (myTKorisnik->dozvola_stampe != 1)
	{
		ShowMyMessageRed->Show("Nemate prava stampanja etikete!!", 0x00CCF8F9);
		return;
	}

	if (!cdsPregledBala->IsEmpty())
	{
		cdsPregledBala->First();

		while (!cdsPregledBala->Eof)
		{

			cxStampaGPClick(cxStampaGP2);
			cdsPregledBala->Next();
		}
	}
	else
		ShowMyMessageRed->Show("Nema podataka za stampu etikete ili kliknite na taster PREGLED!!", 0x00CCF8F9);
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::MenuItem1Click(TObject* Sender)
{
	if (myTKorisnik->dozvola_stampe != 1)
	{
		ShowMyMessageRed->Show("Nemate prava stampanja etikete!!", 0x00CCF8F9);
		return;
	}

	if (!cdsPregledBala->IsEmpty())
	{

		cdsPregledBala->First();

		while (!cdsPregledBala->Eof)
		{

			btStampajClick(btStampaj2);
			cdsPregledBala->Next();
		}
	}
	else
		ShowMyMessageRed->Show("Nema podataka za stampu etikete ili kliknite na taster PREGLED!!", 0x00CCF8F9);
}
// ---------------------------------------------------------------------------        BC_ORIGIN

void __fastcall TODObradaPressa2::cdsObradaStampaCalcFields(TDataSet* DataSet)
{
	cdsObradaStampa->FieldByName("Barcode1")->AsString = cdsObradaStampa->FieldByName("bc_type")->AsString +
		cdsEtiketa->FieldByName("bc_origin")->AsString +
		cdsObradaStampa->FieldByName("bc_grade")->AsString +
		cdsObradaStampa->FieldByName("bc_pack_type")->AsString +
		cdsObradaStampa->FieldByName("crop")->AsString +
		IntToStr(10 * cdsObradaStampa->FieldByName("neto")->AsInteger) +
		"00";
	// 20221000011312012200000            andrea poslala 17.10.2012
	cdsObradaStampa->FieldByName("Barcode2")->AsString = "3" +
		cdsEtiketa->FieldByName("supplier")->AsString +
		FormatDateTime("yyyymmdd", cdsObradaStampa->FieldByName("datum_etikete")->Value) +
		"00000" +
		FormatFloat("000000", cdsObradaStampa->FieldByName("case_no")->AsFloat) +
		"00";
	cdsObradaStampa->FieldByName("barcode_no")->AsString = "CN" + FormatFloat("00000", cdsObradaStampa->FieldByName("case_no")->AsFloat);
} // 31053++++++++00000++++++00
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::cxSledecaBalaClick(TObject* Sender)
{
	Screen->Cursor                          = crHourGlass;
	TfmPraznjenjeSilosa* fmPraznjenjeSilosa = new TfmPraznjenjeSilosa(this);
	fmPraznjenjeSilosa->ShowModal(); // FormStyle = fsMDIChild;
	Screen->Cursor = crDefault;

	if (cdsList->Active)
	{
		sqlIntBatch->Active = false;
		sqlIntBatch->ParamByName("status_batcha")->AsInteger = cdsList->FieldByName("BATCH")->AsInteger;
		sqlIntBatch->ParamByName("mg")->AsInteger = MAGACIN_BUFFER;
		sqlIntBatch->ParamByName("doc")->AsInteger = DOC_PROIZVODNJE;
		sqlIntBatch->Active = true;
	}

	if (cdsObradaGP->Active)
	{
		cdsObradaGP->Edit();
		cdsObradaGP->FieldByName("BATCH_NO")->AsInteger = sqlIntBatch->FieldByName("broj_batcha")->AsInteger;
		cdsObradaGP->FieldByName("ID_BLENDA")->AsInteger = sqlIntBatch->FieldByName("idblend")->AsInteger;
		cdsObradaGP->FieldByName("IDZG")->AsInteger = sqlIntBatch->FieldByName("IDZG")->AsInteger;
		cdsObradaGP->Post();
	}
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::Updatevremenaobrade1Click(TObject* Sender)
{
	cdsPregledBala->First();

	while (!cdsPregledBala->Eof)
	{
		sqlVremeObrade->ParamByName("vreme")->Value = cdsPregledBala->FieldByName("DATUM")->AsDateTime - DM_OD->cdsSystemOD->FieldByName("START_RADNI_DAN")->AsDateTime;
		sqlVremeObrade->ParamByName("id")->Value = cdsPregledBala->FieldByName("ID")->AsInteger;
		sqlVremeObrade->ExecSQL();

		cdsPregledBala->Next();
	}
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::Updatebarkodova1Click(TObject* Sender)
{
	if (MessageBoxA(0, "Koriscenje ove funkcije moze dovesti do gubitka podataka ili promene podataka !!!\nDa li ste SIGURNI da zelite da nastavite?", "", MB_ICONWARNING | MB_YESNO) == IDNO)
	{
		return;
	}

	sqlMaxFCDBarkod->ParamByName("crop")->AsInteger = 2012;
	sqlMaxFCDBarkod->ExecSQL();
	sqlMaxFCDBarkod->Open();

	int NoviBarkod = sqlMaxFCDBarkod->FieldByName("BrojKutije")->AsInteger;

	cdsPregledBala->First();
	AnsiString barkod;

	while (!cdsPregledBala->Eof)
	{

		NoviBarkod = NoviBarkod + 1;

		barkod = cdsPregledBala->FieldByName("CROP")->AsString.SubString(3, 2) + "K";
		barkod += Strutils::DupeString('0', (5 - IntToStr(NoviBarkod).Length())) + IntToStr(NoviBarkod);

		sqlUpdateBarkodovaNovo->ParamByName("int_barkod")->Value = barkod;
		sqlUpdateBarkodovaNovo->ParamByName("barkod")->Value = NoviBarkod;
		sqlUpdateBarkodovaNovo->ParamByName("id")->Value = cdsPregledBala->FieldByName("ID")->AsInteger;
		sqlUpdateBarkodovaNovo->ExecSQL();

		spBalaMG->Prepared = true;
		spBalaMG->ExecProc();

		sqlProveraBale->Close();
		sqlProveraBale->ParamByName("kutijaid")->AsInteger = cdsPregledBala->FieldByName("ID")->AsInteger;
		sqlProveraBale->ExecSQL();
		sqlProveraBale->Open();

		if (sqlProveraBale->FieldByName("broj")->AsInteger > 0)
		{
			sqlUpdateBalaMg->ParamByName("kutijaid")->Value = cdsPregledBala->FieldByName("ID")->AsInteger;
			sqlUpdateBalaMg->ParamByName("int_barkod")->Value = barkod;
			sqlUpdateBalaMg->ParamByName("barkod")->Value = NoviBarkod; // cdsPregledBala->FieldByName("barkod")->AsInteger;
			sqlUpdateBalaMg->ExecSQL();
		}
		else
		{
			sqlInsertTBALA_MG->ParamByName("id")->Value = spBalaMG->ParamByName("ID")->AsInteger;
			sqlInsertTBALA_MG->ParamByName("kutijaid")->Value = cdsPregledBala->FieldByName("ID")->AsInteger;
			sqlInsertTBALA_MG->ParamByName("int_barkod")->Value = barkod;
			sqlInsertTBALA_MG->ParamByName("datum")->AsDateTime = cdsPregledBala->FieldByName("datum_etikete")->AsDateTime;
			sqlInsertTBALA_MG->ParamByName("barkod")->Value = NoviBarkod; // cdsPregledBala->FieldByName("barkod")->AsInteger;
			sqlInsertTBALA_MG->ExecSQL();
		}

		cdsPregledBala->Next();
	}
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::cdsObradaGPBARKODChange(TField* Sender)
{
	AnsiString barkod;
	barkod = cdsObradaGP->FieldByName("CROP")->AsString.SubString(3, 2) + "K";
	barkod += Strutils::DupeString('0', (5 - cdsObradaGP->FieldByName("barkod")->AsString.Length())) + cdsObradaGP->FieldByName("barkod")->AsString;

	cdsObradaGP->FieldByName("INT_BARKOD")->AsString = barkod;
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::frxReport1AfterPrintReport(TObject* Sender)
{
	frxReport1->PreviewForm->Close();
}

// ---------------------------------------------------------------------------
void TODObradaPressa2::Merenje()
{
	Tezina = 0;

	try
	{
		Tezina = 0; // MerenjeTezineVaga(1, "VAGA_PRESA", DM_OD->SC_OD);
		// cxTezina->Text = FloatToStr(Tezina);
	}
	catch (Exception& e)
	{
		ShowMyMessageRed->Show("Proverite da li je ispravno definisan komunikacioni port!!", 0x00FFDDFF);
		Tezina = -1;
		// cxTezina->Text = FloatToStr(Tezina);
	}
}

// ---------------------------------------------------------------------------
void __fastcall TODObradaPressa2::cxPocetakMerenjaClick(TObject* Sender)
{
	TimerNoviGP->Enabled = true;

	// if (cxPocetakMerenja->Tag == 0)
	// {
	// cxPocetakMerenja->Tag     = 1;
	// cxPocetakMerenja->Caption = "Zaustavi merenje";
	// }
	// else if (cxPocetakMerenja->Tag == 1)
	// {
	// cxPocetakMerenja->Tag     = 0;
	// cxPocetakMerenja->Caption = "Pokreni merenje";
	// }
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::TimerNoviGPTimer(TObject* Sender)
{
	// Merenje();
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::cdsListCalcFields(TDataSet* DataSet)
{
	cdsList->FieldByName("Opseg_tezine")->AsString = cdsList->FieldByName("MIN_TEZINA")->AsString + "-" + cdsList->FieldByName("MAX_TEZINA")->AsString;
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::cdsObradaGPReconcileError(TCustomClientDataSet* DataSet,
	EReconcileError* E, TUpdateKind UpdateKind, TReconcileAction& Action)

{
	ShowMessage(E->Message);
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::cxStampaSmenaClick(TObject* Sender)
{
	cdsPregled->Active = false;
	cdsPregled->Params->ParamByName("RADNIK")->AsInteger = myTKorisnik->sifra_usera;
	cdsPregled->Params->ParamByName("DATUM")->AsDate = Now();
	cdsPregled->Active = true;

	TfrxMemoView* fr1;
	fr1 = (TfrxMemoView*)frxReport2->FindObject("Memo1");
	if (fr1 != NULL)
		fr1->Text = myTKorisnik->user;

	frxReport2->ShowReport(true);
}
// ---------------------------------------------------------------------------

void __fastcall TODObradaPressa2::btPonistiClick(TObject* Sender)
{
	cdsObradaGP->Active = false;
}
// ---------------------------------------------------------------------------
