//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OD_vakumiranje.h"
#include "OD_DM.h"
#include "OD_funkcije.h"
#include "fmMessageRed.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "BUS_osnovna_prazna"
#pragma link "cxButtons"
#pragma link "cxClasses"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxCustomData"
#pragma link "cxData"
#pragma link "cxDataStorage"
#pragma link "cxDBData"
#pragma link "cxEdit"
#pragma link "cxFilter"
#pragma link "cxGraphics"
#pragma link "cxGrid"
#pragma link "cxGridCustomTableView"
#pragma link "cxGridCustomView"
#pragma link "cxGridDBTableView"
#pragma link "cxGridLevel"
#pragma link "cxGridTableView"
#pragma link "cxLabel"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxStyles"
#pragma link "cxTextEdit"
#pragma link "cxPC"
#pragma link "cxNavigator"
#pragma link "cxPCdxBarPopupMenu"
#pragma link "dxSkinBlack"
#pragma link "dxSkinBlue"
#pragma link "dxSkinDevExpressDarkStyle"
#pragma link "dxSkinDevExpressStyle"
#pragma link "dxSkinFoggy"
#pragma link "dxSkinOffice2010Black"
#pragma link "dxSkinOffice2010Blue"
#pragma link "dxSkinOffice2010Silver"
#pragma link "dxSkinsCore"
#pragma link "dxSkinscxPCPainter"
#pragma link "dxSkinSevenClassic"
#pragma link "dxSkinVS2010"
#pragma resource "*.dfm"
TfmVakumiranje *fmVakumiranje;
extern TKorisnik *myTKorisnik;
extern int MAGACIN_BUFFER;
extern int DOC_PROIZVODNJE;
int STATUS_U_OBRADI=4;
//---------------------------------------------------------------------------
__fastcall TfmVakumiranje::TfmVakumiranje(TComponent* Owner)
	: TfmOsnovna_prazna(Owner)
{
	cdsVakumiranje->Active = false;
	dsetVakumiranje->ParamByName("id")->AsInteger = -1;
	cdsVakumiranje->Active = true;
}
//---------------------------------------------------------------------------
void __fastcall TfmVakumiranje::cdsVakumiranjeNewRecord(TDataSet *DataSet)
{
	spVakumiranje->Prepared = true;
	spVakumiranje->ExecProc();

	cdsVakumiranje->FieldByName("id")->AsInteger=spVakumiranje->ParamByName("ID")->AsInteger;
	cdsVakumiranje->FieldByName("sifra_radnika")->AsInteger = myTKorisnik->sifra_usera;
	cdsVakumiranje->FieldByName("vreme")->Value = Now();
	cdsVakumiranje->FieldByName("tezina")->AsCurrency=0;
	cdsVakumiranje->FieldByName("deleted")->AsInteger = 0;
	cdsVakumiranje->FieldByName("status")->AsInteger = 0;
}
//---------------------------------------------------------------------------
void __fastcall TfmVakumiranje::cxBarCodeKeyPress(TObject *Sender, wchar_t &Key)
{
	 if((Key == VK_RETURN) && (pravoInsert)) {

		int barkod,grupa;

		if(Sender == cxBarCode) {
			 barkod=StrToInt(cxBarCode->Text);
		}

		// da li je bala vec usla u proizvodnju, ali samo sa statusom U OBRADI
		sqlBalaUObradi->Active = false;
		sqlBalaUObradi->ParamByName("barkod")->AsInteger = StrToInt(cxBarCode->Text);
		sqlBalaUObradi->ParamByName("doc")->AsInteger = DOC_PROIZVODNJE;
		sqlBalaUObradi->ParamByName("mg")->AsInteger = MAGACIN_BUFFER;
		sqlBalaUObradi->ParamByName("status")->AsInteger = STATUS_U_OBRADI;
		sqlBalaUObradi->Active = true;

		if(sqlBalaUObradi->FieldByName("broj")->AsInteger > 0) {
			ShowMyMessageRed->Show("Bala sa barkodom: "+cxBarCode->Text+" je usla u proizvodnju!!", 0x00CCF8F9);
			cxBarCode->Text = "";
			cxBarCode->SetFocus();
			return;
		}

		TLocateOptions Opts;
		Opts.Clear();
			// proverava da li se nalazi na listi
		if (cdsVakumiranje->Locate("brbarkoda", cxBarCode->Text, Opts)) {
			ShowMyMessageRed->Show("BALA "+cxBarCode->Text+" SE VEC NALAZI NA VAKUMIRANJU!! ", 0x00FFDDFF);
			cxBarCode->Text = "";
			cxBarCode->SetFocus();
			return;
		}

		try {
		 cdsBala->Active = false;
		 dsetBala->ParamByName("barkod")->AsInteger = barkod;
		 cdsBala->Active = true;

		 if(cdsBala->RecordCount > 0) {
			cdsVakumiranje->Append();
			cdsVakumiranje->FieldByName("brbarkoda")->AsInteger = cdsBala->FieldByName("brbarkoda")->AsInteger;
			cdsVakumiranje->FieldByName("int_klasa")->AsString  = cdsBala->FieldByName("int_klasa")->AsString;
			cdsVakumiranje->Post();

			cxBarCode->Text = "";
			cxBarCode->SetFocus();
		 }
		 else {
				 ShowMyMessageRed->Show("NE POSTOJI BALA "+cxBarCode->Text+"!! ", 0x00FFDDFF);
		 }
		} catch (Exception &e) {
			ShowMessage("Greska!! "+e.Message);
			cxBarCode->Text = "";
			cxBarCode->SetFocus();
		}
	 }
}
//---------------------------------------------------------------------------

void __fastcall TfmVakumiranje::cxSnimiClick(TObject *Sender)
{
		cxSnimi->Enabled = false;

		if(SnimiCDS(dspVakumiranje, cdsVakumiranje, dsVakumiranje)) {
				ShowMessage("Greska prilikom SNIMANJA novih podataka!!");
				cxSnimi->Enabled = true;
				return;
		}
}
//---------------------------------------------------------------------------
void __fastcall TfmVakumiranje::FormCreate(TObject *Sender)
{   /*
	try {
		cxBarCode->Text = "";
		cxBarCode->SetFocus();
	}
	catch(...) {}
	 */	// sam da prodje gresku prilikom otvaranja forme
	   //}
}
//---------------------------------------------------------------------------
void __fastcall TfmVakumiranje::cxButton1Click(TObject *Sender)
{
  FormCreate(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TfmVakumiranje::cdsVakumiranjeAfterPost(TDataSet *DataSet)
{
	cxSnimi->Click();
}
//---------------------------------------------------------------------------
void __fastcall TfmVakumiranje::FormActivate(TObject *Sender)
{
			cxBarCode->Text = "";
			cxBarCode->SetFocus();
			cxBarCode->SelectAll();
}
//---------------------------------------------------------------------------

void __fastcall TfmVakumiranje::ZatvoriFormuExecute(TObject *Sender)
{
	if(MessageBoxA(Handle,"Da li ste sigurni da zelite da zatvorite prozor?", "Vakumiranje!! ", MB_YESNO) == IDYES)
	{
		ModalResult = mrOk;
	}
}
//---------------------------------------------------------------------------

void __fastcall TfmVakumiranje::Timer1Timer(TObject *Sender)
{
 if(!cdsVakumiranje->Eof && !cdsVakumiranje->Bof) cdsVakumiranje->RefreshRecord();
}
//---------------------------------------------------------------------------

void __fastcall TfmVakumiranje::cxButton2Click(TObject *Sender)
{
  cdsVakumiranje->Active =false;
	Close();
}
//---------------------------------------------------------------------------

void __fastcall TfmVakumiranje::dspVakumiranjeBeforeUpdateRecord(TObject *Sender,
		  TDataSet *SourceDS, TCustomClientDataSet *DeltaDS, TUpdateKind UpdateKind,
          bool &Applied)
{
		if (UpdateKind == ukInsert) {
		if (!pravoInsert) {
			Applied = true;
			ShowMessage("Nemate pravo da dodate nove podatke!");
			if(DeltaDS->Active == true) {
				if(DeltaDS->ChangeCount == 0)
					DeltaDS->Refresh();
				else {
					DeltaDS->Active = false;
					DeltaDS->Active = true;
                }
            }
		}

	}else if (UpdateKind == ukModify) {
		if (!pravoUpdate) {
			Applied = true;
			ShowMessage("Nemate pravo da menjate postojece podatke!");
			if(DeltaDS->Active == true) {
				if(DeltaDS->ChangeCount == 0)
					DeltaDS->Refresh();
				else {
					DeltaDS->Active = false;
					DeltaDS->Active = true;
                }
			}
		}

	}else if (UpdateKind == ukDelete) {
		if (!pravoDelete) {
			Applied = true;
			ShowMessage("Nemate pravo da brisete postojece podatke!");
			if(DeltaDS->Active == true) {
				if(DeltaDS->ChangeCount == 0)
					DeltaDS->Refresh();
				else {
					DeltaDS->Active = false;
					DeltaDS->Active = true;
                }
            }
		}
	}
}
//---------------------------------------------------------------------------

