// ---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "PromenaPodatakaBale.h"
#include "fmMessageRed.h"
#include "OD_funkcije.h"
#include "OD_DM.h"
// ---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "BUS_osnovna_prazna"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxEdit"
#pragma link "cxGraphics"
#pragma link "cxLabel"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxTextEdit"
#pragma link "cxDBEdit"
#pragma link "cxClasses"
#pragma link "cxCustomData"
#pragma link "cxData"
#pragma link "cxDataStorage"
#pragma link "cxDBData"
#pragma link "cxFilter"
#pragma link "cxGrid"
#pragma link "cxGridCustomTableView"
#pragma link "cxGridCustomView"
#pragma link "cxGridDBTableView"
#pragma link "cxGridLevel"
#pragma link "cxGridTableView"
#pragma link "cxStyles"
#pragma link "cxButtons"
#pragma link "cxDBLookupComboBox"
#pragma link "frxClass"
#pragma link "frxDBSet"
#pragma link "frxExportPDF"
#pragma link "cxNavigator"
#pragma link "dxSkinBlack"
#pragma link "dxSkinBlue"
#pragma link "dxSkinDevExpressDarkStyle"
#pragma link "dxSkinDevExpressStyle"
#pragma link "dxSkinFoggy"
#pragma link "dxSkinOffice2010Black"
#pragma link "dxSkinOffice2010Blue"
#pragma link "dxSkinOffice2010Silver"
#pragma link "dxSkinsCore"
#pragma link "dxSkinscxPCPainter"
#pragma link "dxSkinSevenClassic"
#pragma link "dxSkinVS2010"
#pragma resource "*.dfm"
TfmPromenaPodataka* fmPromenaPodataka;
extern int MAGACIN_BUFFER;
extern int DOC_PROIZVODNJE;
extern TKorisnik* myTKorisnik;
extern AnsiString DIR_STAMPE;

// ---------------------------------------------------------------------------
__fastcall TfmPromenaPodataka::TfmPromenaPodataka(TComponent* Owner, int barkod = 0)
	:TfmOsnovna_prazna(Owner)
{
	this->barkod = barkod;

	cdsBalaMG->Active = false;
	dsetBalaMG->ParamByName("id")->AsInteger = -1;
	cdsBalaMG->Active = true;
}

// ---------------------------------------------------------------------------
void __fastcall TfmPromenaPodataka::cxBarCodeKeyPress(TObject* Sender, wchar_t& Key)
{
	if (Key == VK_RETURN)
	{

		// int barkod,grupa;

		// if(Sender == cxBarCode) {
		// barkod=cxBarCode->Text;
		// grupa=-1;
		// }

		try
		{
			   UnicodeString BarKod;
			   int barkod;
			   BarKod = cxBarCode->Text;
			   BarKod=	BarKod.SubString(1,12);
			   barkod=StrToInt(BarKod);
			   BarKod=IntToStr(barkod);


			cdsBala->Active = false;
			dsetBala->ParamByName("barkod")->AsString = BarKod;
			cdsBala->Active = true;

			if (!cdsBala->IsEmpty())
			{

				cxDodaj->Click();

				cdsIntKlasa->Active = false;
				dsetIntKlasa->ParamByName("idsorte")->AsInteger = cdsBala->FieldByName("sortaid")->AsInteger;
				cdsIntKlasa->Active = true;
			}
			else
			{
				ShowMyMessageRed->Show("Ne postoji bala sa barkodom: " + BarKod + " !!", 0x00CCF8F9);
			}

		}
		catch (Exception& e)
		{
			ShowMessage("Greska!! " + e.Message);
		}
	}
}
// ---------------------------------------------------------------------------

void __fastcall TfmPromenaPodataka::FormClose(TObject* Sender, TCloseAction& Action)
{ /*
	 try {
	 cxSnimi->Click();
	 }
	 catch(Exception &e) {
	 //*****************
	 }

	 Action = caFree; */
}

// ---------------------------------------------------------------------------
void __fastcall TfmPromenaPodataka::cdsBalaMGNewRecord(TDataSet* DataSet)
{
	try
	{
		spBalaMG->Prepared = true;
		spBalaMG->ExecProc();

		cdsBalaMG->FieldByName("id")->AsInteger = spBalaMG->ParamByName("ID")->AsInteger;
		cdsBalaMG->FieldByName("barkod")->AsString = cdsBala->FieldByName("barkod")->AsString;
		cdsBalaMG->FieldByName("klasaid_old")->AsInteger = cdsBala->FieldByName("klasaid")->AsInteger;
		cdsBalaMG->FieldByName("VREME")->Value = Now();
		cdsBalaMG->FieldByName("idbalamg")->AsInteger = cdsBala->FieldByName("id")->AsInteger;
		cdsBalaMG->FieldByName("sifra_radnika")->AsInteger = myTKorisnik->sifra_usera;

		sqlOznaka->Active=false;
		sqlOznaka->Params->ParamByName("KLASA")->AsInteger=cdsBalaMG->FieldByName("klasaid_old")->AsInteger;
		sqlOznaka->Active=true;

         UnicodeString klasa=sqlOznaka->FieldByName("OZNAKA")->AsString;
		 klasa= klasa.SubString(0,1) + "4" + klasa.SubString(3,3);
		 sqlNovaKL->Active=false;
		 sqlNovaKL->Params->ParamByName("OZNAKA")->AsString=klasa;
		 sqlNovaKL->Active=true;

		 cdsBalaMG->FieldByName("klasaid_new")->AsInteger =sqlNovaKL->FieldByName("KLASA")->AsInteger;



		cxSnimi->Enabled = true;
	}
	catch (Exception& e)
	{
		ShowMessage("Nemogu da otvorim novi zapis!! " + e.Message);
	}
}

// ---------------------------------------------------------------------------
void __fastcall TfmPromenaPodataka::cxDodajClick(TObject* Sender)
{
	try
	{

		cdsBalaMG->Append();
		cdsBalaMG->Post();

	}
	catch (Exception& e)
	{
		ShowMessage("Nemogu da otvorim novi zapis!! " + e.Message);
	}
}

// ---------------------------------------------------------------------------
void __fastcall TfmPromenaPodataka::cxObrisiClick(TObject* Sender)
{
	try
	{

		if (!cdsBalaMG->Eof)
			cdsBalaMG->Delete();

		if (cdsBalaMG->IsEmpty())
		{
			cxDodaj->Enabled     = false;
			cxObrisi->Enabled    = false;
			cxSveObrisi->Enabled = false;
		}

	}
	catch (Exception& e)
	{
		ShowMessage("Greska!! " + e.Message);
	}
}

// ---------------------------------------------------------------------------
void __fastcall TfmPromenaPodataka::cxSveObrisiClick(TObject* Sender)
{
	try
	{

		while (!cdsBalaMG->Eof)
			cdsBalaMG->Delete();

		if (cdsBalaMG->IsEmpty())
		{
			cxDodaj->Enabled     = false;
			cxObrisi->Enabled    = false;
			cxSveObrisi->Enabled = false;
		}

	}
	catch (Exception& e)
	{
		ShowMessage("Greska!! " + e.Message);
	}
}

// ---------------------------------------------------------------------------
void __fastcall TfmPromenaPodataka::cxButton1Click(TObject* Sender)
{
	cdsBalaMG->Active = false;
	dsetBalaMG->ParamByName("id")->AsInteger = -1;
	cdsBalaMG->Active = true;

	cxDodaj->Enabled     = true;
	cxObrisi->Enabled    = true;
	cxSveObrisi->Enabled = true;

	cxSnimi->Enabled = true;
}

// ---------------------------------------------------------------------------
void __fastcall TfmPromenaPodataka::dspBalaMGBeforeUpdateRecord(TObject* Sender, TDataSet* SourceDS, TCustomClientDataSet* DeltaDS,
	TUpdateKind UpdateKind, bool& Applied)
{

	if (UpdateKind == ukInsert)
	{
		sqlNovaKlasa->ParamByName("barkod")->AsString = DeltaDS->FieldByName("barkod")->AsString;
		sqlNovaKlasa->ParamByName("klasa")->AsInteger = DeltaDS->FieldByName("klasaid_new")->AsInteger;
		sqlNovaKlasa->ExecSQL();

		// sqlObrisiBalu->ParamByName("idstavke")->AsInteger = DeltaDS->FieldByName("id_stavke")->AsInteger;
		// sqlObrisiBalu->ExecSQL();
	}
}

// ---------------------------------------------------------------------------
void __fastcall TfmPromenaPodataka::cxSnimiClick(TObject* Sender)
{
	cxSnimi->Enabled = false;

	if (SnimiCDS(dspBalaMG, cdsBalaMG, dsBalaMG))
	{
		ShowMessage("Greska prilikom SNIMANJA novih podataka!!");
		cxSnimi->Enabled = true;
		return;
	}
		this->ModalResult = mrOk;


	// Close();
}
// ---------------------------------------------------------------------------

void __fastcall TfmPromenaPodataka::FormActivate(TObject* Sender)
{
	try
	{
		wchar_t dugmeEnter=VK_RETURN;
		if (this->barkod > 0)
		{
			cxBarCode->Text = this->barkod;
			cxBarCodeKeyPress(this,dugmeEnter);

		}
		else
		{
			cxBarCode->Text = "";
			cxBarCode->SetFocus();
		}
	}
	catch (...) {}
}
// ---------------------------------------------------------------------------

void __fastcall TfmPromenaPodataka::ZatvoriFormuExecute(TObject * Sender)
{
	if (MessageBoxA(Handle, "Da li ste sigurni da zelite da zatvorite prozor?", "Reklasiranje!! ", MB_YESNO) == IDYES)
	{
		ModalResult = mrOk;
	}
}
// ---------------------------------------------------------------------------

void __fastcall TfmPromenaPodataka::cxButton2Click(TObject * Sender)
{
	cdsBalaMG->Active = false;
	Close();
}
// ---------------------------------------------------------------------------

void __fastcall TfmPromenaPodataka::cxButton3Click(TObject * Sender)
{
	DM_OD->cdsEtiketa->Active = false;
	DM_OD->dsetEtiketa->ParamByName("id")->AsInteger = cdsBalaMG->FieldByName("idbalamg")->AsInteger;
	DM_OD->cdsEtiketa->Active = true;

	if (frxReport1->LoadFromFile(DIR_STAMPE + "\\stampa\\BarCodeNalepnica.fr3"))
	{ // }

		if (DM_OD->cdsEtiketa->FieldByName("primese")->AsInteger == 1)
{
			TfrxMemoView* shPrimese1 = (TfrxMemoView*)frxReport1->FindObject("shPrimese1");
			TfrxMemoView* shPrimese2 = (TfrxMemoView*)frxReport1->FindObject("shPrimese2");

			shPrimese1->Visible = true;
			shPrimese2->Visible = true;
		}

		frxReport1->PrintOptions->ShowDialog = false;
		// frxReport1->Print();
		frxReport1->ShowReport();
	}
}
// ---------------------------------------------------------------------------
