// ---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "od_raspored_stolova.h"
#include "OD_funkcije.h"
// ---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cxClasses"
#pragma link "cxControls"
#pragma link "cxCustomData"
#pragma link "cxData"
#pragma link "cxDataStorage"
#pragma link "cxDBData"
#pragma link "cxEdit"
#pragma link "cxFilter"
#pragma link "cxGraphics"
#pragma link "cxGrid"
#pragma link "cxGridCustomTableView"
#pragma link "cxGridCustomView"
#pragma link "cxGridDBTableView"
#pragma link "cxGridLevel"
#pragma link "cxGridTableView"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxNavigator"
#pragma link "cxStyles"
#pragma link "dxSkinBlack"
#pragma link "dxSkinBlue"
#pragma link "dxSkinDevExpressDarkStyle"
#pragma link "dxSkinDevExpressStyle"
#pragma link "dxSkinFoggy"
#pragma link "dxSkinOffice2010Black"
#pragma link "dxSkinOffice2010Blue"
#pragma link "dxSkinOffice2010Silver"
#pragma link "dxSkinsCore"
#pragma link "dxSkinscxPCPainter"
#pragma link "dxSkinSevenClassic"
#pragma link "dxSkinVS2010"
#pragma link "cxDBLookupComboBox"
#pragma link "cxButtons"
#pragma resource "*.dfm"
Tod_raspored_stol* od_raspored_stol;

// ---------------------------------------------------------------------------
__fastcall Tod_raspored_stol::Tod_raspored_stol(TComponent* Owner, int idblend)
	:TForm(Owner)
{
	this->idblend = idblend;
	cdsOznakaStola->Active=false;
	cdsOznakaStola->Active=true;

	cdsStolovi->Active=false;
	cdsStolovi->Params->ParamByName("idBlenda")->AsInteger= this->idblend ;
	cdsStolovi->Active=true;

	cdsStatistika->Active=false;
	cdsStatistika->Params->ParamByName("idb")->AsInteger=this->idblend;
	cdsStatistika->Active=true;

	cdsBlend->Active=false;
	cdsBlend->Params->ParamByName("IDB")->AsInteger=this->idblend;
	cdsBlend->Active=true;


}

// ---------------------------------------------------------------------------
void __fastcall Tod_raspored_stol::cdsStoloviNewRecord(TDataSet* DataSet)
{
	spStolovi->Prepared = true;
	spStolovi->ExecProc();

	cdsStolovi->FieldByName("ID")->AsInteger = spStolovi->ParamByName("ID")->AsInteger;
	cdsStolovi->FieldByName("IDBLENDA")->AsInteger = this->idblend;
	cdsStolovi->FieldByName("Datum")->Value = Now();
	cdsStolovi->FieldByName("BROJ_BALA")->AsInteger = 0;
}

// ---------------------------------------------------------------------------
void __fastcall Tod_raspored_stol::btSnimiClick(TObject* Sender)
{
	SnimiCDS(dspStolovi, cdsStolovi, dsStolovi);
}
// ---------------------------------------------------------------------------
void __fastcall Tod_raspored_stol::btRasporedClick(TObject *Sender)
{

	float BrojStola                 = 1, KGnaStolu = 0, OstaloKG = 0, UKupnoKG = 0;
	float defaultKGPoStolu    = 0;
	float BrojStolova          = 10;
	float KGPoStolu = 0;
	float UKUPNOKG       = cdsBlend->FieldByName("UKUPNO_KG")->AsFloat;

	cdsStolovi->Active = false;
	dsetStolovi->ParamByName("idBlenda")->AsInteger = cdsBlend->FieldByName("ID")->AsInteger;
	cdsStolovi->Active = true;

	if (cdsStolovi->RecordCount > 0)
	{
		if (MessageDlg("Bale duvana su vec rasporedjene po stolovima ! \n\nDa li ipak zelite da nastavite?", mtWarning, TMsgDlgButtons() << mbYes << mbNo, 0) == mrNo)
			return;
	}
	try
	{

		cdsRasporedStolova->Active = false;
		sqlRasporedStolova->ParamByName("idb")->AsInteger = cdsBlend->FieldByName("id")->AsInteger;
		cdsRasporedStolova->Active = true;

		KGPoStolu = UKUPNOKG / BrojStolova;

		if (cdsRasporedStolova->RecordCount != 0)
			defaultKGPoStolu = (int)Ceil(KGPoStolu);

		cdsRasporedStolova->First();
		cdsOznakaStola->First();

		while (!cdsOznakaStola->Eof)
		{
			KGnaStolu = 0;
			UKupnoKG        = 0;

			while (!cdsRasporedStolova->Eof)
			{
				if (OstaloKG > 0) // 4
				{
					KGnaStolu = KGnaStolu + OstaloKG; // 0+0

					if (OstaloKG <= defaultKGPoStolu) // 0<6.6
					{
						UKupnoKG   = OstaloKG;
						OstaloKG = 0;
					}
					else
					{
						UKupnoKG   = defaultKGPoStolu;
						OstaloKG = OstaloKG - defaultKGPoStolu;
					}
				}
				else
				{
					KGnaStolu = KGnaStolu + cdsRasporedStolova->FieldByName("PROC_MG_KG")->AsFloat;
					UKupnoKG        = cdsRasporedStolova->FieldByName("PROC_MG_KG")->AsFloat;

					if (KGnaStolu > defaultKGPoStolu)
					{
						UKupnoKG   = defaultKGPoStolu - KGnaStolu + cdsRasporedStolova->FieldByName("PROC_MG_KG")->AsFloat;
						OstaloKG = cdsRasporedStolova->FieldByName("PROC_MG_KG")->AsFloat - UKupnoKG;
					}
				}
				if (UKupnoKG > 0)
				{
					cdsStolovi->Append();
					cdsStolovi->FieldByName("id_stola")->AsString = cdsOznakaStola->FieldByName("id")->AsString;
					cdsStolovi->FieldByName("int_klasa")->AsString = cdsRasporedStolova->FieldByName("int_klasa")->AsString;
					cdsStolovi->FieldByName("KG")->AsFloat = UKupnoKG;
					cdsStolovi->Post();
				}

				if (KGnaStolu > defaultKGPoStolu)
				{
					break;
				}

				cdsRasporedStolova->Next();
			}
			BrojStolova = BrojStolova - 1;

			UKUPNOKG = UKUPNOKG - defaultKGPoStolu;

			KGPoStolu   = UKUPNOKG / BrojStolova;
			defaultKGPoStolu = (int)Ceil(KGPoStolu);

			cdsOznakaStola->Next();
		}
		btSnimi->Enabled = true;
	}
	catch (Exception& e)
	{
	   //	 ShowMessage("Greska!! "+e.Message);
	}
	btSnimi->Enabled = true;
}
//---------------------------------------------------------------------------

