/******************************************   30.10.2013  *******************************************/
ALTER TABLE MG_STAV ADD NETOMASA_BA DOUBLE PRECISION;
ALTER TABLE SYSTEM_OD ADD DATUM_OD DATE;


/****************************************    14.10.2013   *******************************************/
ALTER TABLE OD_OZNAKA_BLENDA ADD SIFRA_PROIZVODA INTEGER;
/**************************************** do 14.10.2013   *******************************************/
ALTER TABLE OD_OBRADA_GP ADD TEZINA DOUBLE PRECISION;
ALTER TABLE OD_LIST ADD MAX_TEZINA DOUBLE PRECISION;
ALTER TABLE OD_LIST ADD MIN_TEZINA DOUBLE PRECISION;

ALTER TABLE TBLRADNICI ADD DOZVOLA_STAMPE SMALLINT;
update TBLRADNICI set DOZVOLA_STAMPE=0;

INSERT INTO TROLE_NAZIV_FORME (ID, NAZIV_FORME_MENI, NAZIV_FORME_PROGRAM, SOFTVER) VALUES (64, 'Obrada - NUS proizvodi', 'ODObradaPressaNUS', 'LEAF');
INSERT INTO MER_DEF_PORT (ID, PORT, DATA_BITS, BRZINA, STOP_BIT, PARITET, WAIT_TIME, START_STR, END_STR, NAPOMENA, PACKET_SIZE, MIN_VALUE, MAX_VALUE, PROVERA_VALUE, VAGA) VALUES (3, 1, 8, 9600, 1, 'pNone', 100, 'Wnk', 'l', NULL, 10, 10, 200, 1, 'VAGA_PRESA');
INSERT INTO MER_DEF_PORT (ID, PORT, DATA_BITS, BRZINA, STOP_BIT, PARITET, WAIT_TIME, START_STR, END_STR, NAPOMENA, PACKET_SIZE, MIN_VALUE, MAX_VALUE, PROVERA_VALUE, VAGA) VALUES (4, 1, 8, 9600, 1, 'pNone', 100, 'Wnk', 'l', NULL, 10, 10, 200, 1, 'VAGA_NUS');

ALTER TABLE TBALA_MG ADD KOLICINA DOUBLE PRECISION;
ALTER TABLE TBALA_MG ADD KOLICINA_ALT DOUBLE PRECISION;




CREATE TABLE PRTEH (
    ID               INTEGER NOT NULL,
    SIFRA_PROIZVODA  INTEGER,
    NAZIV            VARCHAR(50),
    DATUM            DATE DEFAULT 'NOW',
    ID_ODELJENJA     INTEGER,
    KOLICINA         DECIMAL(18,4),
    KOL_U_PJM        DECIMAL(18,4),
    OPIS             VARCHAR(60),
    ARTIKAL          VARCHAR(250),
    KOD              VARCHAR(20),
    JEDMERE          VARCHAR(10),
    IDJM             INTEGER,
    AKTIVAN          SMALLINT,
    SIFRA_MAGACINA   INTEGER,
    VERZIJA          VARCHAR(10),
    CENA             DECIMAL(18,4),
    DATE_CHANGE      TIMESTAMP,
    RADNIK_CHANGE    INTEGER
);




/******************************************************************************/
/***                              Primary Keys                              ***/
/******************************************************************************/

ALTER TABLE PRTEH ADD CONSTRAINT PK_PRTEH PRIMARY KEY (ID);


/******************************************************************************/
/***                              Foreign Keys                              ***/
/******************************************************************************/

ALTER TABLE PRTEH ADD CONSTRAINT FK_PRTEH_1 FOREIGN KEY (KOD) REFERENCES TBLARTIKLI (KOD);
ALTER TABLE PRTEH ADD CONSTRAINT FK_PRTEH_2 FOREIGN KEY (IDJM) REFERENCES TBLJM (ID);




CREATE TABLE PRNORMATIV (
    ID                INTEGER NOT NULL,
    ID_TEHPROCES      INTEGER,
    SIFRA_MATERIJALA  INTEGER,
    KOLICINA          DOUBLE PRECISION DEFAULT 0,
    KOLICINA_PJM      DOUBLE PRECISION DEFAULT 0,
    ZA_PRAVLJENJE     DOUBLE PRECISION DEFAULT 0,
    SIFRA_MG          INTEGER,
    TIPS              VARCHAR(1),
    TIP_OBRACUNA_KOL  VARCHAR(1),
    KOD               VARCHAR(20),
    ARTIKAL           VARCHAR(250),
    JEDMERE           VARCHAR(10),
    IDJM              INTEGER,
    PROCENAT_OTPISA   DOUBLE PRECISION,
    OSNOVNA           CHAR(1),
    DATE_CHANGE       TIMESTAMP,
    RADNIK_CHANGE     INTEGER
);




/******************************************************************************/
/***                              Primary Keys                              ***/
/******************************************************************************/

ALTER TABLE PRNORMATIV ADD CONSTRAINT PK_PRNORMATIV PRIMARY KEY (ID);


/******************************************************************************/
/***                              Foreign Keys                              ***/
/******************************************************************************/

ALTER TABLE PRNORMATIV ADD CONSTRAINT FK_PRNORMATIV_2 FOREIGN KEY (SIFRA_MG) REFERENCES TBLMAGACIN (SIFRA_MAGACINA);
ALTER TABLE PRNORMATIV ADD CONSTRAINT FK_PRNORMATIV_3 FOREIGN KEY (KOD) REFERENCES TBLARTIKLI (KOD);
ALTER TABLE PRNORMATIV ADD CONSTRAINT FK_PRNORMATIV_4 FOREIGN KEY (IDJM) REFERENCES TBLJM (ID);


/******************************************************************************/
/***                          Fields descriptions                           ***/
/******************************************************************************/

COMMENT ON COLUMN PRNORMATIV.OSNOVNA IS 
'Ako je stavka osnovna, onda se kolicina ostalih stavki normativa preracunavaju na osnovu kolicine osnovne stavke
D - jeste osnovna stavka
N - nije osnovna stavka';

ALTER TABLE PRNORMATIV ADD CONSTRAINT FK_PRNORMATIV_1 FOREIGN KEY (ID_TEHPROCES) REFERENCES PRTEH(ID);


CREATE SEQUENCE GEN_MG_STAV_NTM_ID;

create procedure sp_gen_mg_stav_ntm_id
returns (id integer)
as
begin
  id = gen_id(gen_mg_stav_ntm_id, 1);
  suspend;
end;

CREATE SEQUENCE GEN_MG_ZG_NTM_ID;

create procedure sp_gen_mg_zg_ntm_id
returns (id integer)
as
begin
  id = gen_id(gen_mg_zg_ntm_id, 1);
  suspend;
end;

CREATE TABLE MG_ZG_NTM (
    ID                INTEGER NOT NULL,
    BROJ              INTEGER,
    DATUM_RADA        DATE,
    DATUMDPO          DATE,
    SIFRA_KOMITENTA   INTEGER NOT NULL,
    SIFRA_DOKUMENTA   INTEGER NOT NULL,
    SIFRA_MAGACINA    INTEGER NOT NULL,
    VEZA              INTEGER,
    SIFRA_RADNIKA     INTEGER,
    SIFRA_MAGACINA_U  INTEGER,
    VEZA_IDN          INTEGER,
    BUD               VARCHAR(20),
    OPIS              VARCHAR(150),
    STATUS            INTEGER,
    VREME             TIMESTAMP,
    AKTIVAN           SMALLINT DEFAULT 0 NOT NULL,
    ZAVRSENO          SMALLINT DEFAULT 0 NOT NULL,
    PO                VARCHAR(20),
    IDBLENDA          INTEGER,
    RADNIK_DEL        INTEGER,
    VREME_DEL         TIMESTAMP,
    KOLICINA          DOUBLE PRECISION
);




/******************************************************************************/
/***                              Primary Keys                              ***/
/******************************************************************************/

ALTER TABLE MG_ZG_NTM ADD CONSTRAINT PK_MG_ZG_NTM PRIMARY KEY (ID);


/******************************************************************************/
/***                              Foreign Keys                              ***/
/******************************************************************************/

ALTER TABLE MG_ZG_NTM ADD CONSTRAINT FK_MG_ZG_NTM_1 FOREIGN KEY (SIFRA_KOMITENTA) REFERENCES TBLKOMITENTI (SIFRA_KOMITENTA);
ALTER TABLE MG_ZG_NTM ADD CONSTRAINT FK_MG_ZG_NTM_2 FOREIGN KEY (SIFRA_DOKUMENTA) REFERENCES TBLDOKUMENTI (SIFRA_DOKUMENTA);
ALTER TABLE MG_ZG_NTM ADD CONSTRAINT FK_MG_ZG_NTM_3 FOREIGN KEY (SIFRA_MAGACINA) REFERENCES TBLMAGACIN (SIFRA_MAGACINA);
ALTER TABLE MG_ZG_NTM ADD CONSTRAINT FK_MG_ZG_NTM_4 FOREIGN KEY (SIFRA_RADNIKA) REFERENCES TBLRADNICI (SIFRA_RADNIKA);
ALTER TABLE MG_ZG_NTM ADD CONSTRAINT FK_MG_ZG_NTM_5 FOREIGN KEY (RADNIK_DEL) REFERENCES TBLRADNICI (SIFRA_RADNIKA);


CREATE TABLE MG_STAV_NTM (
    ID             INTEGER NOT NULL,
    IDZG           INTEGER NOT NULL,
    MAGACIN_STAV   INTEGER,
    SIFRA_ROBE     INTEGER,
    KOD            VARCHAR(20),
    ARTIKAL        VARCHAR(150),
    JM             VARCHAR(10),
    ULAZ_KOL       DECIMAL(15,4),
    IZLAZ_KOL      DECIMAL(15,4),
    ULAZ_KOL_ALT   DECIMAL(15,4),
    IZLAZ_KOL_ALT  DECIMAL(15,4),
    VREME          TIMESTAMP,
    STATUS         SMALLINT,
    AKTIVAN        SMALLINT DEFAULT 0,
    RADNIK_DEL     INTEGER,
    VREME_DEL      TIMESTAMP
);




/******************************************************************************/
/***                              Primary Keys                              ***/
/******************************************************************************/

ALTER TABLE MG_STAV_NTM ADD CONSTRAINT PK_MG_STAV_NTM PRIMARY KEY (ID);


/******************************************************************************/
/***                              Foreign Keys                              ***/
/******************************************************************************/

ALTER TABLE MG_STAV_NTM ADD CONSTRAINT FK_MG_STAV_NTM_1 FOREIGN KEY (IDZG) REFERENCES MG_ZG_NTM (ID);
ALTER TABLE MG_STAV_NTM ADD CONSTRAINT FK_MG_STAV_NTM_2 FOREIGN KEY (SIFRA_ROBE) REFERENCES TBLARTIKLI (SIFRA_ROBE);
ALTER TABLE MG_STAV_NTM ADD CONSTRAINT FK_MG_STAV_NTM_3 FOREIGN KEY (MAGACIN_STAV) REFERENCES TBLMAGACIN (SIFRA_MAGACINA);


create or alter procedure OD_STATISTIKA_OBRADE (
    IDZG integer,
    BLEND integer,
    BATCH varchar(10))
returns (
    ID integer,
    IDBLENDA integer,
    GRADE varchar(20),
    BROJ_BALA double precision,
    RB integer,
    PROCENAT double precision,
    KOM_BALA double precision,
    TEZINA double precision,
    INT_KLASA varchar(10),
    PROCENAT_OBRADE double precision,
    POREKLO varchar(30),
    IDPOREKLA integer,
    PROV_POREKLA smallint)
as
BEGIN
  select z.prov_porekla from mg_zg z where z.id=:idzg into :prov_porekla;

  FOR
    select  s.id,
            s.idblenda,
            s.grade,
            s.broj_bala,
            s.rb,
            s.procenat,
            s.idporekla,
            p.opis
    from od_blend_stavke s left join tsistem_poreklo p on s.idporekla=p.id
    where s.idblenda=:blend
    order by s.rb
    INTO :ID,
         :IDBLENDA,
         :GRADE,
         :BROJ_BALA,
         :RB,
         :PROCENAT,
         :idporekla,
         :poreklo
  DO
  BEGIN
    kom_bala=0; tezina=0; int_klasa='';

    if(prov_porekla = 1) then   --sa proverom porekla
      begin
        select sum(s.izlaz_kol), sum(s.izlaz_kol_alt), s.kod
        from mg_zg o inner join mg_stav s on o.id=s.idzg
        where  o.idblend =:IDBLENDA
        and o.id=:IDZG
        and s.kod=:grade
        and s.status = 40
        and s.idporekla=:idporekla
        group by s.kod
        into  :kom_bala, :tezina, :int_klasa;
      end
    else                        --bez provere porekla
      begin
        select sum(s.izlaz_kol), sum(s.izlaz_kol_alt), s.kod
        from mg_zg o inner join mg_stav s on o.id=s.idzg
        where  o.idblend =:IDBLENDA
        and o.id=:IDZG
        and s.kod=:grade
        and s.status = 40
        group by s.kod
        into  :kom_bala, :tezina, :int_klasa;
      end


    if(broj_bala <> 0) then procenat_obrade = (100.0000*kom_bala/broj_bala);
    else                    procenat_obrade = 0;

    SUSPEND;
  END
END;


ALTER TABLE OD_BLEND
ADD UKUPNO_KG DOUBLE PRECISION;


ALTER TABLE TBALA_MG
ADD MAGACIN VARCHAR(1);

ALTER TABLE MG_STAV
ADD MAGACIN VARCHAR(1);

