/******************************************************************************/
/****              Generated by IBExpert 03.09.2018 13:33:01               ****/
/******************************************************************************/



/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE OD_OZNAKA_BLENDA (
    ID             INTEGER NOT NULL,
    OZNAKA_BLENDA  VARCHAR(10) NOT NULL,
    OPIS           VARCHAR(250),
    SIFRA_RADNIKA  INTEGER,
    VREME          TIMESTAMP,
    PROV_POREKLA   SMALLINT
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE OD_OZNAKA_BLENDA ADD CONSTRAINT PK_OD_OZNAKA_BLENDA PRIMARY KEY (ID);


/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE OD_OZNAKA_BLENDA ADD CONSTRAINT FK_OD_OZNAKA_BLENDA_1 FOREIGN KEY (SIFRA_RADNIKA) REFERENCES TBLRADNICI (SIFRA_RADNIKA);


/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/



ALTER TABLE OD_OZNAKA_BLENDA
ADD OPIS VARCHAR(250);
ALTER TABLE OD_OZNAKA_BLENDA
ADD SIFRA_RADNIKA INTEGER;
ALTER TABLE OD_OZNAKA_BLENDA
ADD VREME TIMESTAMP;

alter table OD_OZNAKA_BLENDA
add constraint FK_OD_OZNAKA_BLENDA_1
foreign key (SIFRA_RADNIKA)
references TBLRADNICI(SIFRA_RADNIKA);

update RDB$RELATION_FIELDS set
RDB$NULL_FLAG = 1
where (RDB$FIELD_NAME = 'OZNAKA_BLENDA') and
(RDB$RELATION_NAME = 'OD_OZNAKA_BLENDA')
;


INSERT INTO OD_OZNAKA_BLENDA (ID, OZNAKA_BLENDA, OPIS, SIFRA_RADNIKA, VREME) VALUES (1, 'FCD', NULL, 11, '2011-09-08 11:36:05');
INSERT INTO OD_OZNAKA_BLENDA (ID, OZNAKA_BLENDA, OPIS, SIFRA_RADNIKA, VREME) VALUES (2, 'FLD', NULL, 11, '2011-09-08 11:36:16');
INSERT INTO OD_OZNAKA_BLENDA (ID, OZNAKA_BLENDA, OPIS, SIFRA_RADNIKA, VREME) VALUES (3, 'FME', NULL, 11, '2011-09-08 11:36:21');
INSERT INTO OD_OZNAKA_BLENDA (ID, OZNAKA_BLENDA, OPIS, SIFRA_RADNIKA, VREME) VALUES (4, 'BCD', NULL, 11, '2011-09-08 11:36:29');
INSERT INTO OD_OZNAKA_BLENDA (ID, OZNAKA_BLENDA, OPIS, SIFRA_RADNIKA, VREME) VALUES (5, 'BLD', NULL, 11, '2011-09-08 11:36:31');
INSERT INTO OD_OZNAKA_BLENDA (ID, OZNAKA_BLENDA, OPIS, SIFRA_RADNIKA, VREME) VALUES (6, 'BME', NULL, 11, '2011-09-08 11:36:35');

COMMIT WORK;


INSERT INTO OD_ETIKETE_GP (ID, DEALER, ORIGIN, BERBA, STAND_NETO, STAND_TARA, IZMENA, SIFRA_RADNIKA, AKTIVAN) VALUES (1, 'JT International AD Senta', 'SERBIA', 2011, 200, 14, NULL, 10, 1);

COMMIT WORK;


INSERT INTO OD_LIST (ID, NAZIV, OZNAKA, OPIS, SIFRA_RADNIKA, VREME, SAP_BATCH, MO_PI, BATCH) VALUES ('STRIPS', 'Strips Virdzinija', 'XCSFCB', NULL, NULL, NULL, '0003699495', 'CS0003-10JT', '3');
INSERT INTO OD_LIST (ID, NAZIV, OZNAKA, OPIS, SIFRA_RADNIKA, VREME, SAP_BATCH, MO_PI, BATCH) VALUES ('STEM', 'Dugo rebro Virdzinija', 'XCSFCD', NULL, NULL, NULL, '0003699496', 'CS0004-10JT', '2');
INSERT INTO OD_LIST (ID, NAZIV, OZNAKA, OPIS, SIFRA_RADNIKA, VREME, SAP_BATCH, MO_PI, BATCH) VALUES ('LAMINA', 'Sitnjavina Virdzinija', 'ZCSXF', NULL, NULL, NULL, '0003699509', 'CS0015-10JT', '2');
INSERT INTO OD_LIST (ID, NAZIV, OZNAKA, OPIS, SIFRA_RADNIKA, VREME, SAP_BATCH, MO_PI, BATCH) VALUES ('STEM2', 'Kratko rebro Virdzinija', 'ZCSSFMM', NULL, NULL, NULL, '0003699506', 'CS0012-10JT', '2');

COMMIT WORK;


ALTER TABLE OD_LIST
ADD TIP_STAMPE SMALLINT;





CREATE INDEX OD_VAKUMIRANJE_IDX3
ON OD_VAKUMIRANJE (TEMP_MASA);
CREATE INDEX OD_VAKUMIRANJE_IDX2
ON OD_VAKUMIRANJE (STATUS);
CREATE INDEX OD_VAKUMIRANJE_IDX1
ON OD_VAKUMIRANJE (DELETED);
CREATE INDEX OD_VAKUMIRANJE_IDX4
ON OD_VAKUMIRANJE (BRBARKODA);


/* ******************************* 10.09.2011 ******************************* */
CREATE TABLE SYSTEM_OD (
    ID INTEGER NOT NULL,
    EXT_MR_TEZINE SMALLINT);
alter table SYSTEM_OD
add constraint PK_SYSTEM_OD
primary key (ID);

SET TERM ^ ;

CREATE OR ALTER PROCEDURE TEZINA_OD (
    masa decimal(15,2),
    mg integer,
    doc integer,
    datum date)
returns (
    id integer,
    brbarkod integer)
as
declare variable status smallint;
declare variable meri_prg integer;
begin
 select o.ext_mr_tezine from system_od o into :meri_prg;

if(meri_prg = 1) then
begin
 mg=100;
 doc=6001;
 select vakumiranje from od_status_merenja into :status;

 if(status <> 1) then
   begin
        SELECT first 1 Min(s.id), s.barkod
          FROM mg_zg z inner join mg_stav s on z.id=s.idzg
            and s.deleted<>1
            and z.sifra_magacina=:mg
            and z.sifra_dokumenta=:doc
            and z.datumdpo=:datum
            and s.izlaz_kol>0
          GROUP BY s.temp_masa,s.barkod
          HAVING s.temp_masa Is Null
          into :id, :BRBARKOD;

        update mg_stav set temp_masa=:masa, izlaz_kol_alt=:masa where mg_stav.id =:id;
   end
 else
   begin
        SELECT first 1 Min(v.id), v.brbarkoda
          FROM od_vakumiranje v
          where   v.deleted=0
          and     v.status=0
          GROUP BY v.brbarkoda, v.temp_masa
          HAVING v.temp_masa Is Null
          into :id, :BRBARKOD;

          update od_vakumiranje set temp_masa=:masa, tezina=:masa where id =:id;
   end

  suspend;
end
end^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE TBALA_DNEVNI_IZV_INTKL (
    sid integer,
    pocdat date,
    krajdat date)
returns (
    oznaka varchar(20),
    klasa varchar(25),
    daily_entries numeric(18,2),
    cenaklase numeric(18,2),
    vrednost numeric(18,4),
    broj_bala integer,
    neto_masa numeric(18,2),
    avr_price numeric(18,2),
    kolic_iz_dnev numeric(18,2),
    proscena_iz_dnev numeric(18,2),
    vred_iz_dnev numeric(18,2),
    kolic_izlaz numeric(18,2),
    kolic_zalihe numeric(18,2),
    vred_zalihe numeric(18,2),
    proscena_zalihe numeric(18,2),
    kolic_bruto_zalihe numeric(18,2),
    prosvlaga_zalihe numeric(18,2))
as
BEGIN
  FOR
    SELECT
                   m.OZNAKA,
                   k.KLASA,
                   0.00 as DAILY_ENTRIES,
                   b.CENAKLASE,
                   SUM(b.CENAKLASE*b.NETOMASA) as Vrednost,
                   COUNT(*) as broj_bala,
                   SUM(b.NETOMASA) as neto_masa,
    
                   0.00 as AVR_PRICE,
                   0.00 as KOLIC_IZ_DNEV,
                   0.00 as PROSCENA_IZ_DNEV,
                   0.00 as VRED_IZ_DNEV,
                   0.00 as KOLIC_IZLAZ,
                   0.00 as KOLIC_ZALIHE,
                   0.00 as VRED_ZALIHE,
                   0.00 as PROSCENA_ZALIHE,
                   0.00 as KOLIC_BRUTO_ZALIHE,
                   0.00 as PROSVLAGA_ZALIHE
    
            FROM TBALA b INNER JOIN TSISTEMKLASACENA k ON (b.KLASA = k.KLASACENAID) AND (b.SORTAID = k.SORTAID) and (b.SORTAID=:SID)
                                AND b.uobradiod BETWEEN :POCDAT AND :KRAJDAT
                                AND b.obrisano<>1
                          INNER JOIN TSISTEMMAGACIN m ON b.klasaid = m.MAGACINID
    
            GROUP BY    m.OZNAKA,
                        k.KLASA,
                        b.CENAKLASE
            ORDER BY m.OZNAKA, k.klasa
    INTO :OZNAKA,
         :KLASA,
         :DAILY_ENTRIES,
         :CENAKLASE,
         :VREDNOST,
         :BROJ_BALA,
         :NETO_MASA,
         :AVR_PRICE,
         :KOLIC_IZ_DNEV,
         :PROSCENA_IZ_DNEV,
         :VRED_IZ_DNEV,
         :KOLIC_IZLAZ,
         :KOLIC_ZALIHE,
         :VRED_ZALIHE,
         :PROSCENA_ZALIHE,
         :KOLIC_BRUTO_ZALIHE,
         :PROSVLAGA_ZALIHE
  DO
  BEGIN
    SUSPEND;
  END
END
^

SET TERM ; ^

ALTER TABLE OD_OBRADA_GP
ADD ID_BLENDA INTEGER;
ALTER TABLE OD_OBRADA_GP
ADD IDZG INTEGER;

ALTER TABLE OD_OBRADA_GP
ADD INT_BARKOD VARCHAR(15);
ALTER TABLE OD_OBRADA_GP
ADD IDOZBLENDA INTEGER;
/* ********************************************************************************** */
ALTER TABLE OD_BLEND_STAVKE
ADD IDPOREKLA INTEGER;
ALTER TABLE MG_STAV
ADD IDPOREKLA INTEGER;


SET TERM ^ ;

CREATE OR ALTER PROCEDURE OD_STATISTIKA_OBRADE (
    idzg integer,
    blend integer,
    batch varchar(10))
returns (
    id integer,
    idblenda integer,
    grade varchar(20),
    broj_bala double precision,
    rb integer,
    procenat double precision,
    kom_bala integer,
    tezina double precision,
    int_klasa varchar(10),
    procenat_obrade double precision,
    poreklo varchar(30),
    idporekla integer)
as
BEGIN
  FOR
    select  s.id,
            s.idblenda,
            s.grade,
            s.broj_bala,
            s.rb,
            s.procenat,
            s.idporekla,
            p.opis
    from od_blend_stavke s inner join tsistem_poreklo p on s.idporekla=p.id
    where s.idblenda=:blend
    order by s.rb
    INTO :ID,
         :IDBLENDA,
         :GRADE,
         :BROJ_BALA,
         :RB,
         :PROCENAT,
         :idporekla,
         :poreklo
  DO
  BEGIN
    kom_bala=0; tezina=0; int_klasa='';

    select count(*), sum(s.izlaz_kol_alt), s.kod
    from mg_zg o inner join mg_stav s on o.id=s.idzg
    where  o.idblend =:IDBLENDA
    and o.id=:IDZG
    and s.kod=:grade
    and s.status = 4
    and s.idporekla=:idporekla
    group by s.kod
    into  :kom_bala, :tezina, :int_klasa;

    if(broj_bala <> 0) then procenat_obrade = (100.0000*kom_bala/broj_bala);
    else                    procenat_obrade = 0;

    SUSPEND;
  END
END^

SET TERM ; ^


ALTER TABLE OD_LIST
ADD DOZNAKA VARCHAR(3);

ALTER TABLE OD_LIST ADD NETO_AMB DOUBLE PRECISION;
ALTER TABLE OD_LIST ADD TARA_AMB DOUBLE PRECISION;
ALTER TABLE MG_ZG ADD DATUM_OD TIMESTAMP;
ALTER TABLE OD_BLEND ADD IDBLENDA INTEGER;

ALTER TABLE OD_BLEND ADD BROJ_BL_KOOPERANTA INTEGER;
ALTER TABLE MG_STAV ADD KOOPERANTID INTEGER;



/* ******************************************************************************************** */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE TBALA_DNEVNI_IZV_INTKL (
    sid integer,
    pocdat date,
    krajdat date)
returns (
    oznaka varchar(20),
    klasa varchar(25),
    daily_entries numeric(18,2),
    cenaklase numeric(18,2),
    vrednost numeric(18,4),
    broj_bala integer,
    neto_masa numeric(18,2),
    avr_price numeric(18,2),
    kolic_iz_dnev numeric(18,2),
    proscena_iz_dnev numeric(18,2),
    vred_iz_dnev numeric(18,2),
    kolic_izlaz numeric(18,2),
    kolic_zalihe numeric(18,2),
    vred_zalihe numeric(18,2),
    proscena_zalihe numeric(18,2),
    kolic_bruto_zalihe numeric(18,2),
    prosvlaga_zalihe numeric(18,2),
    int_klasa integer,
    ext_klasa integer)
as
declare variable mg integer;
declare variable doc integer;
BEGIN
  mg=10;
  doc=6001;

  FOR
    SELECT
                   m.OZNAKA,
                   k.KLASA,
                   0.00 as DAILY_ENTRIES,
                   b.CENAKLASE,
                   0 as Vrednost,
                   COUNT(*) as broj_bala,
                   SUM(b.NETOMASA) as neto_masa,
    
                   0.00 as AVR_PRICE,
                   0.00 as KOLIC_IZ_DNEV,
                   0.00 as PROSCENA_IZ_DNEV,
                   0.00 as VRED_IZ_DNEV,
                   0.00 as KOLIC_IZLAZ,
                   0.00 as KOLIC_ZALIHE,
                   0.00 as VRED_ZALIHE,
                   0.00 as PROSCENA_ZALIHE,
                   0.00 as KOLIC_BRUTO_ZALIHE,
                   0.00 as PROSVLAGA_ZALIHE,
                   b.klasa,
                   b.klasaid
    
            FROM TBALA b INNER JOIN TSISTEMKLASACENA k ON (b.KLASA = k.KLASACENAID) AND (b.SORTAID = k.SORTAID) and (b.SORTAID=:SID)
                                AND b.uobradiod BETWEEN :POCDAT AND :KRAJDAT
                                AND b.obrisano<>1
                          INNER JOIN TSISTEMMAGACIN m ON b.klasaid = m.MAGACINID
    
            GROUP BY    m.OZNAKA,
                        k.KLASA,
                        b.CENAKLASE,
                        b.klasa,
                        b.klasaid
            ORDER BY m.OZNAKA, k.klasa
    INTO :OZNAKA,
         :KLASA,
         :DAILY_ENTRIES,
         :CENAKLASE,
         :VREDNOST,
         :BROJ_BALA,
         :NETO_MASA,
         :AVR_PRICE,
         :KOLIC_IZ_DNEV,
         :PROSCENA_IZ_DNEV,
         :VRED_IZ_DNEV,
         :KOLIC_IZLAZ,
         :KOLIC_ZALIHE,
         :VRED_ZALIHE,
         :PROSCENA_ZALIHE,
         :KOLIC_BRUTO_ZALIHE,
         :PROSVLAGA_ZALIHE,
         :ext_klasa,
         :int_klasa
  DO
  BEGIN
    select sum(b.netomasa)
    from tbala b
    where b.uobradiod=:KRAJDAT
    and   b.klasa=:ext_klasa
    and   b.klasaid=:int_klasa
    group by b.uobradiod, b.klasa, b.klasaid
    into  :DAILY_ENTRIES ;

    VREDNOST=DAILY_ENTRIES*CENAKLASE;

    SELECT SUM(b.netomasa)
    FROM MG_ZG z INNER JOIN MG_STAV s ON z.id=s.idzg
                 INNER JOIN TBALA_MG b ON b.balaid=s.balaid and b.obrisano=0
    where z.sifra_magacina=:mg
    and   z.sifra_dokumenta=:doc
    and   CAST(z.datum_od AS DATE) = :KRAJDAT
    and   b.klasa=  :ext_klasa
    and   b.klasaid=:int_klasa
    group by z.sifra_magacina, z.sifra_dokumenta
    into :KOLIC_IZ_DNEV;

    SELECT SUM(b.netomasa)
    FROM MG_ZG z INNER JOIN MG_STAV s ON z.id=s.idzg
                 INNER JOIN TBALA_MG b ON b.balaid=s.balaid and b.obrisano=0
    where z.sifra_magacina=:mg
    and   z.sifra_dokumenta=:doc
    and   CAST(z.datum_od AS DATE) between :POCDAT and :KRAJDAT
    and   b.klasa=  :ext_klasa
    and   b.klasaid=:int_klasa
    group by z.sifra_magacina, z.sifra_dokumenta --, z.datumdpo  --, s.kod, s.klasaid
    into :KOLIC_IZLAZ;

    KOLIC_ZALIHE = NETO_MASA - KOLIC_IZLAZ;
    VRED_ZALIHE  = KOLIC_ZALIHE*CENAKLASE;

    SUSPEND;
  END
END^

SET TERM ; ^

ALTER TABLE OD_LIST
ADD LIST VARCHAR(10);

SET TERM ^ ;

CREATE OR ALTER PROCEDURE OD_PRG_OBRADA_DUVANA (
    od_datuma date,
    do_datuma date)
returns (
    datum date,
    grade varchar(10),
    idzg integer,
    batch_no varchar(10),
    list varchar(10),
    neto double precision,
    broj_bala integer,
    oznaka_blenda varchar(10))
as
BEGIN
  FOR
    SELECT cast(g.datum as date),
           g.grade,
           g.idzg,
           g.batch_no,
           l.list,
           SUM(g.neto) as neto,
           COUNT(*)as broj_bala,
           b.oznaka_blenda
    
    FROM  OD_OBRADA_GP g inner join od_list l ON l.OZNAKA=g.grade and CAST(g.datum AS DATE) BETWEEN :OD_DATUMA AND :DO_DATUMA AND g.deleted=0
                         LEFT JOIN od_oznaka_blenda b ON b.id=g.idozblenda
    GROUP BY g.datum,
           g.grade,
           l.list,
           b.oznaka_blenda,
           g.idzg,
           g.batch_no
    INTO :DATUM,
         :GRADE,
         :IDZG,
         :BATCH_NO,
         :LIST,
         :NETO,
         :BROJ_BALA,
         :OZNAKA_BLENDA
  DO
  BEGIN
    SUSPEND;
  END
END
^

SET TERM ; ^

ALTER TABLE OD_OBRADA_GP ADD BLOKIRAJ SMALLINT;
ALTER TABLE OD_OBRADA_GP ADD STATUS INTEGER;

/*   **************************************************************************************************** */
/*   *************************************** 25.09.2011************************************************** */
/*   **************************************************************************************************** */

ALTER TABLE TBALA_MG ADD TIP_PROIZVODA INTEGER;
update tbala_mg set tip_proizvoda=4, barkod=brbarkoda where brbarkoda<1000000;
update mg_stav set barkod=broj_serije where barkod is null;

ALTER TABLE TBALA_MG ADD BARKOD VARCHAR(20);
ALTER TABLE OD_OBRADA_GP ADD ZAPRIMLJENA SMALLINT;
CREATE INDEX TBALA_MG_IDX3 ON TBALA_MG (BARKOD);
CREATE INDEX MG_STAV_IDX2 ON MG_STAV (BARKOD);

ALTER TABLE TBALA_MG DROP CONSTRAINT FK_TBALA_MG_1;
ALTER TABLE TBALA_MG DROP CONSTRAINT FK_TBALA_MG_2;
ALTER TABLE TBALA_MG DROP CONSTRAINT FK_TBALA_MG_3;
ALTER TABLE TBALA_MG DROP CONSTRAINT FK_TBALA_MG_4;
ALTER TABLE TBALA_MG DROP CONSTRAINT FK_TBALA_MG_5;
ALTER TABLE TBALA_MG DROP CONSTRAINT FK_TBALA_MG_6;

update RDB$RELATION_FIELDS set RDB$NULL_FLAG = NULL where (RDB$FIELD_NAME = 'PODSORTAID') and (RDB$RELATION_NAME = 'TBALA_MG');
update RDB$RELATION_FIELDS set RDB$NULL_FLAG = NULL where (RDB$FIELD_NAME = 'KLASA') and (RDB$RELATION_NAME = 'TBALA_MG');
update RDB$RELATION_FIELDS set RDB$NULL_FLAG = NULL where (RDB$FIELD_NAME = 'AMBALAZA') and (RDB$RELATION_NAME = 'TBALA_MG');
update RDB$RELATION_FIELDS set RDB$NULL_FLAG = NULL where (RDB$FIELD_NAME = 'PRASINA') and (RDB$RELATION_NAME = 'TBALA_MG');
update RDB$RELATION_FIELDS set RDB$NULL_FLAG = NULL where (RDB$FIELD_NAME = 'VLAGA') and (RDB$RELATION_NAME = 'TBALA_MG');
update RDB$RELATION_FIELDS set RDB$NULL_FLAG = NULL where (RDB$FIELD_NAME = 'KOOPERANTID') and (RDB$RELATION_NAME = 'TBALA_MG');
update RDB$FIELDS set RDB$FIELD_LENGTH = 15, RDB$CHARACTER_LENGTH = 15 where RDB$FIELD_NAME = 'RDB$2616' ;

update RDB$FIELDS set RDB$FIELD_LENGTH = 20, RDB$CHARACTER_LENGTH = 20 where RDB$FIELD_NAME = 'RDB$4781' ;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE AZURIRANJE_MG_WH (
    mg integer)
returns (
    sifra_mg integer,
    balaid integer,
    lokacija integer,
    barkod varchar(20))
as
begin
  for
   select z.sifra_magacina, s.balaid, s.barkod
   from mg_zg z inner join mg_stav s on (s.idzg=z.id)
   group by 1,2,3
   having sum(s.ulaz_kol-s.izlaz_kol)>0
   into :sifra_mg,
        :balaid,
        :barkod
  do
  begin

   update tbala_mg m
   set m.sifra_mg=:sifra_mg
   where m.barkod=:barkod;

  end
end
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE MG_BALA (
    mg integer,
    barkod_b varchar(10),
    grupa_b integer)
returns (
    kod varchar(20),
    balaid integer,
    broj_serije varchar(10),
    grupa integer,
    ulaz decimal(18,4),
    izlaz decimal(18,4),
    stanje decimal(18,4))
as
BEGIN
  FOR
    SELECT
               s.kod,
               m.balaid,
               s.broj_serije,
               m.grupa,
               CAST(SUM(s.ULAZ_KOL) AS DECIMAL(18,4)) AS ULAZ,
               CAST(SUM(s.IZLAZ_KOL) AS DECIMAL(18,4)) AS IZLAZ,
               CAST(SUM(s.ULAZ_KOL-s.IZLAZ_KOL) AS DECIMAL(18,4)) AS STANJE
        
    
        FROM  mg_zg z INNER JOIN MG_STAV s ON s.IDZG = z.ID and z.sifra_magacina=:mg
                      INNER JOIN tbala_mg m ON m.barkod=s.barkod
                                 and (m.grupa=:grupa_b or m.barkod=:barkod_b)
    
        GROUP BY s.kod,m.balaid, s.broj_serije, m.grupa
    INTO
         :KOD,
         :BALAID,
         :BROJ_SERIJE,
         :GRUPA,
         :ULAZ,
         :IZLAZ,
         :STANJE
  DO
  BEGIN
    SUSPEND;
  END
END
^

SET TERM ; ^

ALTER TABLE OD_OBRADA_GP ADD ZAPRIMLJENA SMALLINT;
CREATE INDEX TBALA_MG_IDX3 ON TBALA_MG (BARKOD);
CREATE INDEX MG_STAV_IDX2 ON MG_STAV (BARKOD);

CREATE TABLE TBALA_REKLAS (
    ID             INTEGER NOT NULL,
    BARKOD         INTEGER,
    KLASAID_OLD    INTEGER,
    KLASAID_NEW    INTEGER,
    VREME          TIMESTAMP,
    SIFRA_RADNIKA  INTEGER
);
ALTER TABLE TBALA_REKLAS ADD CONSTRAINT PK_TBALA_REKLAS PRIMARY KEY (ID);
ALTER TABLE MG_STAV DROP CONSTRAINT FK_MG_STAV_3;

/*   **************************************************************************************************** */
/*   *************************************** 04.10.2011************************************************** */
/*   **************************************************************************************************** */

ALTER TABLE TBALA_REKLAS ADD ID_STAVKE INTEGER;


CREATE TABLE OD_HEARSON (
    ID INTEGER NOT NULL,
    SIFRA_RADNIKA INTEGER,
    DATUM DATE,
    DATUMRADA TIMESTAMP,
    RADNIK_CHANGE INTEGER,
    VREME_CHANGE TIMESTAMP,
    MERENJE_START TIMESTAMP,
    MERENJE_STOP TIMESTAMP,
    PRITISAK_START DOUBLE PRECISION,
    PRITISAK_STOP DOUBLE PRECISION,
    TEMP_START DOUBLE PRECISION,
    TEMP_STOP DOUBLE PRECISION);
alter table OD_HEARSON
add constraint PK_OD_HEARSON
primary key (ID);

alter table OD_HEARSON
add constraint FK_OD_HEARSON_1
foreign key (SIFRA_RADNIKA)
references TBLRADNICI(SIFRA_RADNIKA);

ALTER TABLE OD_HEARSON
ADD VLAGA_START DOUBLE PRECISION;
ALTER TABLE OD_HEARSON
ADD VLAGA_STOP DOUBLE PRECISION;


CREATE TABLE OD_HEARSON_STAVKE (
    ID INTEGER NOT NULL,
    IDZ INTEGER NOT NULL,
    BROJ_TACNE INTEGER,
    TEZINA_TACNE DOUBLE PRECISION,
    TEZINA_BRUTO DOUBLE PRECISION,
    DUVAN_PRE_SUS DOUBLE PRECISION,
    TACNA_POSLE_SUS DOUBLE PRECISION,
    BROJ_KUTIJE INTEGER,
    GRADE VARCHAR(20),
    VREME TIMESTAMP,
    SIFRA_RADNIKA INTEGER,
    RADNIK_CHANGE INTEGER,
    VREME_CHANGE TIMESTAMP,
    VLAGA_SADRZAJ DOUBLE PRECISION,
    VLAGA_H DOUBLE PRECISION,
    VLAGA_M DOUBLE PRECISION,
    VLAGA_TARGET DOUBLE PRECISION,
    UCL DOUBLE PRECISION,
    LCL DOUBLE PRECISION);
alter table OD_HEARSON_STAVKE
add constraint PK_OD_HEARSON_STAVKE
primary key (ID);


CREATE SEQUENCE GEN_OD_HEARSON_STAVKE_ID;
SET TERM ^ ;

CREATE PROCEDURE SP_GEN_OD_HEARSON_STAVKE_ID
RETURNS (ID INTEGER)
AS
BEGIN
  ID = GEN_ID(GEN_OD_HEARSON_STAVKE_ID, 1);
  SUSPEND;
END

^

SET TERM ; ^

CREATE SEQUENCE GEN_OD_HEARSON_ID;
SET TERM ^ ;

CREATE PROCEDURE SP_GEN_OD_HEARSON_ID
RETURNS (ID INTEGER)
AS
BEGIN
  ID = GEN_ID(GEN_OD_HEARSON_ID, 1);
  SUSPEND;
END

^

SET TERM ; ^

/*   **************************************************************************************************** */
/*   *************************************** 07.10.2011************************************************** */
/*   **************************************************************************************************** */

ALTER TABLE OD_HEARSON ADD IDSMENE VARCHAR(10);
ALTER TABLE OD_HEARSON ADD PROTOK_V DOUBLE PRECISION;

CREATE TABLE OD_LAB_TACNE (
    ID INTEGER NOT NULL,
    OPIS VARCHAR(30));
alter table OD_LAB_TACNE
add constraint PK_OD_LAB_TACNE
primary key (ID);

ALTER TABLE OD_LIST ADD VLAGA_TARGET DOUBLE PRECISION;
ALTER TABLE OD_LIST ADD UCL DOUBLE PRECISION;
ALTER TABLE OD_LIST ADD LCL DOUBLE PRECISION;

ALTER TABLE OD_HEARSON_STAVKE ADD IDSMENE VARCHAR(10);

update RDB$FIELDS set
RDB$FIELD_LENGTH = 20,
RDB$CHARACTER_LENGTH = 20
where RDB$FIELD_NAME = 'RDB$4781';

ALTER TABLE OD_OBRADA_GP ADD DATUM_ETIKETE TIMESTAMP;

/*   **************************************************************************************************** */
/*   *************************************** 07.10.2011************************************************** */
/*   **************************************************************************************************** */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE OD_KUTIJE_DUVANA (
    od_datuma date,
    do_datuma date)
returns (
    case_no integer,
    grade varchar(10),
    mopi varchar(15),
    sap_batch varchar(10),
    int_barkod varchar(15),
    datum_etikete timestamp,
    datum_obrade timestamp,
    neto double precision,
    tara double precision,
    bruto double precision,
    batch_no varchar(10),
    datum_prijema timestamp,
    sifra_mg integer,
    sifra_mg_u integer,
    sifra_lokacije integer,
    magacin varchar(50),
    magacin_u varchar(50),
    lokacija varchar(50))
as
BEGIN
  FOR
    SELECT
            g.case_no,
            g.grade,
            g.mopi,
            g.sap_batch,
            g.int_barkod,
            g.datum_etikete,
            g.datum as datum_obrade,
            g.neto,
            g.tara,
            g.bruto,
            g.batch_no,
            b.datum_prijema,
            b.sifra_mg,
            b.sifra_mg_u,
            b.sifra_lokacije,
            mg1.magacin as magacin,
            mg2.magacin as magacin_u,
            l.lokacija
        
        FROM   TBALA_MG  b  inner join od_obrada_gp g   ON g.int_barkod=b.barkod
                            left  join tblmagacin    mg1 ON (mg1.sifra_magacina=b.sifra_mg)
                            left  join tbllokacije   l   ON (l.sifra_lokacije = b.sifra_lokacije)
                            left  join tblmagacin    mg2 ON (mg2.sifra_magacina=b.sifra_mg_u)
        where cast(b.datum_prijema as date) between :od_datuma and :do_datuma and g.deleted=0
        ORDER BY g.int_barkod
    INTO :CASE_NO,
         :GRADE,
         :MOPI,
         :SAP_BATCH,
         :INT_BARKOD,
         :DATUM_ETIKETE,
         :DATUM_OBRADE,
         :NETO,
         :TARA,
         :BRUTO,
         :BATCH_NO,
         :DATUM_PRIJEMA,
         :SIFRA_MG,
         :SIFRA_MG_U,
         :SIFRA_LOKACIJE,
         :MAGACIN,
         :MAGACIN_U,
         :LOKACIJA
  DO
  BEGIN
    SUSPEND;
  END
END
^
s
SET TERM ; ^

ALTER TABLE OD_HEARSON_STAVKE ADD IDBLENDA INTEGER;
ALTER TABLE OD_PROCESSING ADD OPIS VARCHAR(150);

/*   **************************************************************************************************** */
/*   *************************************** 20.10.2011************************************************** */
/*   **************************************************************************************************** */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE OD_PREGLED_OTP_MG (
    od_datuma date,
    do_datuma date,
    mg integer,
    doc integer)
returns (
    datumdpo date,
    broj integer,
    balaid integer,
    broj_serije varchar(10),
    kod varchar(20),
    klasa varchar(25),
    grupa integer,
    rack integer,
    idbranja varchar(10),
    iduzgoja varchar(10),
    branje varchar(200),
    uzgoja varchar(200),
    sifra_robe integer,
    izlaz_kol decimal(18,4),
    izlaz_kol_alt decimal(18,4),
    ambalaza_kg numeric(18,4),
    brutomasa double precision)
as
BEGIN
  FOR
    SELECT 
            m.datumdpo,
            m.broj,
            s.balaid,
            s.broj_serije,
            s.kod,
            c.klasa,
            s.grupa,
            s.rack,
            s.idbranja,
            s.iduzgoja,
            nb.naziv as branje,
            nu.naziv as uzgoja,
            s.sifra_robe,
            s.izlaz_kol,
            s.izlaz_kol_alt,
            (b.ambalaza/1000.0000) as ambalaza_kg,
            b.brutomasa
    
        FROM       MG_ZG m INNER JOIN MG_STAV S ON (m.id=s.idzg) and m.datumdpo between :od_datuma and :do_datuma and m.sifra_magacina=:mg and m.sifra_dokumenta=:doc
                          INNER JOIN TBALA b ON b.brbarkoda=s.barkod
                          INNER JOIN tsistemklasacena c ON c.klasacenaid=b.klasaid

                          LEFT JOIN tsistem_nbranja nb ON nb.oznaka=s.idbranja
                          LEFT JOIN tsistem_nuzgoja nu ON nu.oznaka=s.iduzgoja
    
        ORDER BY m.broj, m.datumdpo
    INTO :DATUMDPO,
         :BROJ,
         :BALAID,
         :BROJ_SERIJE,
         :KOD,
         :KLASA,
         :GRUPA,
         :RACK,
         :IDBRANJA,
         :IDUZGOJA,
         :BRANJE,
         :UZGOJA,
         :SIFRA_ROBE,
         :IZLAZ_KOL,
         :IZLAZ_KOL_ALT,
         :AMBALAZA_KG,
         :BRUTOMASA
  DO
  BEGIN
    SUSPEND;
  END
END^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE TBALA_PRET (
    mg integer,
    barkod_b integer,
    grupa_b integer,
    brbarkoda varchar(20))
returns (
    balaid integer,
    grupa integer,
    bruto double precision,
    neto double precision,
    klasa integer,
    klasaid integer,
    podsortaid integer,
    sortaid integer,
    secen varchar(10),
    navodnjavan varchar(10),
    lokacija integer,
    int_klasa varchar(20),
    barkod varchar(20))
as
BEGIN
  FOR
    SELECT     b.balaid,
               m.barkod,
               m.grupa,
               b.brutomasa,
               b.netomasa,
               b.klasa,
               b.klasaid,
               b.podsortaid,
               b.sortaid,
               b.secen,
               b.navodnjavan,
               ik.oznaka
        FROM tbala_mg m left join tbala b on b.brbarkoda=m.barkod and b.obrisano=0
                        left join tsistemmagacin ik on ik.magacinid=b.klasaid
        WHERE  m.obrisano=0
                and ((m.grupa=:grupa_b) or (m.brbarkoda=:barkod_b) or (m.barkod=:brbarkoda))
                and m.sifra_mg=:mg
    INTO
         :BALAID,
         :BARKOD,
         :GRUPA,
         :BRUTO,
         :NETO,
         :klasa,
         :klasaid,
         :podsortaid,
         :sortaid,
         :secen,
         :navodnjavan,
         :int_klasa
  DO
  BEGIN
    select grade, neto
    from od_obrada_gp
    where int_barkod = :brbarkoda and deleted=0
    into :int_klasa, :NETO;

    SUSPEND;
  END
END^

SET TERM ; ^


/******************************************************************************/
/****              Generated by IBExpert 31.10.2011 15:21:11               ****/
/******************************************************************************/



/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE OD_OBRADA_TP (
    ID         INTEGER NOT NULL,
    BARKOD     VARCHAR(30),
    TEZINA     DOUBLE PRECISION,
    VREME      TIMESTAMP,
    OBRISANO   SMALLINT,
    TEZINA_VG  DOUBLE PRECISION,
    ID_DEALER  INTEGER,
    DEALER     VARCHAR(250)
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE OD_OBRADA_TP ADD CONSTRAINT PK_OD_OBRADA_TP PRIMARY KEY (ID);

CREATE SEQUENCE GEN_OD_OBRADA_TP_ID;
ALTER SEQUENCE GEN_OD_OBRADA_TP_ID RESTART WITH 0;


SET TERM ^ ;

CREATE OR ALTER PROCEDURE SP_GEN_OD_OBRADA_TP_ID 
returns (
    id integer)
as
begin
  id = gen_id(gen_od_obrada_tp_id, 1);
  suspend;
end^

SET TERM ; ^

ALTER TABLE TSISTEMMAGACIN ADD POINTS DOUBLE PRECISION;


SET TERM ^ ;

CREATE OR ALTER PROCEDURE TBALA_DNEVNI_OTKUP (
    sid integer,
    psid integer,
    pocdat date,
    krajdat date)
returns (
    pdv decimal(18,2),
    kooperantid integer,
    komitent varchar(255),
    cenaklase numeric(18,2),
    klasa varchar(25),
    sap_matnum varchar(20),
    brutomasa numeric(18,2),
    ambalaza decimal(18,2),
    prasina integer,
    prasinaodbitak numeric(18,4),
    vlaga numeric(18,2),
    vlagaodbitak numeric(18,4),
    netomasa numeric(18,2),
    sortaid integer,
    podsortaid integer,
    oznaka varchar(20),
    podsorta varchar(20),
    oznaka_vlage varchar(4),
    uobradiod date,
    naknadaprevoza decimal(18,2),
    poreklo varchar(30),
    mesto varchar(50),
    points double precision)
as
BEGIN
  FOR
    SELECT
               TBLPOREZ.STOPA1 as PDV,
               TBALA.KOOPERANTID,
               TBLKOMITENTI.komitent,
               TBALA.CENAKLASE,
               TSISTEMKLASACENA.KLASA,
               TSISTEMKLASACENA.sap_matnum,
               TBALA.BRUTOMASA,
               TBALA.AMBALAZA,
               TBALA.PRASINA,
               TBALA.PRASINAODBITAK,
               TBALA.VLAGA,
               TBALA.VLAGAODBITAK,
               TBALA.NETOMASA,
               TBALA.SORTAID,
               TBALA.PODSORTAID,
               TSISTEMMAGACIN.OZNAKA,
               ps.PODSORTA,
               TBALA.OZNAKA_VLAGE,
               TBALA.UOBRADIOD,
               TBALA.NAKNADAPREVOZA,
               p.opis,
               TBLMESTO.mesto,
               TSISTEMMAGACIN.points
    
        FROM (((TBALA INNER JOIN TSISTEMKLASACENA ON (TBALA.KLASA = TSISTEMKLASACENA.KLASACENAID) AND (TBALA.SORTAID = TSISTEMKLASACENA.SORTAID))
                      INNER JOIN TSISTEMPODSORTA ps ON (TBALA.SORTAID = ps.SORTAID) AND (TBALA.PODSORTAID = ps.PODSORTAID))
                      INNER JOIN TBLKOMITENTI ON TBALA.KOOPERANTID=TBLKOMITENTI.SIFRA_KOMITENTA
                      INNER JOIN TSISTEM_POREKLO p ON p.id=ps.porekloid
                      LEFT JOIN TSISTEMMAGACIN ON TBALA.klasaid = TSISTEMMAGACIN.MAGACINID)
                      LEFT JOIN TKURS ON TBALA.UOBRADIOD = TKURS.INSERT_DATE
                      LEFT JOIN TBLPOREZ ON TBLKOMITENTI.SIFRAPDVA = TBLPOREZ.SIFRA_POREZA
                      LEFT JOIN TBLMESTO ON TBLMESTO.sifra_mesta = tblkomitenti.sifra_mesta

        WHERE   TBALA.SORTAID=:SID
      --  AND      TBALA.PODSORTAID = :PSID
        AND      TBALA.UOBRADIOD BETWEEN :POCDAT AND :KRAJDAT
        AND      TBALA.obrisano<>1
        ORDER BY tsistemklasacena.klasa, tbala.uobradiod, tbala.brbarkoda
    INTO :PDV,
         :KOOPERANTID,
         :KOMITENT,
         :CENAKLASE,
         :KLASA,
         :SAP_MATNUM,
         :BRUTOMASA,
         :AMBALAZA,
         :PRASINA,
         :PRASINAODBITAK,
         :VLAGA,
         :VLAGAODBITAK,
         :NETOMASA,
         :SORTAID,
         :PODSORTAID,
         :OZNAKA,
         :PODSORTA,
         :OZNAKA_VLAGE,
         :UOBRADIOD,
         :NAKNADAPREVOZA,
         :POREKLO,
         :MESTO,
         :POINTS
  DO
  BEGIN
    SUSPEND;
  END
END^

SET TERM ; ^


SET TERM ^ ;

CREATE OR ALTER PROCEDURE TBALA_KUMULATIVNI_IZV (
    sorta integer,
    podsorta integer,
    od_datuma date,
    do_datuma date)
returns (
    period varchar(20),
    klasa varchar(25),
    broj_bala integer,
    cenaklase numeric(18,2),
    bruto numeric(18,2),
    neto numeric(18,2),
    netovrednost numeric(18,4),
    vlagaodbitak numeric(18,4),
    prasinaodbitak numeric(18,4),
    ambalaza decimal(18,2),
    naknadaprevoza decimal(18,2),
    ukupno decimal(18,2),
    ukupnobruto decimal(18,2))
as
BEGIN
  FOR
    SELECT 'Prethodno stanje' as period,
           d.klasa,
           COUNT(*) as broj_bala,
           d.cenaklase,
           SUM(d.brutomasa) as bruto,
           SUM(d.netomasa) as neto,
           SUM(d.netomasa*d.cenaklase) as netovrednost,
           SUM(d.vlagaodbitak) as vlagaodbitak,
           SUM(d.prasinaodbitak) as prasinaodbitak,
           SUM(d.ambalaza/1000.0000) as ambalaza,
           SUM(d.naknadaprevoza) as naknadaprevoza
     FROM TBALA_DNEVNI_OTKUP(:sorta, :podsorta, :od_datuma, :do_datuma-1) d
     GROUP BY d.klasa, d.cenaklase
    INTO :PERIOD,
         :KLASA,
         :BROJ_BALA,
         :CENAKLASE,
         :BRUTO,
         :NETO,
         :NETOVREDNOST,
         :VLAGAODBITAK,
         :PRASINAODBITAK,
         :AMBALAZA,
         :NAKNADAPREVOZA
  DO
  BEGIN
    SELECT SUM(d.netomasa), SUM(d.brutomasa)
    FROM TBALA_DNEVNI_OTKUP(:sorta, :podsorta, :od_datuma, :do_datuma-1) d
    INTO :UKUPNO, :UKUPNOBRUTO;

    SUSPEND;
  END

  FOR
    SELECT 'Danasnje stanje' as period,
           d.klasa,
           COUNT(*) as broj_bala,
           d.cenaklase,
           SUM(d.brutomasa) as bruto,
           SUM(d.netomasa) as neto,
           SUM(d.netomasa*d.cenaklase) as netovrednost,
           SUM(d.vlagaodbitak) as vlagaodbitak,
           SUM(d.prasinaodbitak) as prasinaodbitak,
           SUM(d.ambalaza/1000.0000) as ambalaza,
           SUM(d.naknadaprevoza) as naknadaprevoza
     FROM TBALA_DNEVNI_OTKUP(:sorta, :podsorta, :do_datuma, :do_datuma) d
     GROUP BY d.klasa, d.cenaklase
    INTO :PERIOD,
         :KLASA,
         :BROJ_BALA,
         :CENAKLASE,
         :BRUTO,
         :NETO,
         :NETOVREDNOST,
         :VLAGAODBITAK,
         :PRASINAODBITAK,
         :AMBALAZA,
         :NAKNADAPREVOZA
  DO
  BEGIN
    SELECT SUM(d.netomasa), SUM(d.brutomasa)
    FROM TBALA_DNEVNI_OTKUP(:sorta, :podsorta, :do_datuma, :do_datuma) d
    INTO :UKUPNO, :UKUPNOBRUTO;

    SUSPEND;
  END

  FOR
    SELECT 'Kumulativno stanje' as period,
           d.klasa,
           COUNT(*) as broj_bala,
           d.cenaklase,
           SUM(d.brutomasa) as bruto,
           SUM(d.netomasa) as neto,
           SUM(d.netomasa*d.cenaklase) as netovrednost,
           SUM(d.vlagaodbitak) as vlagaodbitak,
           SUM(d.prasinaodbitak) as prasinaodbitak,
           SUM(d.ambalaza/1000.0000) as ambalaza,
           SUM(d.naknadaprevoza) as naknadaprevoza
     FROM TBALA_DNEVNI_OTKUP(:sorta, :podsorta, :od_datuma, :do_datuma) d
     GROUP BY d.klasa, d.cenaklase
    INTO :PERIOD,
         :KLASA,
         :BROJ_BALA,
         :CENAKLASE,
         :BRUTO,
         :NETO,
         :NETOVREDNOST,
         :VLAGAODBITAK,
         :PRASINAODBITAK,
         :AMBALAZA,
         :NAKNADAPREVOZA
  DO
  BEGIN

    SELECT SUM(d.netomasa), SUM(d.brutomasa)
    FROM TBALA_DNEVNI_OTKUP(:sorta, :podsorta, :od_datuma, :do_datuma) d
    INTO :UKUPNO, :UKUPNOBRUTO;

    SUSPEND;
  END
END
^

SET TERM ; ^

ALTER TABLE CIPHERLAB_DATA
ADD PONAVLJANJE SMALLINT;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE PROMET_MAGACINA_WH (
    od_datuma date,
    do_datuma date,
    mg integer)
returns (
    tip_proizvoda varchar(30),
    sorta varchar(30),
    int_klasa varchar(30),
    ulaz decimal(18,4),
    izlaz decimal(18,4),
    stanje decimal(18,4),
    ulaz_alt decimal(18,4),
    izlaz_alt decimal(18,4),
    stanje_alt decimal(18,4))
as
BEGIN
  FOR
    SELECT 
           t.opis,
           s.kod,
           ss.imesorte,
           CAST(SUM(s.ULAZ_KOL) AS DECIMAL(18,4)) AS ULAZ,
           CAST(SUM(s.IZLAZ_KOL) AS DECIMAL(18,4)) AS IZLAZ,
           CAST(SUM(s.ULAZ_KOL-s.IZLAZ_KOL) AS DECIMAL(18,4)) AS STANJE,
    
           CAST(SUM(s.ULAZ_KOL_alt) AS DECIMAL(18,4)) AS ULAZ_ALT,
           CAST(SUM(s.IZLAZ_KOL_alt) AS DECIMAL(18,4)) AS IZLAZ_ALT,
           CAST(SUM(s.ULAZ_KOL_alt-s.IZLAZ_KOL_alt) AS DECIMAL(18,4)) AS STANJE_ALT
    
    FROM  mg_zg z INNER JOIN MG_STAV s ON (s.IDZG = z.ID and z.DATUMDPO between :OD_DATUMA AND :DO_DATUMA and z.sifra_magacina=:mg)
                  INNER JOIN tbala_mg mg ON mg.barkod=s.barkod and mg.obrisano=0
                  INNER JOIN tip_artikla t ON t.tip_artikla=mg.tip_proizvoda
                  LEFT JOIN  tbala b ON b.brbarkoda= mg.barkod and b.obrisano=0
                  LEFT JOIN  tsistemsorta ss ON ss.sortaid=b.sortaid
    GROUP BY
           t.opis,
           s.kod,
           ss.imesorte
    INTO
           :TIP_PROIZVODA,
           :INT_KLASA,
           :sorta, 
           :ULAZ,
           :IZLAZ,
           :stanje,
           :ulaz_alt,
           :izlaz_alt,
           :stanje_alt
  DO
  BEGIN
    SUSPEND;
  END
END^

SET TERM ; ^



SET TERM ^ ;

CREATE OR ALTER PROCEDURE OD_BALE_DUVANA (
    od_datuma date,
    do_datuma date,
    mg integer,
    doc_pri integer,
    doc_otp integer,
    doc_obr integer)
returns (
    datum_otk date,
    balaid integer,
    brbarkoda integer,
    vreme_otk timestamp,
    secen varchar(1),
    navodnjavan varchar(1),
    klasa varchar(25),
    int_klasa varchar(20),
    netomasa double precision,
    brutomasa double precision,
    sap_matnum varchar(20),
    branje varchar(200),
    uzgoja varchar(200),
    primese smallint,
    vlaga numeric(18,2),
    kooperantid integer,
    komitent varchar(255),
    podsorta varchar(20),
    sifra_mg integer,
    magacin varchar(50),
    sifra_lokacije integer,
    lokacija varchar(50),
    ambalaza_kg numeric(18,4),
    datum_otp date,
    broj_otp integer,
    datum_obr date,
    vreme_obr timestamp,
    batch_no varchar(20),
    blend varchar(20),
    grupa integer,
    rack integer,
    idgrupe integer,
    reklasirano varchar(10),
    datum_rekl date,
    masa_obr double precision,
    veza_id integer,
    sifra_mg_u integer,
    magacin_u varchar(50),
    barkod_string varchar(20),
    zavrseno smallint)
as
BEGIN
  FOR
    SELECT 
                tb.datum_prijema,
                tb.zavrseno,
                b.balaid,
                b.brbarkoda,
                CAST(b.brbarkoda AS VARCHAR(20)),
                tb.datum_prijema,
                b.secen,
                b.navodnjavan,
                c.klasa,
                c.sap_matnum,
                b.primese,
                b.vlaga,
                b.kooperantid,
                k.komitent,
                p.podsorta,
                m.oznaka as INT_KLASA,
                b.netomasa,
                b.brutomasa,
                tb.sifra_mg,
                mg1.magacin,
                tb.sifra_mg_u,
                mg2.magacin,
                tb.sifra_lokacije,
                l.lokacija,

                (b.ambalaza/1000.0000) as ambalaza_kg,
                tb.grupa,
                g.rack,
                NULL,
                tb.veza_id
        
            FROM      TBALA_MG tb INNER JOIN tbala b ON b.balaid=tb.balaid and b.obrisano=0 and tb.obrisano=0 AND tb.tip_proizvoda=4
                                 INNER JOIN tsistemklasacena c ON c.klasacenaid=b.klasa
                                 INNER JOIN tsistemmagacin  m ON (m.magacinid=b.klasaid)
                                 INNER JOIN tsistempodsorta p ON (p.podsortaid=b.podsortaid)
                                 INNER JOIN TBLKOMITENTI    k ON (k.sifra_komitenta=b.kooperantid)
                                 LEFT JOIN tsistem_nbranja nb ON (nb.oznaka=b.secen)
                                 LEFT JOIN tsistem_nuzgoja nu ON (nu.oznaka=b.navodnjavan)
                                 LEFT JOIN tbala_grupa      g ON (g.id_bale = b.balaid and g.deleted=0)
                                 LEFT JOIN tblmagacin      mg1 ON (mg1.sifra_magacina=tb.sifra_mg)
                                 LEFT JOIN tbllokacije      l ON (l.sifra_lokacije = tb.sifra_lokacije)
                                 LEFT JOIN tblmagacin      mg2 ON (mg2.sifra_magacina=tb.sifra_mg_u)

            where cast(tb.datum_prijema as date) between :od_datuma and :do_datuma and b.obrisano=0
            ORDER BY b.brbarkoda
    INTO :DATUM_OTK,
         :ZAVRSENO,
         :BALAID,
         :BRBARKODA,
         :barkod_string,
         :VREME_OTK,
         :SECEN,
         :NAVODNJAVAN,
         :KLASA,
         :SAP_MATNUM,
         :PRIMESE,
         :VLAGA,
         :KOOPERANTID,
         :KOMITENT,
         :PODSORTA,
         :INT_KLASA,
         :NETOMASA,
         :BRUTOMASA,
         :SIFRA_MG,
         :MAGACIN,
         :SIFRA_MG_U,
         :MAGACIN_U,
         :SIFRA_LOKACIJE,
         :LOKACIJA,
         :AMBALAZA_KG,
         :GRUPA,
         :RACK,
         :DATUM_REKL,
         :veza_id
  DO
  BEGIN
    datum_otp=NULL; broj_otp=NULL;
    datum_obr=NULL; vreme_obr=NULL;
    batch_no=''; blend='';
    reklasirano='';

    SELECT MAX(z.datumdpo), MAX(z.broj)
    from mg_zg z inner join mg_stav s on z.id=s.idzg
    where z.sifra_dokumenta=1100 and s.barkod=:barkod_string
    into :datum_otp, :broj_otp;

    select MAX(b.vreme), m.oznaka
    from tbala_reklas b INNER JOIN tsistemmagacin m on m.magacinid=b.klasaid_old
    where b.barkod=:BRBARKODA
    GROUP BY m.oznaka
    into :datum_rekl, :reklasirano;


    SELECT z.datumdpo, s.vreme, z.broj_batcha, b.opis
    from mg_zg z inner join mg_stav s on s.idzg=z.id
                 inner join od_blend b on b.id=z.idblend
    where z.sifra_dokumenta=:doc_obr and s.barkod=:barkod_string
    into :datum_obr, :vreme_obr, :batch_no, :blend;

    SUSPEND;
  END
END^

SET TERM ; ^




/****************************************************************************************************/
/*                Dodaj ovo Darko                                                                   */ 
/****************************************************************************************************/
SET TERM ^ ;

CREATE OR ALTER PROCEDURE OD_LAB_IZV_DEGRAD (
    od_datuma date,
    do_datuma date,
    id_transakcije integer)
returns (
    id integer,
    datum date,
    idgrade varchar(10),
    idsmene varchar(10),
    idlist varchar(10),
    runday integer,
    idblend integer,
    batch_no varchar(10),
    case_no integer,
    idlaboranta integer,
    sifra_radnika integer,
    vreme time,
    izmena timestamp,
    vrsta_transakcije integer,
    id_uzorka varchar(10),
    vlaga double precision,
    temperatura double precision,
    kolicina double precision,
    status char(1),
    unos timestamp,
    veza integer,
    sugar double precision,
    nicotin double precision,
    grade varchar(30),
    smena varchar(30),
    list varchar(30),
    laborant varchar(30),
    mesto_uzorka varchar(50),
    idtip integer,
    transakcija varchar(50),
    id_lab integer,
    idprocesa integer,
    parametar1 varchar(10),
    parametar2 varchar(10),
    parametar3 varchar(10),
    kolicina_ov1 double precision,
    kolicina_ov12 double precision,
    kolicina_ov14 double precision,
    kolicina_ov18 double precision,
    kolicina_pan double precision,
    over1 double precision,
    over12 double precision,
    totalover1_12 double precision,
    over14 double precision,
    totalover1_14 double precision,
    over18 double precision,
    onpan double precision,
    totalover18_pan double precision,
    ukupnakolicina double precision,
    opis varchar(250))
as
BEGIN
  FOR
    select p.*,
           t.opis as transakcija
    from OD_PROCESSING p  INNER JOIN od_transakcije t ON t.id=p.vrsta_transakcije  
                                                                  and p.datum between :od_datuma and :do_datuma
                                                                  and p.vrsta_transakcije=:id_transakcije    
                                                                  and p.status<>'D'
    order by p.datum, p.vreme
    INTO :ID,
         :DATUM,
         :IDGRADE,
         :IDSMENE,
         :IDLIST,
         :RUNDAY,
         :IDBLEND,
         :BATCH_NO,
         :CASE_NO,
         :IDLABORANTA,
         :SIFRA_RADNIKA,
         :VREME,
         :IZMENA,
         :VRSTA_TRANSAKCIJE,
         :ID_UZORKA,
         :VLAGA,
         :TEMPERATURA,
         :KOLICINA,
         :STATUS,
         :UNOS,
         :VEZA,
         :SUGAR,
         :NICOTIN,
         :GRADE,
         :SMENA,
         :LIST,
         :LABORANT,
         :MESTO_UZORKA,
         :IDTIP,
         :OPIS,
         :TRANSAKCIJA
  DO
  BEGIN

    select kolicina
    from od_lab_merenja m
    where idprocesa=:id
    and parametar1='OVER1'
    into :kolicina_ov1;

    select kolicina
    from od_lab_merenja m
    where idprocesa=:id
    and parametar1='OVER1/2'
    into :kolicina_ov12;

    select kolicina
    from od_lab_merenja m
    where idprocesa=:id
    and parametar1='OVER1/4'
    into :kolicina_ov14;

    select kolicina
    from od_lab_merenja m
    where idprocesa=:id
    and parametar1='OVER1/8'
    into :kolicina_ov18;

    select kolicina
    from od_lab_merenja m
    where idprocesa=:id
    and parametar1='ONPAN'
    into :kolicina_pan;

    UkupnaKolicina = kolicina_ov1+kolicina_ov12+kolicina_ov14+kolicina_ov18+kolicina_pan;

    if(UkupnaKolicina <> 0) then
      begin
        Over1         = 100.0000*(KOLICINA_OV1 /UkupnaKolicina);
        Over12        = 100.0000*(KOLICINA_OV12/UkupnaKolicina);
        TotalOver1_12 = 100.0000*((KOLICINA_OV1+KOLICINA_OV12)/UkupnaKolicina);
        Over14        = 100.0000*(kolicina_ov14/UkupnaKolicina);
        TotalOver1_14 = 100.0000*((KOLICINA_OV1+KOLICINA_OV12+kolicina_ov14)/UkupnaKolicina);
        Over18        = 100.0000*(KOLICINA_OV18/UkupnaKolicina);
        OnPan         = 100.0000*(kolicina_pan/UkupnaKolicina);
        TotalOver18_pan=100.0000*((kolicina_pan+KOLICINA_OV18)/UkupnaKolicina);
      end

    SUSPEND;
  END
END^

SET TERM ; ^



SET TERM ^ ;

CREATE OR ALTER PROCEDURE OD_LAB_IZVESTAJ (
    od_datuma date,
    do_datuma date,
    id_transakcije integer)
returns (
    id integer,
    datum date,
    idgrade varchar(10),
    idsmene varchar(10),
    idlist varchar(10),
    runday integer,
    idblend integer,
    batch_no varchar(10),
    case_no integer,
    idlaboranta integer,
    sifra_radnika integer,
    vreme time,
    izmena timestamp,
    vrsta_transakcije integer,
    id_uzorka varchar(10),
    vlaga double precision,
    temperatura double precision,
    kolicina double precision,
    status char(1),
    unos timestamp,
    veza integer,
    sugar double precision,
    nicotin double precision,
    grade varchar(30),
    smena varchar(30),
    list varchar(30),
    laborant varchar(30),
    mesto_uzorka varchar(50),
    idtip integer,
    transakcija varchar(50),
    id_lab integer,
    idprocesa integer,
    parametar1 varchar(10),
    parametar2 varchar(10),
    parametar3 varchar(10),
    kolicina_obj double precision,
    vrednost_obj double precision,
    procenat_obj double precision,
    kolicina_7sl double precision,
    vrednost_7sl double precision,
    procenat_7sl double precision,
    kolicina_12sl double precision,
    vrednost_12sl double precision,
    procenat_12sl double precision,
    kolicina_12mesh double precision,
    vrednost_12mesh double precision,
    procenat_12mesh double precision,
    kolicina_pan double precision,
    vrednost_pan double precision,
    procenat_pan double precision)
as
BEGIN
  FOR
    select p.*,
           t.opis as transakcija
    from OD_PROCESSING p  INNER JOIN od_transakcije t ON t.id=p.vrsta_transakcije  
                                                                  and p.datum between :od_datuma and :do_datuma
                                                                  and p.vrsta_transakcije=:id_transakcije    
                                                                  and p.status<>'D'
    order by p.datum, p.vreme
    INTO :ID,
         :DATUM,
         :IDGRADE,
         :IDSMENE,
         :IDLIST,
         :RUNDAY,
         :IDBLEND,
         :BATCH_NO,
         :CASE_NO,
         :IDLABORANTA,
         :SIFRA_RADNIKA,
         :VREME,
         :IZMENA,
         :VRSTA_TRANSAKCIJE,
         :ID_UZORKA,
         :VLAGA,
         :TEMPERATURA,
         :KOLICINA,
         :STATUS,
         :UNOS,
         :VEZA,
         :SUGAR,
         :NICOTIN,
         :GRADE,
         :SMENA,
         :LIST,
         :LABORANT,
         :MESTO_UZORKA,
         :IDTIP,
         :TRANSAKCIJA
  DO
  BEGIN

    select kolicina, procenat
    from od_lab_merenja m
    where idprocesa=:id
    and parametar1='OBJS3/32'
    into :kolicina_obj, :procenat_obj;

    select kolicina, procenat
    from od_lab_merenja m
    where idprocesa=:id
    and parametar1='#7SLOTTED'
    into :kolicina_7sl, :procenat_7sl;

    select kolicina, procenat
    from od_lab_merenja m
    where idprocesa=:id
    and parametar1='#12SLOTTED'
    into :kolicina_12sl, :procenat_12sl;

    select kolicina, procenat
    from od_lab_merenja m
    where idprocesa=:id
    and parametar1='#12MESH'
    into :kolicina_12mesh, :procenat_12mesh;

    select kolicina, procenat
    from od_lab_merenja m
    where idprocesa=:id
    and parametar1='FIBONPAN'
    into :kolicina_pan, :procenat_pan;

        SUSPEND;

  END
END^

SET TERM ; ^

